//-----------------------------------------------------
//导入
//________________________________________________________________
import { world, system } from '@minecraft/server';
import { ActionFormData, ModalFormData } from '@minecraft/server-ui';
import { score, set } from 'score.js';
import { fightSkill, isPlayerBehindEntity } from 'enhancement/dna.js'
import { sounds } from './sounds.js'
import { anbssLore, anbssDamageA } from 'stands/items/anbss.js'

//-----------------------------------------------------
//变量
//________________________________________________________________

export let combo = { "playerName": 0 };
let comboTime = { "playerName": 0 };
const damage_sounds = [
"stand:artist",
"stand:et",
"stand:jojo3",
"stand:stand_players",
"stand:footprints",
"stand:bcp",
"stand:tank",
"stand:ah64a",
"stand:jj",
"stand:ec",
"stand:dz",
"stand:zombie_half",
"stand:zombie_hand",
"stand:zombie_head",
"stand:zombie_shooter",
"stand:dio1",
"stand:dio3",
"stand:dio3h"
]

//-----------------------------------------------------
//事件
//________________________________________________________________

world.afterEvents.entityHurt.subscribe(event => {
    let try_miss = false;
    let miss_tf = false;
       
    try {
        const player2 = event.hurtEntity;
        const damage2 = event.damage
        const fs2 = new fightSkill(player2);
        
        if (player2.typeId == "minecraft:player" && !try_miss && !miss_tf && miss(player2, fs2)) {
             player2.getComponent("minecraft:health").setCurrentValue(player2.getComponent("minecraft:health").currentValue+damage2)
        }
                
    } catch (error) {
        // world.sendMessage(`${error}`)
    }
    
    try {
        const entity = event.hurtEntity;
        const player = event.damageSource.damagingEntity ? event.damageSource.damagingEntity : "return";
        const cause = event.damageSource.cause;
        const damage = parseInt(event.damage)
        const fs = new fightSkill(player);
        let rDamage = 0;
        let a = 0;
                
         if (entity.typeId == "minecraft:player") {
            const fs3 = new fightSkill(entity);
            if (miss(entity, fs3)) {
                entity.getComponent("minecraft:health").setCurrentValue(entity.getComponent("minecraft:health").currentValue+damage)
                rDamage = 0;
                miss_tf = true;
            }
            try_miss = true;
        }
        if (player.typeId != "minecraft:player" || cause == "magic" || player.hasTag("be_stopped_of_time") || event.damageSource.damagingEntity == "return")return;
        
        if (entity.getComponent("health").currentValue == 0) {
            try {
                anbssLore(player, entity)
            } catch(error) {}
        }
        
        //斩首
        if ((entity.getComponent("minecraft:health").currentValue / entity.getComponent("minecraft:health").effectiveMax) < 0.15 && (entity.getComponent("minecraft:health").currentValue / entity.getComponent("minecraft:health").effectiveMax) > 0 && fs.getFightSkill()["fs"].indexOf("斩首") != -1) {
            rDamage = 114514
            entity.runCommand("particle stand:kill ~~1.5~")
            entity.runCommand("playsound random.break @a ~~~ 100 1 0")
            player.runCommand("camerashake add @a[r=5] 0.35 0.1")
        }
        
        //攻击加成
        if (cause == "entityAttack" || cause == "projectile") {
            rDamage = parseInt( rDamage + damage * ( 1 + score(player, "strong")/20 ) )
            rDamage = rDamage + parseInt( 1.5 * ( 1 + anbssDamageA(player)) )
        }
        
        //连击
        if (!entity.getComponent("minecraft:type_family")?.hasTypeFamily("bc") && entity.typeId != "stand:sheer_heart_attack" && entity.typeId != "stand:footprints") {
            if (!combo[player.name]) {
                combo[player.name] = 0
            }
            
            try {
                if (entity.getEffect("slowness").amplifier >= 0 && fs.getFightSkill()["fs"].indexOf("破冰") != -1) {
                    a = a + 0.5
                    entity.runCommand("playsound random.glass @a ~~~ 20 1 0")
                }
            } catch(e) {
                // world.sendMessage(`${e}`)
            }
            
            if (combo[player.name] == 0 && fs.getFightSkill()["fs"].indexOf("突刺") != -1) {
                a = a + 1
                entity.runCommand("particle minecraft:critical_hit_emitter ~~1.5~")
                entity.runCommand("playsound random.anvil_land @a ~~~ 100 1 0")
                player.runCommand("camerashake add @s 0.2 0.1")
            }
            
            if (fs.getFightSkill()["fs"].indexOf("背击") != -1 && isPlayerBehindEntity(player, entity)) {
                a = a + 0.5
                entity.runCommand("particle minecraft:end_chest ~~1.5~")
                entity.runCommand("particle minecraft:end_chest ~~1.5~")
                entity.runCommand("particle minecraft:end_chest ~~1.5~")
                entity.runCommand("particle minecraft:end_chest ~~1.5~")
                entity.runCommand("playsound mob.endermen.hit @a ~~~ 100 1.2 0")
                player.runCommand("camerashake add @s 0.2 0.1")
            }
            
            rDamage = rDamage + (parseInt(rDamage * (combo[player.name]/10)) == 0 ? 1 : parseInt(rDamage * (combo[player.name]/10)))
            rDamage = parseInt( rDamage * ( a + 1))
           
            combo[player.name] += 1
            player.runCommand(`scoreboard players set @s pl.co ${combo[player.name]}`)
            comboTime[player.name] = 2
            system.runTimeout(() => {
                if (comboTime[player.name] == 0) {
                    combo[player.name] = 0
                    player.runCommand("scoreboard players set @s pl.co 0")
                }
            }, 40)
        }
        
        //最后结算
        if (entity.typeId == "stand:sheer_heart_attack" || entity.getComponent("minecraft:type_family")?.hasTypeFamily("bc") && entity.nameTag.replace("§a", "").replace("的军队", "") == player.name && player.isSneaking) {
            rDamage = 0
        }
        if (rDamage > 0 && entity.getComponent("minecraft:health").currentValue != 0) {
            if (entity.hasTag("be_stopped_of_time")) {
                 entity.runCommand(`scoreboard players add @s ts_damage ${parseInt(rDamage)}`)
            } else {
                 system.runTimeout(() => {
                    if (entity.getComponent("minecraft:health").currentValue-rDamage <= 0) {
                        anbssLore(player, entity)
                        entity.addTag(`death_by:${player.id}`)
                        if (entity.typeId == "minecraft:player") {
                            system.runTimeout(() => {
                                entity.removeTag(`death_by:${player.id}`)
                            }, 2)
                        }
                    }
                    const newHealth = entity.getComponent("minecraft:health").currentValue-rDamage > 0 ? (entity.getComponent("minecraft:health").currentValue-rDamage) : 0
                    entity.getComponent("minecraft:health").setCurrentValue(newHealth)
                 }, 1)
            }           
            // // const oldHealth = entity.getComponent("minecraft:health").currentValue + damage
            // // system.runTimeout(() => {
                // // const health = entity.getComponent("minecraft:health").currentValue
                // // if (health != 0) {
                    // // player.sendMessage(`${oldHealth} - ${damage} - ${rDamage} = ${health}`)
                // // }
            // // }, 10)
            
            // let sound;
            // if (damage_sounds.indexOf(entity.typeId) != -1) {
                // entity.runCommand("stopsound @a[r=20] game.player.hurt")
            // } else {
                // sound = sounds["entities"][entity.typeId.replace("minecraft:", "")]["events"]["hurt"];
                // entity.runCommand(`stopsound @a[r=20] ${sound}`)
            // }
            // system.runTimeout(() => {
                // if (damage_sounds.indexOf(entity.typeId) != -1) {
                    // // entity.runCommand("playsound game.player.hurt @a ~~~ 100 1 0")
                // } else {
                    // entity.runCommand(`playsound ${sound} @a ~~~ 100 1 0`)
                // }
            // }, 0.0001)
        }
    } catch (error) {
         // world.sendMessage(`§b${error}`)
    }
    
})

system.runInterval(() => {
    for (const player of world.getPlayers()) {
        if (comboTime[player.name] == undefined) {
            comboTime[player.name] = 0
        }
        if (comboTime[player.name] > 0) {
            comboTime[player.name] -= 1
        }
        player.runCommand("scoreboard players add @s[scores={stand_energy=..99}] stand_energy 1")
    }
}, 20)

system.runInterval(() => {
    for (const player of world.getPlayers()) {
        if (system.currentTick % ( 20 - score(player, "life_level") ) === 0 && score(player, "stand_type_id") != 6) {
            const fs = new fightSkill(player);
            if (fs.getFightSkill()["fs"].indexOf("恢复") != -1) {
                player.runCommand("scoreboard players add @s[scores={stand_energy=..99}] stand_energy 1")
            }
            if (player.isSleeping) {
                 player.runCommand("scoreboard players add @s[scores={stand_energy=..99}] stand_energy 1")
                 player.runCommand("scoreboard players add @s[scores={stand_energy=..99}] stand_energy 1")
                 player.runCommand("scoreboard players add @s[scores={stand_energy=..99}] stand_energy 1")
            }
            if (player.isEmoting) {
                 player.runCommand("scoreboard players add @s[scores={stand_energy=..99}] stand_energy 1")
            }
        }
    }
})

//-----------------------------------------------------
//函数
//________________________________________________________________

//取随机整数
function randomNum(minNum, maxNum) {
    switch (arguments.length) {
        case 1:
            return parseInt(Math.random() * minNum + 1, 10);
            break;
        case 2:
            return parseInt(Math.random() * (maxNum - minNum + 1) + minNum, 10);
            break;
        default:
            return 0;
            break;
    }
};

function miss(player, fs) {
    let result;
    result = false;
    if (fs.getFightSkill()["fs"].indexOf("闪避") != -1) {
         let p = randomNum(1, 10)
         if (p == 1 && player.getComponent("minecraft:health").currentValue != 0) {
            player.addTag("miss")
            result = true;
            system.runTimeout(() => {
                player.removeTag("miss")
            }, 20)
            player.runCommand("playsound block.false_permissions @a ~~~ 100 1 0 ")
            player.runCommand("particle minecraft:elephant_tooth_paste_vapor_particle ~~0.5~")
        }
    }
    return result;
}