export let sounds = {
    "entities": {
        "allay": {
            "events": {
                "ambient": "mob.allay.idle",
                "ambient.tame": "mob.allay.idle_holding",
                "death": "mob.allay.death",
                "hurt": "mob.allay.hurt"
            },
            "pitch": [0.80, 1.20],
            "volume": 1
        },
        "armadillo": {
            "events": {
                "ambient": "mob.armadillo.ambient",
                "death": "mob.armadillo.death",
                "eat": "mob.armadillo.eat",
                "hurt": "mob.armadillo.hurt",
                "hurt.reduced": "mob.armadillo.hurt_reduced",
                "step": "mob.armadillo.step"
            },
            "pitch": [0.80, 1.20],
            "volume": 1.0
        },
        "axolotl": {
            "events": {
                "ambient": "mob.axolotl.idle",
                "ambient.in.water": "mob.axolotl.idle_water",
                "attack": "mob.axolotl.attack",
                "death": "mob.axolotl.death",
                "eat": "",
                "hurt": "mob.axolotl.hurt",
                "splash": "mob.axolotl.splash",
                "swim": "mob.axolotl.swim"
            },
            "pitch": [0.80, 1.20],
            "volume": 1.0
        },
        "bat": {
            "events": {
                "ambient": "mob.bat.idle",
                "death": "mob.bat.death",
                "hurt": "mob.bat.hurt",
                "takeoff": {
                    "pitch": [0.80, 1.20],
                    "sound": "mob.bat.takeoff",
                    "volume": 0.050
                }
            },
            "pitch": [0.760, 1.140],
            "volume": 0.10
        },
        "bee": {
            "events": {
                "ambient.pollinate": {
                    "sound": "mob.bee.pollinate",
                    "volume": 0.850
                },
                "attack": {
                    "pitch": [0.80, 1.0],
                    "sound": "mob.bee.sting"
                },
                "death": {
                    "pitch": [0.90, 1.10],
                    "sound": "mob.bee.death",
                    "volume": 0.60
                },
                "eat": "",
                "hurt": {
                    "pitch": [0.90, 1.10],
                    "sound": "mob.bee.hurt",
                    "volume": 0.60
                }
            },
            "pitch": 1.0,
            "volume": 0.60
        },
        "blaze": {
            "events": {
                "ambient": "mob.blaze.breathe",
                "death": "mob.blaze.death",
                "hurt": "mob.blaze.hit",
                "shoot": "mob.blaze.shoot"
            },
            "pitch": [0.80, 1.20],
            "volume": 1.0
        },
        "bogged": {
            "events": {
                "ambient": "mob.bogged.ambient",
                "death": "mob.bogged.death",
                "hurt": "mob.bogged.hurt",
                "step": {
                    "pitch": 1.0,
                    "sound": "mob.bogged.step",
                    "volume": 1.0
                }
            },
            "pitch": [0.80, 1.20],
            "volume": 1.0
        },
        "breeze": {
            "events": {
                "ambient": {
                    "pitch": [0.70, 1.10],
                    "sound": "mob.breeze.idle_ground",
                    "volume": [0.80, 1.0]
                },
                "ambient.in.air": {
                    "pitch": 1.0,
                    "sound": "mob.breeze.idle_air",
                    "volume": 1.0
                },
                "charge": {
                    "pitch": 1.0,
                    "sound": "mob.breeze.charge",
                    "volume": 1.0
                },
                "death": {
                    "pitch": 1.0,
                    "sound": "mob.breeze.death",
                    "volume": 1.0
                },
                "hurt": {
                    "pitch": 1.0,
                    "sound": "mob.breeze.hurt",
                    "volume": 1.0
                },
                "jump": {
                    "pitch": 1.0,
                    "sound": "mob.breeze.jump",
                    "volume": 1.0
                },
                "land": {
                    "pitch": 1.0,
                    "sound": "mob.breeze.land",
                    "volume": 1.0
                },
                "reflect": {
                    "pitch": 1.0,
                    "sound": "mob.breeze.deflect",
                    "volume": 1.0
                },
                "shoot": {
                    "pitch": [1.0, 1.20],
                    "sound": "mob.breeze.shoot",
                    "volume": 1.50
                },
                "step": {
                    "volume": 0.0
                }
            },
            "pitch": [0.80, 1.20],
            "volume": 1.0
        },
        "camel": {
            "events": {
                "ambient": "mob.camel.ambient",
                "death": "mob.camel.death",
                "eat": "mob.camel.eat",
                "hurt": "mob.camel.hurt",
                "saddle": "mob.horse.leather",
                "step": "mob.camel.step",
                "step_sand": "mob.camel.step_sand"
            },
            "pitch": [0.80, 1.20],
            "volume": 1
        },
        "cat": {
            "events": {
                "ambient": "mob.cat.straymeow",
                "ambient.tame": "mob.cat.meow",
                "death": {
                    "pitch": 0.90,
                    "sound": "mob.cat.hit",
                    "volume": 0.50
                },
                "eat": "mob.cat.eat",
                "hurt": {
                    "sound": "mob.cat.hit",
                    "volume": 0.450
                },
                "purr": "mob.cat.purr",
                "purreow": "mob.cat.purreow",
                "tempt": {
                    "pitch": 1.0,
                    "sound": "mob.cat.beg_for_food",
                    "volume": 0.70
                }
            },
            "pitch": [0.80, 1.20],
            "volume": 1.0
        },
        "cave_spider": {
            "events": {
                "ambient": "mob.spider.say",
                "death": "mob.spider.death",
                "hurt": "mob.spider.say",
                "step": {
                    "pitch": [0.90, 1.10],
                    "sound": "mob.spider.step",
                    "volume": 0.350
                }
            },
            "pitch": [0.80, 1.20],
            "volume": 1.0
        },
        "chicken": {
            "events": {
                "ambient": "mob.chicken.say",
                "death": "mob.chicken.hurt",
                "eat": "",
                "hurt": "mob.chicken.hurt",
                "plop": "mob.chicken.plop",
                "step": {
                    "pitch": 1.0,
                    "sound": "mob.chicken.step",
                    "volume": 0.250
                }
            },
            "pitch": [0.80, 1.20],
            "volume": 1.0
        },
        "cod": {
            "events": {
                "flop": {
                    "pitch": 1.0,
                    "sound": "mob.fish.flop",
                    "volume": 1.0
                },
                "hurt": "mob.fish.hurt",
                "hurt.in.water": "mob.fish.hurt",
                "step": {
                    "pitch": 1.0,
                    "sound": "mob.fish.step",
                    "volume": 0.150
                }
            },
            "pitch": [0.80, 1.20],
            "volume": 1.0
        },
        "cow": {
            "events": {
                "ambient": "mob.cow.say",
                "death": "mob.cow.hurt",
                "eat": "",
                "hurt": "mob.cow.hurt",
                "step": {
                    "pitch": [0.90, 1.10],
                    "sound": "mob.cow.step",
                    "volume": 0.650
                }
            },
            "pitch": [0.80, 1.20],
            "volume": 1.0
        },
        "creeper": {
            "events": {
                "death": "mob.creeper.death",
                "fuse": {
                    "pitch": 0.50,
                    "sound": "random.fuse",
                    "volume": 1.0
                },
                "hurt": "mob.creeper.say"
            },
            "pitch": [0.80, 1.20],
            "volume": 1.0
        },
        "dolphin": {
            "events": {
                "ambient": "mob.dolphin.idle",
                "ambient.in.water": "mob.dolphin.idle_water",
                "attack": "mob.dolphin.attack",
                "breathe": "mob.dolphin.blowhole",
                "death": "mob.dolphin.death",
                "death.in.water": "mob.dolphin.death",
                "eat": {
                    "pitch": 1.0,
                    "sound": "mob.dolphin.eat",
                    "volume": 0.70
                },
                "hurt": "mob.dolphin.hurt",
                "hurt.in.water": "mob.dolphin.hurt",
                "jump": {
                    "pitch": 1.0,
                    "sound": "mob.dolphin.jump",
                    "volume": 0.70
                },
                "splash": "mob.dolphin.splash",
                "swim": "mob.dolphin.swim"
            },
            "pitch": [0.80, 1.20],
            "volume": 1.0
        },
        "donkey": {
            "events": {
                "add.chest": {
                    "pitch": [0.80, 1.20],
                    "sound": "mob.horse.armor",
                    "volume": 1.0
                },
                "ambient": "mob.horse.donkey.idle",
                "armor": {
                    "pitch": 1.0,
                    "sound": "mob.horse.armor",
                    "volume": 0.60
                },
                "breathe": {
                    "pitch": 1.0,
                    "sound": "mob.horse.breathe",
                    "volume": 0.70
                },
                "death": "mob.horse.donkey.death",
                "eat": {
                    "pitch": [0.80, 1.20],
                    "sound": "mob.horse.eat",
                    "volume": [0.50, 1.50]
                },
                "hurt": "mob.horse.donkey.hit",
                "jump": {
                    "pitch": 1.0,
                    "sound": "mob.horse.jump",
                    "volume": 0.40
                },
                "land": {
                    "pitch": 1.0,
                    "sound": "mob.horse.land",
                    "volume": 0.40
                },
                "mad": "mob.horse.donkey.angry",
                "saddle": {
                    "pitch": 1.0,
                    "sound": "mob.horse.leather",
                    "volume": 0.50
                }
            },
            "pitch": [0.80, 1.20],
            "volume": 0.80
        },
        "drowned": {
            "events": {
                "ambient": "mob.drowned.say",
                "ambient.in.water": "mob.drowned.say_water",
                "death": "mob.drowned.death",
                "death.in.water": "mob.drowned.death_water",
                "hurt": "mob.drowned.hurt",
                "hurt.in.water": "mob.drowned.hurt_water",
                "step": "mob.drowned.step"
            },
            "pitch": [0.80, 1.20],
            "volume": 1.0
        },
        "elder_guardian": {
            "events": {
                "ambient": "mob.guardian.land_idle",
                "ambient.in.water": "mob.elderguardian.idle",
                "death": "mob.elderguardian.death",
                "death.in.water": "mob.elderguardian.death",
                "flop": "mob.guardian.flop",
                "guardian.flop": {
                    "pitch": 1.0,
                    "sound": "mob.guardian.flop",
                    "volume": 1.0
                },
                "hurt": "mob.guardian.land_hit",
                "hurt.in.water": "mob.elderguardian.hit"
            },
            "pitch": [0.80, 1.20],
            "volume": 1.0
        },
        "ender_dragon": {
            "events": {
                "death": "mob.enderdragon.death",
                "flap": "mob.enderdragon.flap",
                "hurt": "mob.enderdragon.hit",
                "mad": "mob.enderdragon.growl"
            },
            "pitch": [0.80, 1.20],
            "volume": 80.0
        },
        "enderman": {
            "events": {
                "ambient": "mob.endermen.idle",
                "death": "mob.endermen.death",
                "hurt": "mob.endermen.hit",
                "mad": "mob.endermen.scream",
                "stare": {
                    "pitch": 1.0,
                    "sound": "mob.endermen.stare",
                    "volume": 1.0
                }
            },
            "pitch": [0.80, 1.20],
            "volume": 1.0
        },
        "endermite": {
            "events": {
                "ambient": "mob.endermite.say",
                "death": "mob.endermite.kill",
                "hurt": "mob.endermite.hit",
                "step": {
                    "pitch": 1.0,
                    "sound": "mob.endermite.step",
                    "volume": 0.150
                }
            },
            "pitch": [0.80, 1.20],
            "volume": 1.0
        },
        "evocation_fang": {
            "events": {
                "fang": "mob.evocation_fangs.attack"
            },
            "pitch": [0.80, 1.20],
            "volume": 0.80
        },
        "evocation_illager": {
            "events": {
                "ambient": "mob.evocation_illager.ambient",
                "ambient.in.raid": {
                    "pitch": [0.80, 1.20],
                    "sound": "mob.evocation_illager.ambient",
                    "volume": 3.0
                },
                "cast.spell": "mob.evocation_illager.cast_spell",
                "celebrate": "mob.evocation_illager.celebrate",
                "death": "mob.evocation_illager.death",
                "hurt": "mob.evocation_illager.hurt",
                "prepare.attack": "mob.evocation_illager.prepare_attack",
                "prepare.summon": "mob.evocation_illager.prepare_summon",
                "prepare.wololo": "mob.evocation_illager.prepare_wololo"
            },
            "pitch": [0.80, 1.20],
            "volume": 1.0
        },
        "fox": {
            "events": {
                "ambient": "mob.fox.ambient",
                "attack": "mob.fox.bite",
                "death": "mob.fox.death",
                "eat": "mob.fox.eat",
                "hurt": "mob.fox.hurt",
                "mad": "mob.fox.aggro",
                "screech": {
                    "sound": "mob.fox.screech",
                    "volume": 2
                },
                "sleep": "mob.fox.sleep",
                "sniff": "mob.fox.sniff",
                "spit": "mob.fox.spit"
            },
            "pitch": [0.80, 1.20],
            "volume": 1.0
        },
        "frog": {
            "events": {
                "ambient": "mob.frog.ambient",
                "ambient.baby": {
                    "pitch": 1.20,
                    "sound": "mob.frog.ambient",
                    "volume": 2.50
                },
                "death": "mob.frog.death",
                "eat": "mob.frog.eat",
                "hurt": "mob.frog.hurt",
                "jump_to_block": "mob.frog.jump_to_block",
                "step": "mob.frog.step"
            },
            "pitch": [0.80, 1.20],
            "volume": 1
        },
        "ghast": {
            "events": {
                "ambient": "mob.ghast.moan",
                "death": "mob.ghast.death",
                "hurt": "mob.ghast.scream",
                "scream": "mob.ghast.affectionate_scream",
                "shoot": {
                    "sound": "mob.ghast.fireball",
                    "volume": 0.70
                },
                "warn": "mob.ghast.charge"
            },
            "pitch": [0.80, 1.20],
            "volume": 5.0
        },
        "glow_squid": {
            "events": {
                "ambient": "mob.glow_squid.ambient",
                "death": "mob.glow_squid.death",
                "hurt": "mob.glow_squid.hurt"
            },
            "pitch": [0.80, 1.20],
            "volume": 0.40
        },
        "goat": {
            "events": {
                "ambient": "mob.goat.ambient",
                "ambient.screamer": "mob.goat.ambient.screamer",
                "death": "mob.goat.death",
                "death.screamer": "mob.goat.death.screamer",
                "eat": "mob.goat.eat",
                "hurt": "mob.goat.hurt",
                "hurt.screamer": "mob.goat.hurt.screamer",
                "step": "mob.goat.step"
            },
            "pitch": [0.80, 1.20],
            "volume": 1
        },
        "guardian": {
            "events": {
                "ambient": "mob.guardian.land_idle",
                "ambient.in.water": "mob.guardian.ambient",
                "death": "mob.guardian.land_death",
                "death.in.water": "mob.guardian.death",
                "flop": "mob.guardian.flop",
                "guardian.flop": {
                    "pitch": 1.0,
                    "sound": "mob.guardian.flop",
                    "volume": 1.0
                },
                "hurt": "mob.guardian.land_hit",
                "hurt.in.water": "mob.guardian.hit"
            },
            "pitch": [0.80, 1.20],
            "volume": 1.0
        },
        "hoglin": {
            "events": {
                "ambient": "mob.hoglin.ambient",
                "angry": "mob.hoglin.angry",
                "attack": "mob.hoglin.attack",
                "death": "mob.hoglin.death",
                "eat": "",
                "hurt": "mob.hoglin.hurt",
                "retreat": "mob.hoglin.retreat",
                "step": {
                    "pitch": 1.0,
                    "sound": "mob.hoglin.step",
                    "volume": 1.0
                }
            },
            "pitch": [0.80, 1.20],
            "volume": 1.0
        },
        "horse": {
            "events": {
                "add.chest": {
                    "pitch": [0.80, 1.20],
                    "sound": "mob.horse.armor",
                    "volume": 1.0
                },
                "ambient": "mob.horse.idle",
                "armor": {
                    "pitch": 1.0,
                    "sound": "mob.horse.armor",
                    "volume": 0.60
                },
                "breathe": {
                    "pitch": 1.0,
                    "sound": "mob.horse.breathe",
                    "volume": 0.70
                },
                "death": "mob.horse.death",
                "eat": {
                    "pitch": [0.80, 1.20],
                    "sound": "mob.horse.eat",
                    "volume": [0.50, 1.50]
                },
                "hurt": "mob.horse.hit",
                "jump": {
                    "pitch": 1.0,
                    "sound": "mob.horse.jump",
                    "volume": 0.40
                },
                "land": {
                    "pitch": 1.0,
                    "sound": "mob.horse.land",
                    "volume": 0.40
                },
                "mad": "mob.horse.angry",
                "saddle": {
                    "pitch": 1.0,
                    "sound": "mob.horse.leather",
                    "volume": 0.60
                }
            },
            "pitch": [0.80, 1.20],
            "volume": 0.80
        },
        "husk": {
            "events": {
                "ambient": "mob.husk.ambient",
                "death": "mob.husk.death",
                "hurt": "mob.husk.hurt",
                "step": {
                    "pitch": 1.0,
                    "sound": "mob.husk.step",
                    "volume": 0.350
                }
            },
            "pitch": [0.80, 1.20],
            "volume": 1.0
        },
        "iron_golem": {
            "events": {
                "ambient": "mob.irongolem.say",
                "death": "mob.irongolem.death",
                "hurt": "mob.irongolem.hit",
                "irongolem.crack": "mob.irongolem.crack",
                "irongolem.repair": "mob.irongolem.repair",
                "step": {
                    "pitch": 1.0,
                    "sound": "mob.irongolem.walk",
                    "volume": 1.0
                },
                "throw": {
                    "pitch": 1.0,
                    "sound": "mob.irongolem.throw",
                    "volume": 1.0
                }
            },
            "pitch": [0.80, 1.0],
            "volume": 1.0
        },
        "item": {
            "events": {
                "fizz": {
                    "pitch": [2.0, 2.40],
                    "sound": "random.fizz",
                    "volume": 0.40
                }
            },
            "pitch": [0.80, 1.20],
            "volume": 1.0
        },
        "lightning_bolt": {
            "events": {
                "explode": {
                    "pitch": [0.30, 0.70],
                    "sound": "ambient.weather.lightning.impact"
                },
                "thunder": {
                    "pitch": [0.60, 1.0],
                    "sound": "ambient.weather.thunder"
                }
            },
            "volume": 1000.0
        },
        "llama": {
            "events": {
                "add.chest": {
                    "pitch": [0.80, 1.20],
                    "sound": "mob.horse.armor",
                    "volume": 1.0
                },
                "ambient": "mob.llama.idle",
                "armor": {
                    "pitch": 1.0,
                    "sound": "mob.llama.swag",
                    "volume": 0.50
                },
                "death": "mob.llama.death",
                "eat": {
                    "pitch": [0.80, 1.20],
                    "sound": "mob.llama.eat",
                    "volume": [0.50, 1.50]
                },
                "hurt": "mob.llama.hurt",
                "mad": "mob.llama.angry",
                "shoot": "mob.llama.spit",
                "step": {
                    "pitch": 1.0,
                    "sound": "mob.llama.step",
                    "volume": 0.150
                }
            },
            "pitch": [0.80, 1.20],
            "volume": 0.80
        },
        "magma_cube": {
            "events": {
                "ambient": "",
                "attack": {
                    "pitch": [0.80, 1.20],
                    "sound": "mob.attack"
                },
                "death": "mob.magmacube.small",
                "hurt": "mob.magmacube.small",
                "squish.big": {
                    "pitch": [0.640, 0.960],
                    "sound": "mob.magmacube.big"
                },
                "squish.small": {
                    "pitch": [0.640, 0.960],
                    "sound": "mob.magmacube.small"
                }
            },
            "pitch": [0.80, 1.20],
            "volume": 1.0
        },
        "minecart": {
            "events": {
                "step": ""
            }
        },
        "minecraft:npc": {
            "events": {
                "ambient": "mob.villager.idle",
                "death": "dig.wood",
                "hurt": "mob.villager.hit"
            },
            "pitch": [0.80, 1.20],
            "volume": 1.0
        },
        "mooshroom": {
            "events": {
                "ambient": "mob.cow.say",
                "death": "mob.cow.hurt",
                "eat": "mob.mooshroom.eat",
                "hurt": "mob.cow.hurt",
                "step": {
                    "pitch": [0.90, 1.10],
                    "sound": "mob.cow.step",
                    "volume": 0.650
                }
            },
            "pitch": [0.80, 1.20],
            "volume": 1.0
        },
        "mule": {
            "events": {
                "add.chest": {
                    "pitch": [0.80, 1.20],
                    "sound": "mob.horse.armor",
                    "volume": 1.0
                },
                "ambient": "mob.horse.donkey.idle",
                "armor": {
                    "pitch": 1.0,
                    "sound": "mob.horse.armor",
                    "volume": 0.60
                },
                "breathe": {
                    "pitch": 1.0,
                    "sound": "mob.horse.breathe",
                    "volume": 0.70
                },
                "death": "mob.horse.donkey.death",
                "eat": {
                    "pitch": [0.80, 1.20],
                    "sound": "mob.horse.eat",
                    "volume": [0.50, 1.50]
                },
                "hurt": "mob.horse.donkey.hit",
                "jump": {
                    "pitch": 1.0,
                    "sound": "mob.horse.jump",
                    "volume": 0.40
                },
                "land": {
                    "pitch": 1.0,
                    "sound": "mob.horse.land",
                    "volume": 0.40
                },
                "mad": "mob.horse.donkey.angry",
                "saddle": {
                    "pitch": 1.0,
                    "sound": "mob.horse.leather",
                    "volume": 0.60
                }
            },
            "pitch": [0.80, 1.20],
            "volume": 0.80
        },
        "npc": {
            "events": {
                "death": "dig.wood",
                "hurt": "mob.villager.hit",
                "spawn": "mob.villager.idle"
            },
            "pitch": [0.80, 1.20],
            "volume": 1.0
        },
        "ocelot": {
            "events": {
                "ambient": "mob.ocelot.idle",
                "death": "mob.ocelot.death",
                "eat": "mob.cat.eat",
                "hurt": {
                    "sound": "mob.cat.hit",
                    "volume": 0.450
                }
            },
            "pitch": [0.80, 1.20],
            "volume": 1.0
        },
        "panda": {
            "events": {
                "ambient": "mob.panda.idle",
                "ambient.aggressive": "mob.panda.idle.aggressive",
                "ambient.baby": "mob.panda_baby.idle",
                "ambient.worried": "mob.panda.idle.worried",
                "attack": "mob.panda.bite",
                "cant_breed": "mob.panda.cant_breed",
                "death": {
                    "sound": "mob.panda.death",
                    "volume": 0.820
                },
                "eat": "mob.panda.eat",
                "hurt": {
                    "sound": "mob.panda.hurt",
                    "volume": 0.820
                },
                "presneeze": "mob.panda.presneeze",
                "sneeze": "mob.panda.sneeze",
                "step": {
                    "sound": "mob.panda.step",
                    "volume": 0.40
                }
            },
            "pitch": [0.80, 1.20],
            "volume": 1.0
        },
        "parrot": {
            "events": {
                "ambient": {
                    "sound": "mob.parrot.idle",
                    "volume": 0.70
                },
                "death": {
                    "pitch": [0.80, 1.0],
                    "sound": "mob.parrot.death",
                    "volume": 1.0
                },
                "eat": "mob.parrot.eat",
                "fly": "mob.parrot.fly",
                "hurt": {
                    "pitch": [0.80, 1.0],
                    "sound": "mob.parrot.hurt",
                    "volume": 1.0
                },
                "imitate.blaze": {
                    "pitch": 1.80,
                    "sound": "mob.blaze.ambient",
                    "volume": 0.40
                },
                "imitate.bogged": {
                    "pitch": 1.70,
                    "sound": "mob.bogged.ambient"
                },
                "imitate.breeze": {
                    "pitch": 1.70,
                    "sound": "mob.breeze.idle_ground",
                    "volume": 0.70
                },
                "imitate.cave_spider": {
                    "pitch": 1.80,
                    "sound": "mob.spider.say",
                    "volume": 0.60
                },
                "imitate.creeper": {
                    "pitch": 1.80,
                    "sound": "random.fuse",
                    "volume": 0.60
                },
                "imitate.drowned": {
                    "pitch": 1.80,
                    "sound": "mob.zombie.say",
                    "volume": 0.60
                },
                "imitate.elder_guardian": {
                    "pitch": 1.70,
                    "sound": "mob.guardian.land_idle",
                    "volume": 0.70
                },
                "imitate.ender_dragon": {
                    "pitch": 1.80,
                    "sound": "mob.enderdragon.growl",
                    "volume": 0.20
                },
                "imitate.enderman": {
                    "pitch": 1.70,
                    "sound": "mob.endermen.idle",
                    "volume": 0.50
                },
                "imitate.endermite": {
                    "pitch": 1.80,
                    "sound": "mob.endermite.say",
                    "volume": 0.70
                },
                "imitate.evocation_illager": {
                    "pitch": 1.80,
                    "sound": "mob.evocation_illager.ambient",
                    "volume": 0.60
                },
                "imitate.ghast": {
                    "pitch": 1.80,
                    "sound": "mob.ghast.moan",
                    "volume": 0.70
                },
                "imitate.husk": {
                    "pitch": 1.80,
                    "sound": "mob.husk.ambient",
                    "volume": 0.60
                },
                "imitate.illusion_illager": {
                    "pitch": 1.80,
                    "sound": "mob.illusion_illager.ambient",
                    "volume": 0.70
                },
                "imitate.magma_cube": {
                    "pitch": 1.80,
                    "sound": "mob.magmacube.big",
                    "volume": 0.60
                },
                "imitate.panda": {
                    "pitch": 0.80,
                    "sound": "mob.panda.idle",
                    "volume": 0.70
                },
                "imitate.polar_bear": {
                    "pitch": 0.80,
                    "sound": "mob.polarbear.idle",
                    "volume": 0.70
                },
                "imitate.shulker": {
                    "pitch": 1.70,
                    "sound": "mob.shulker.ambient",
                    "volume": 0.40
                },
                "imitate.silverfish": {
                    "pitch": 1.80,
                    "sound": "mob.silverfish.say",
                    "volume": 0.70
                },
                "imitate.skeleton": {
                    "pitch": 1.70,
                    "sound": "mob.skeleton.say",
                    "volume": 1
                },
                "imitate.slime": {
                    "pitch": 1.80,
                    "sound": "mob.slime.big",
                    "volume": 0.60
                },
                "imitate.spider": {
                    "pitch": 1.80,
                    "sound": "mob.spider.say",
                    "volume": 0.60
                },
                "imitate.stray": {
                    "pitch": 1.60,
                    "sound": "mob.stray.ambient",
                    "volume": 0.60
                },
                "imitate.vex": {
                    "pitch": 1.60,
                    "sound": "mob.vex.ambient",
                    "volume": 0.80
                },
                "imitate.vindication_illager": {
                    "pitch": 1.70,
                    "sound": "mob.vindicator.idle",
                    "volume": 0.60
                },
                "imitate.warden": {
                    "pitch": 1.80,
                    "sound": "mob.warden.clicking",
                    "volume": 0.80
                },
                "imitate.witch": {
                    "pitch": 1.80,
                    "sound": "mob.witch.ambient",
                    "volume": 0.50
                },
                "imitate.wither": {
                    "pitch": 1.80,
                    "sound": "mob.wither.ambient",
                    "volume": 0.20
                },
                "imitate.wither_skeleton": {
                    "pitch": 1.80,
                    "sound": "mob.skeleton.say",
                    "volume": 0.70
                },
                "imitate.wolf": {
                    "pitch": 1.80,
                    "sound": "mob.wolf.bark",
                    "volume": 0.60
                },
                "imitate.zombie": {
                    "pitch": 1.80,
                    "sound": "mob.zombie.say",
                    "volume": 0.60
                },
                "imitate.zombie_pigman": {
                    "pitch": 1.80,
                    "sound": "mob.zombiepig.zpig",
                    "volume": 0.40
                },
                "imitate.zombie_villager": {
                    "pitch": 1.80,
                    "sound": "mob.zombie_villager.say",
                    "volume": 0.60
                },
                "step": "mob.parrot.step"
            },
            "pitch": [0.80, 1.20],
            "volume": 1.0
        },
        "phantom": {
            "events": {
                "ambient": "mob.phantom.idle",
                "attack": "mob.phantom.bite",
                "death": "mob.phantom.death",
                "flap": "mob.phantom.flap",
                "hurt": "mob.phantom.hurt",
                "swoop": {
                    "pitch": [0.950, 1.050],
                    "sound": "mob.phantom.swoop"
                }
            },
            "pitch": [0.80, 1.20],
            "volume": 10.0
        },
        "pig": {
            "events": {
                "ambient": "mob.pig.say",
                "boost": {
                    "pitch": 1.0,
                    "sound": "mob.pig.boost",
                    "volume": 1.0
                },
                "death": "mob.pig.death",
                "death.to.zombie": {
                    "sound": "mob.pig.death",
                    "volume": 2.0
                },
                "eat": "",
                "hurt": "mob.pig.say",
                "step": {
                    "pitch": 1.0,
                    "sound": "mob.pig.step",
                    "volume": 0.20
                }
            },
            "pitch": [0.80, 1.20],
            "volume": 1.0
        },
        "piglin": {
            "events": {
                "admire": "mob.piglin.admiring_item",
                "ambient": "mob.piglin.ambient",
                "angry": "mob.piglin.angry",
                "attack": "mob.piglin.attack",
                "celebrate": "mob.piglin.celebrate",
                "death": "mob.piglin.death",
                "hurt": "mob.piglin.hurt",
                "jealous": "mob.piglin.jealous",
                "retreat": "mob.piglin.retreat",
                "step": {
                    "sound": "mob.piglin.step",
                    "volume": 0.350
                }
            },
            "pitch": [0.80, 1.20],
            "volume": 1.0
        },
        "piglin_brute": {
            "events": {
                "ambient": "mob.piglin_brute.ambient",
                "angry": "mob.piglin_brute.angry",
                "death": "mob.piglin_brute.death",
                "hurt": "mob.piglin_brute.hurt",
                "step": {
                    "sound": "mob.piglin_brute.step",
                    "volume": 0.350
                }
            },
            "pitch": [0.80, 1.20],
            "volume": 1.0
        },
        "pillager": {
            "events": {
                "ambient": "mob.pillager.idle",
                "ambient.in.raid": {
                    "pitch": [0.80, 1.20],
                    "sound": "mob.pillager.idle",
                    "volume": 3.0
                },
                "celebrate": "mob.pillager.celebrate",
                "death": "mob.pillager.death",
                "hurt": "mob.pillager.hurt"
            },
            "pitch": [0.80, 1.20],
            "volume": 1.0
        },
        "player": {
            "events": {
                "attack.nodamage": "game.player.attack.nodamage",
                "attack.strong": "game.player.attack.strong",
                "death": "game.player.die",
                "death.in.water": "game.player.die",
                "elderguardian.curse": {
                    "pitch": 1.0,
                    "sound": "mob.elderguardian.curse",
                    "volume": 1.0
                },
                "hurt": "game.player.hurt",
                "hurt.in.water": "game.player.hurt",
                "splash": {
                    "pitch": [0.60, 1.40],
                    "sound": "entity.generic.splash"
                },
                "throw": {
                    "pitch": [0.330, 0.50],
                    "sound": "random.bow",
                    "volume": 0.50
                }
            },
            "pitch": [0.80, 1.20],
            "volume": 1.0
        },
        "polar_bear": {
            "events": {
                "ambient": "mob.polarbear.idle",
                "ambient.baby": "mob.polarbear_baby.idle",
                "death": "mob.polarbear.death",
                "hurt": {
                    "sound": "mob.polarbear.hurt",
                    "volume": 0.70
                },
                "mob.warning": {
                    "pitch": 1.0,
                    "sound": "mob.polarbear.warning",
                    "volume": 1.20
                },
                "step": {
                    "pitch": 1.0,
                    "sound": "mob.polarbear.step",
                    "volume": 0.70
                }
            },
            "pitch": [0.80, 1.20],
            "volume": 1.0
        },
        "pufferfish": {
            "events": {
                "flop": {
                    "pitch": 1.0,
                    "sound": "mob.fish.flop",
                    "volume": 1.0
                },
                "hurt": "mob.fish.hurt",
                "hurt.in.water": "mob.fish.hurt",
                "step": {
                    "pitch": 1.0,
                    "sound": "mob.fish.step",
                    "volume": 0.150
                }
            },
            "pitch": [0.80, 1.20],
            "volume": 1.0
        },
        "rabbit": {
            "events": {
                "ambient": "mob.rabbit.idle",
                "death": "mob.rabbit.death",
                "eat": "",
                "hurt": "mob.rabbit.hurt"
            },
            "pitch": [0.80, 1.20],
            "volume": 0.80
        },
        "ravager": {
            "events": {
                "ambient": "mob.ravager.ambient",
                "ambient.in.raid": {
                    "pitch": [0.80, 1.20],
                    "sound": "mob.ravager.ambient",
                    "volume": 3.0
                },
                "attack.strong": "mob.ravager.bite",
                "celebrate": "mob.ravager.celebrate",
                "death": "mob.ravager.death",
                "hurt": "mob.ravager.hurt",
                "roar": "mob.ravager.roar",
                "step": "mob.ravager.step",
                "stun": "mob.ravager.stun"
            },
            "pitch": [0.80, 1.20],
            "volume": 1.0
        },
        "salmon": {
            "events": {
                "flop": {
                    "pitch": 1.0,
                    "sound": "mob.fish.flop",
                    "volume": 1.0
                },
                "hurt": "mob.fish.hurt",
                "hurt.in.water": "mob.fish.hurt",
                "step": {
                    "pitch": 1.0,
                    "sound": "mob.fish.step",
                    "volume": 0.150
                }
            },
            "pitch": [0.80, 1.20],
            "volume": 1.0
        },
        "sheep": {
            "events": {
                "ambient": "mob.sheep.say",
                "death": "mob.sheep.say",
                "eat": "",
                "hurt": "mob.sheep.say",
                "step": {
                    "pitch": 1.0,
                    "sound": "mob.sheep.step",
                    "volume": 0.40
                }
            },
            "pitch": [0.80, 1.20],
            "volume": 1.0
        },
        "shulker": {
            "events": {
                "ambient": "mob.shulker.ambient",
                "death": "mob.shulker.death",
                "hurt": "mob.shulker.hurt",
                "shoot": "mob.shulker.shoot",
                "shulker.close": "mob.shulker.close",
                "shulker.open": "mob.shulker.open"
            },
            "pitch": [0.80, 1.20],
            "volume": 1.0
        },
        "silverfish": {
            "events": {
                "ambient": "mob.silverfish.say",
                "death": "mob.silverfish.kill",
                "hurt": "mob.silverfish.hit",
                "step": {
                    "pitch": 1.0,
                    "sound": "mob.silverfish.step",
                    "volume": 0.350
                }
            },
            "pitch": [0.80, 1.20],
            "volume": 1.0
        },
        "skeleton": {
            "events": {
                "ambient": "mob.skeleton.say",
                "death": "mob.skeleton.death",
                "hurt": {
                    "sound": "mob.skeleton.hurt",
                    "volume": 0.70
                },
                "step": {
                    "pitch": 1.0,
                    "sound": "mob.skeleton.step",
                    "volume": 1.0
                }
            },
            "pitch": [0.80, 1.20],
            "volume": 1.0
        },
        "skeleton_horse": {
            "events": {
                "add.chest": {
                    "pitch": [0.80, 1.20],
                    "sound": "mob.horse.armor",
                    "volume": 1.0
                },
                "ambient": "mob.horse.skeleton.idle",
                "armor": {
                    "pitch": 1.0,
                    "sound": "mob.horse.armor",
                    "volume": 0.60
                },
                "breathe": {
                    "pitch": 1.0,
                    "sound": "mob.horse.breathe",
                    "volume": 0.70
                },
                "death": "mob.horse.skeleton.death",
                "hurt": "mob.horse.skeleton.hit",
                "jump": {
                    "pitch": 1.0,
                    "sound": "mob.horse.jump",
                    "volume": 0.40
                },
                "land": {
                    "pitch": 1.0,
                    "sound": "mob.horse.land",
                    "volume": 0.40
                },
                "saddle": {
                    "pitch": 1.0,
                    "sound": "mob.horse.leather",
                    "volume": 0.60
                }
            },
            "pitch": [0.80, 1.20],
            "volume": 0.80
        },
        "slime": {
            "events": {
                "ambient": "",
                "attack": {
                    "pitch": [0.80, 1.20],
                    "sound": "mob.attack"
                },
                "death": "mob.slime.small",
                "hurt": "mob.slime.small",
                "squish.big": {
                    "pitch": [0.640, 0.960],
                    "sound": "mob.slime.big"
                },
                "squish.small": {
                    "pitch": [0.640, 0.960],
                    "sound": "mob.slime.small"
                }
            },
            "pitch": [0.80, 1.20],
            "volume": 1.0
        },
        "sniffer": {
            "events": {
                "ambient": "mob.sniffer.idle",
                "death": "mob.sniffer.death",
                "eat": "mob.sniffer.eat",
                "hurt": "mob.sniffer.hurt",
                "plop": "mob.sniffer.plop",
                "step": "mob.sniffer.step"
            },
            "pitch": [0.80, 1.20],
            "volume": 1.0
        },
        "snow_golem": {
            "events": {
                "death": {
                    "pitch": [0.80, 1.20],
                    "sound": "mob.snowgolem.death"
                },
                "hurt": {
                    "pitch": [0.80, 1.20],
                    "sound": "mob.snowgolem.hurt"
                },
                "shoot": {
                    "pitch": [0.330, 0.50],
                    "sound": "mob.snowgolem.shoot"
                }
            },
            "pitch": [0.80, 1.20],
            "volume": 1.0
        },
        "spider": {
            "events": {
                "ambient": "mob.spider.say",
                "death": "mob.spider.death",
                "hurt": "mob.spider.say",
                "step": {
                    "pitch": [0.90, 1.10],
                    "sound": "mob.spider.step",
                    "volume": 0.350
                }
            },
            "pitch": [0.80, 1.20],
            "volume": 1.0
        },
        "squid": {
            "events": {
                "ambient": "mob.squid.ambient",
                "death": "mob.squid.death",
                "hurt": "mob.squid.hurt"
            },
            "pitch": [0.80, 1.20],
            "volume": 0.40
        },
        "stray": {
            "events": {
                "ambient": "mob.stray.ambient",
                "death": "mob.stray.death",
                "hurt": "mob.stray.hurt",
                "step": {
                    "pitch": 1.0,
                    "sound": "mob.stray.step",
                    "volume": 1.0
                }
            },
            "pitch": [0.80, 1.20],
            "volume": 1.0
        },
        "strider": {
            "events": {
                "ambient": "mob.strider.idle",
                "death": "mob.strider.death",
                "eat": "mob.strider.eat",
                "hurt": "mob.strider.hurt",
                "panic": "mob.strider.panic",
                "step": {
                    "pitch": 1.0,
                    "sound": "mob.strider.step",
                    "volume": 0.250
                },
                "step_lava": {
                    "pitch": 1.0,
                    "sound": "mob.strider.step_lava",
                    "volume": 0.20
                },
                "tempt": "mob.strider.tempt"
            },
            "pitch": [0.80, 1.20],
            "volume": 1.0
        },
        "tadpole": {
            "events": {
                "death": "mob.tadpole.death",
                "flop": {
                    "pitch": 1.0,
                    "sound": "mob.fish.flop",
                    "volume": 1.0
                },
                "hurt": "mob.tadpole.hurt"
            },
            "pitch": [0.80, 1.20],
            "volume": 1
        },
        "trader_llama": {
            "events": {
                "add.chest": {
                    "pitch": [0.80, 1.20],
                    "sound": "mob.horse.armor",
                    "volume": 1.0
                },
                "ambient": "mob.llama.idle",
                "armor": {
                    "pitch": 1.0,
                    "sound": "mob.llama.swag",
                    "volume": 0.50
                },
                "death": "mob.llama.death",
                "eat": {
                    "pitch": [0.80, 1.20],
                    "sound": "mob.llama.eat",
                    "volume": [0.50, 1.50]
                },
                "hurt": "mob.llama.hurt",
                "mad": "mob.llama.angry",
                "shoot": "mob.llama.spit",
                "step": {
                    "pitch": 1.0,
                    "sound": "mob.llama.step",
                    "volume": 0.150
                }
            },
            "pitch": [0.80, 1.20],
            "volume": 0.80
        },
        "tropicalfish": {
            "events": {
                "flop": {
                    "pitch": 1.0,
                    "sound": "mob.fish.flop",
                    "volume": 1.0
                },
                "hurt": "mob.fish.hurt",
                "hurt.in.water": "mob.fish.hurt",
                "step": {
                    "pitch": 1.0,
                    "sound": "mob.fish.step",
                    "volume": 0.150
                }
            },
            "pitch": [0.80, 1.20],
            "volume": 1.0
        },
        "turtle": {
            "events": {
                "ambient": "mob.turtle.ambient",
                "born": {
                    "pitch": 1.0,
                    "sound": "mob.turtle_baby.born",
                    "volume": 1.0
                },
                "death": "mob.turtle.death",
                "death.baby": "mob.turtle_baby.death",
                "eat": "",
                "hurt": "mob.turtle.hurt",
                "hurt.baby": "mob.turtle_baby.hurt",
                "step": {
                    "pitch": 1.0,
                    "sound": "mob.turtle.step",
                    "volume": 1.0
                },
                "step.baby": {
                    "pitch": 1.0,
                    "sound": "mob.turtle_baby.step",
                    "volume": 1.0
                },
                "swim": {
                    "pitch": [0.60, 1.40],
                    "sound": "mob.turtle.swim"
                }
            },
            "pitch": [0.80, 1.20],
            "volume": 1.0
        },
        "vex": {
            "events": {
                "ambient": "mob.vex.ambient",
                "charge": "mob.vex.charge",
                "death": "mob.vex.death",
                "hurt": "mob.vex.hurt"
            },
            "pitch": [0.80, 1.20],
            "volume": 1.0
        },
        "villager": {
            "events": {
                "ambient": "mob.villager.idle",
                "death": "mob.villager.death",
                "death.to.zombie": "mob.villager.death",
                "haggle": "mob.villager.haggle",
                "haggle.no": "mob.villager.no",
                "haggle.yes": "mob.villager.yes",
                "hurt": "mob.villager.hit"
            },
            "pitch": [0.80, 1.20],
            "volume": 1.0
        },
        "villager_v2": {
            "events": {
                "ambient": "mob.villager.idle",
                "death": "mob.villager.death",
                "death.to.zombie": "mob.villager.death",
                "haggle": "mob.villager.haggle",
                "haggle.no": "mob.villager.no",
                "haggle.yes": "mob.villager.yes",
                "hurt": "mob.villager.hit"
            },
            "pitch": [0.80, 1.20],
            "volume": 1.0
        },
        "vindicator": {
            "events": {
                "ambient": "mob.vindicator.idle",
                "ambient.in.raid": {
                    "pitch": [0.80, 1.20],
                    "sound": "mob.vindicator.idle",
                    "volume": 3.0
                },
                "celebrate": "mob.vindicator.celebrate",
                "death": "mob.vindicator.death",
                "hurt": "mob.vindicator.hurt"
            },
            "pitch": [0.80, 1.20],
            "volume": 1.0
        },
        "wandering_trader": {
            "events": {
                "ambient": "mob.wanderingtrader.idle",
                "death": "mob.wanderingtrader.death",
                "disappeared": "mob.wanderingtrader.disappeared",
                "drink": "mob.wanderingtrader.drink_potion",
                "drink.milk": "mob.wanderingtrader.drink_milk",
                "haggle": "mob.wanderingtrader.haggle",
                "haggle.no": "mob.wanderingtrader.no",
                "haggle.yes": "mob.wanderingtrader.yes",
                "hurt": "mob.wanderingtrader.hurt",
                "reappeared": "mob.wanderingtrader.reappeared"
            },
            "pitch": [0.80, 1.20],
            "volume": 1.0
        },
        "warden": {
            "events": {
                "agitated": {
                    "pitch": [0.80, 1.20],
                    "sound": "mob.warden.agitated",
                    "volume": 10.0
                },
                "ambient": "mob.warden.idle",
                "angry": {
                    "pitch": [0.80, 1.20],
                    "sound": "mob.warden.angry",
                    "volume": 10.0
                },
                "attack": {
                    "pitch": 1.0,
                    "sound": "mob.warden.attack",
                    "volume": 10.0
                },
                "death": {
                    "pitch": [0.80, 1.0],
                    "sound": "mob.warden.death",
                    "volume": 1.0
                },
                "dig": {
                    "pitch": 1.0,
                    "sound": "mob.warden.dig",
                    "volume": 5.0
                },
                "emerge": {
                    "pitch": 1.0,
                    "sound": "mob.warden.emerge",
                    "volume": 5.0
                },
                "heartbeat": {
                    "pitch": 1.0,
                    "sound": "mob.warden.heartbeat",
                    "volume": 5.0
                },
                "hurt": {
                    "pitch": [0.80, 1.0],
                    "sound": "mob.warden.hurt",
                    "volume": 1.0
                },
                "idle": {
                    "pitch": 1.0,
                    "sound": "mob.warden.idle",
                    "volume": 3.0
                },
                "listening": {
                    "pitch": [0.80, 1.20],
                    "sound": "mob.warden.listening",
                    "volume": 10.0
                },
                "listening_angry": {
                    "pitch": [0.80, 1.20],
                    "sound": "mob.warden.listening_angry",
                    "volume": 10.0
                },
                "nearby_close": {
                    "pitch": [0.80, 1.20],
                    "sound": "mob.warden.nearby_close",
                    "volume": 5.0
                },
                "nearby_closer": {
                    "pitch": [0.80, 1.20],
                    "sound": "mob.warden.nearby_closer",
                    "volume": 5.0
                },
                "nearby_closest": {
                    "pitch": [0.80, 1.20],
                    "sound": "mob.warden.nearby_closest",
                    "volume": 5.0
                },
                "roar": {
                    "pitch": 1.0,
                    "sound": "mob.warden.roar",
                    "volume": 10.0
                },
                "sniff": {
                    "pitch": 1.0,
                    "sound": "mob.warden.sniff",
                    "volume": 5.0
                },
                "step": {
                    "pitch": 1.0,
                    "sound": "mob.warden.step",
                    "volume": 10.0
                }
            },
            "pitch": [0.80, 1.20],
            "volume": 1.0
        },
        "witch": {
            "events": {
                "ambient": "mob.witch.ambient",
                "ambient.in.raid": {
                    "pitch": [0.80, 1.20],
                    "sound": "mob.witch.ambient",
                    "volume": 3.0
                },
                "celebrate": "mob.witch.celebrate",
                "death": "mob.witch.death",
                "drink": {
                    "pitch": 1.0,
                    "sound": "mob.witch.drink",
                    "volume": 1.0
                },
                "hurt": "mob.witch.hurt",
                "throw": {
                    "pitch": 1.0,
                    "sound": "mob.witch.throw",
                    "volume": 1.0
                }
            },
            "pitch": [0.80, 1.20],
            "volume": 1.0
        },
        "wither": {
            "events": {
                "ambient": "mob.wither.ambient",
                "break.block": {
                    "pitch": 1.0,
                    "sound": "mob.wither.break_block",
                    "volume": 1.0
                },
                "death": "mob.wither.death",
                "death.mid.volume": {
                    "sound": "mob.wither.death",
                    "volume": 0.750
                },
                "death.min.volume": {
                    "sound": "mob.wither.death",
                    "volume": 0.50
                },
                "hurt": "mob.wither.hurt",
                "shoot": {
                    "pitch": 1.0,
                    "sound": "mob.wither.shoot",
                    "volume": 3.0
                },
                "spawn": {
                    "pitch": 1.0,
                    "sound": "mob.wither.spawn",
                    "volume": 1.0
                }
            },
            "pitch": [0.80, 1.20],
            "volume": 1.0
        },
        "wither_skeleton": {
            "events": {
                "ambient": {
                    "pitch": [0.80, 1.20],
                    "sound": "entity.wither_skeleton.ambient",
                    "volume": 1.0
                },
                "death": {
                    "pitch": [0.80, 1.20],
                    "sound": "entity.wither_skeleton.death",
                    "volume": 1.0
                },
                "hurt": {
                    "pitch": [0.80, 1.20],
                    "sound": "entity.wither_skeleton.hurt",
                    "volume": 1.0
                },
                "sound": {
                    "pitch": 1.0,
                    "sound": "entity.wither_skeleton.step",
                    "volume": 0.150
                },
                "step": {
                    "pitch": 1.0,
                    "sound": "mob.skeleton.step",
                    "volume": 1.0
                }
            },
            "pitch": [0.80, 1.20],
            "volume": 1.0
        },
        "wolf": {
            "events": {
                "ambient": "mob.wolf.bark",
                "death": "mob.wolf.death",
                "eat": "",
                "growl": "mob.wolf.growl",
                "hurt": "mob.wolf.hurt",
                "hurt.reduced": "armor.damage_wolf",
                "pant": "mob.wolf.panting",
                "shake": {
                    "pitch": [0.80, 1.20],
                    "sound": "mob.wolf.shake"
                },
                "step": {
                    "pitch": 1.0,
                    "sound": "mob.wolf.step",
                    "volume": 0.650
                },
                "whine": "mob.wolf.whine"
            },
            "pitch": [0.80, 1.20],
            "volume": 1.0
        },
        "xp_orb": {
            "events": {
                "fizz": {
                    "pitch": [2.0, 2.40],
                    "sound": "random.fizz",
                    "volume": 0.40
                }
            },
            "pitch": [0.80, 1.20],
            "volume": 1.0
        },
        "zoglin": {
            "events": {
                "ambient": "mob.zoglin.idle",
                "angry": "mob.zoglin.angry",
                "attack": "mob.zoglin.attack",
                "death": "mob.zoglin.death",
                "hurt": "mob.zoglin.hurt",
                "step": {
                    "pitch": 1.0,
                    "sound": "mob.zoglin.step",
                    "volume": 0.150
                }
            },
            "pitch": [0.80, 1.20],
            "volume": 1.0
        },
        "zombie": {
            "events": {
                "ambient": "mob.zombie.say",
                "death": "mob.zombie.death",
                "hurt": "mob.zombie.hurt",
                "step": {
                    "pitch": 1.0,
                    "sound": "mob.zombie.step",
                    "volume": 0.450
                }
            },
            "pitch": [0.80, 1.20],
            "volume": 1.0
        },
        "zombie_horse": {
            "events": {
                "add.chest": {
                    "pitch": [0.80, 1.20],
                    "sound": "mob.horse.armor",
                    "volume": 1.0
                },
                "ambient": "mob.horse.zombie.idle",
                "armor": {
                    "pitch": 1.0,
                    "sound": "mob.horse.armor",
                    "volume": 0.60
                },
                "breathe": {
                    "pitch": 1.0,
                    "sound": "mob.horse.breathe",
                    "volume": 0.70
                },
                "death": "mob.horse.zombie.death",
                "hurt": "mob.horse.zombie.hit",
                "jump": {
                    "pitch": 1.0,
                    "sound": "mob.horse.jump",
                    "volume": 0.40
                },
                "land": {
                    "pitch": 1.0,
                    "sound": "mob.horse.land",
                    "volume": 0.40
                },
                "saddle": {
                    "pitch": 1.0,
                    "sound": "mob.horse.leather",
                    "volume": 0.60
                }
            },
            "pitch": [0.80, 1.20],
            "volume": 0.80
        },
        "zombie_pigman": {
            "events": {
                "ambient": "mob.zombiepig.zpig",
                "death": "mob.zombiepig.zpigdeath",
                "hurt": "mob.zombiepig.zpighurt",
                "mad": {
                    "pitch": [1.440, 2.160],
                    "sound": "mob.zombiepig.zpigangry",
                    "volume": 2.0
                }
            },
            "pitch": [0.80, 1.20],
            "volume": 1.0
        },
        "zombie_villager": {
            "events": {
                "ambient": "mob.zombie_villager.say",
                "death": "mob.zombie_villager.death",
                "hurt": "mob.zombie_villager.hurt",
                "step": {
                    "pitch": 1.0,
                    "sound": "mob.zombie.step",
                    "volume": 0.450
                }
            },
            "pitch": [0.80, 1.20],
            "volume": 1.0
        },
        "zombie_villager_v2": {
            "events": {
                "ambient": "mob.zombie_villager.say",
                "death": "mob.zombie_villager.death",
                "hurt": "mob.zombie_villager.hurt",
                "step": {
                    "pitch": 1.0,
                    "sound": "mob.zombie.step",
                    "volume": 0.450
                }
            },
            "pitch": [0.80, 1.20],
            "volume": 1.0
        }
    }
}