//-----------------------------------------------------
//导入
//________________________________________________________________

import { ItemStack, world, system  } from '@minecraft/server';
import {  score, set } from 'score.js';
import {  standName } from 'disc/disc.js'

//-----------------------------------------------------
//事件
//________________________________________________________________


world.afterEvents.itemUse.subscribe(event => {
    const item = event.itemStack;
    const player = event.source;
    getStand(player, item)
});

//-----------------------------------------------------
//函数
//________________________________________________________________

//取随机整数
function randomNum(minNum, maxNum) {
    switch (arguments.length) {
        case 1:
            return parseInt(Math.random() * minNum + 1, 10);
            break;
        case 2:
            return parseInt(Math.random() * (maxNum - minNum + 1) + minNum, 10);
            break;
        default:
            return 0;
            break;
    }
};

function spareStand() {
    const can_get_stand_with_arrow = 
    [
       1, //白金之星
       2, //杀手皇后
       3, //回音act3
       4, //疯狂钻石
       5, //折纸师
       6, //辛红辣椒
       7, //公路之星
       8 //极恶中队
    ]
    const standN = randomNum(0, can_get_stand_with_arrow.length)
    const stand = can_get_stand_with_arrow[standN]
    return stand;
}

export function getStand(player, item) {
    if (item.typeId == "johnny3150:stand_arrow" && player.hasTag("use_arrow")) {
        player.removeTag("use_arrow")

        //神秘大转盘,100块💰一次
        if (score(player, "stand_type_id") == 0 && item.getLore() == "") {

            //耐久-1
            const damageItem = item.clone();
            const container = player.getComponent("minecraft:inventory").container;
            if (damageItem.getComponent("minecraft:durability").damage < 2) {
                damageItem.getComponent("minecraft:durability").damage += 1;
                container.setItem(player.selectedSlotIndex, damageItem);
            } else {
                let air = new ItemStack("minecraft:air", 1)
                container.setItem(player.selectedSlotIndex, air);
            }

            //20%谁玩都合适
            const die = randomNum(0, 4);
            if (die == 0 && !player.hasTag("创造模式")) {
                player.runCommand("gamerule showdeathmessages false")
                player.kill()
                let text = player.name
                world.sendMessage({
                    rawtext: [{
                        "text": text
                    }, {
                        "translate": "die.arrow"
                    }],
                })
                player.runCommand("gamerule showdeathmessages true")
            } else {
                const stand = spareStand();
                set(player, "stand_type_id", stand)
                set(player, "stand_summon", 0)
                player.runCommand("function GetStandOrClearStand")
            }
        }

        //特殊替身之箭
        if (score(player, "stand_type_id") == 0 && item.getLore() != "") {
            const container = player.getComponent("minecraft:inventory").container;
            let air = new ItemStack("minecraft:air", 1)
            container.setItem(player.selectedSlotIndex, air);
            const stand = standName.indexOf(item.getLore()[1].replace("  §r§9", "")) > -1 ? standName.indexOf(item.getLore()[1].replace("  §r§9", "")) : 0
            set(player, "stand_type_id", stand)
            set(player, "stand_summon", 0)
            player.runCommand("function GetStandOrClearStand")
        }
    }
}

export function attackGetStand(player, dp, item) {
    if (item.typeId == "johnny3150:stand_arrow") {

        //神秘大转盘,100块💰一次
        if (score(player, "stand_type_id") == 0 && item.getLore() == "") {

            //耐久-1
            const damageItem = item.clone();
            const container = dp.getComponent("minecraft:inventory").container;
            if (damageItem.getComponent("minecraft:durability").damage < 2) {
                damageItem.getComponent("minecraft:durability").damage += 1;
                container.setItem(dp.selectedSlotIndex, damageItem);
            } else {
                let air = new ItemStack("minecraft:air", 1)
                container.setItem(dp.selectedSlotIndex, air);
            }

            //20%谁玩都合适
            const die = randomNum(0, 4);
            if (die == 0 && !player.hasTag("创造模式")) {
                player.runCommand("gamerule showdeathmessages false")
                player.kill()
                let text = player.name
                world.sendMessage({
                    rawtext: [{
                        "text": text
                    }, {
                        "translate": "die.arrow"
                    }],
                })
                player.runCommand("gamerule showdeathmessages true")
            } else {
                const stand = spareStand();
                set(player, "stand_type_id", stand)
                set(player, "stand_summon", 0)
                player.runCommand("function GetStandOrClearStand")
            }
        }

        //特殊替身之箭
        if (score(player, "stand_type_id") == 0 && item.getLore() != "") {
            const container = dp.getComponent("minecraft:inventory").container;
            let air = new ItemStack("minecraft:air", 1)
            container.setItem(dp.selectedSlotIndex, air);
            const stand = standName.indexOf(item.getLore()[1].replace("  §r§9", "")) > -1 ? standName.indexOf(item.getLore()[1].replace("  §r§9", "")) : 0
            set(player, "stand_type_id", stand)
            set(player, "stand_summon", 0)
            player.runCommand("function GetStandOrClearStand")
        }
    }
}