//-----------------------------------------------------
//导入
//________________________________________________________________

import { ItemStack, world, system } from '@minecraft/server';
import {  score, set } from 'score.js';

//-----------------------------------------------------
//常量
//________________________________________________________________

export const standName = [
"空气", 
"白金之星",
"杀手皇后",
"回音 act3",
"疯狂钻石",
"折纸师",
"辛红辣椒",
"公路之星",
"极恶中队",
"世界"
];

//-----------------------------------------------------
//事件
//________________________________________________________________

system.runInterval(() => {
    for (const player of world.getPlayers()) {
        discLoreInitialize(player);
    }
}, 5)

world.afterEvents.itemUse.subscribe(event => {
    const item = event.itemStack;
    const player = event.source;
    const container = player.getComponent("minecraft:inventory")
            .container;

    if (item.typeId == "stand:disc" && player.hasTag("use_disc")) {
        player.removeTag("use_disc")
        let typeId = standName.indexOf(item.getLore()[3].replace("  §r§9", ""));
        let level = (item.getLore()[5].replace("  §r§9", "")).replace("%%", "");
        if (score(player, "stand_type_id") == 0) {
            if (typeId != 0 && score(player, "stand_summon") == 0) {
                player.runCommand("function GetStandOrClearStand")
                set(player, "stand_type_id", typeId)
                set(player, "stand_level", (level > score(player, "stand_level") ? level : score(player, "stand_level")))
                set(player, "stand_energy", 0)
                item.setLore([""])
                container.setItem(player.selectedSlotIndex, item)
            }
        } else {
            if (typeId == 0 && score(player, "stand_summon") == 0) {
                item.setLore([
                "§r§7光碟",
                "",
                "§r§7所收纳替身:",
                `  §r§9${standName[score(player, "stand_type_id")]}`,
                "§r§7完成度:",
                `  §r§9${score(player, "stand_level")}%%`])
                player.runCommand("function GetStandOrClearStand")
                set(player, "stand_type_id", 0)
                set(player, "stand_level", 0)
                set(player, "stand_energy", 0)
                set(player, "stand_summon", 0)
                set(player, "angry", 0)
                container.setItem(player.selectedSlotIndex, item)
            }
            if (typeId == 0 && score(player, "stand_summon") == 1) {
                player.runCommand(`tellraw @s {"rawtext":[{"translate":"disc.error"}]}`)
            }
            if (typeId != 0) {
                player.runCommand(`tellraw @s {"rawtext":[{"translate":"disc.error2"}]}`)
            }
        }
    }
});

//-----------------------------------------------------
//函数
//________________________________________________________________

function discLoreInitialize(player) {
    for (var num = 0; num < 35; num++) {
        const container = player.getComponent("minecraft:inventory").container;
        player.runCommand(`replaceitem entity @s slot.inventory ${num} keep air`)
        let item = container.getItem(num);
        if (item != undefined) {
            if (item.typeId == "stand:disc" && item.getLore() == "") {
                let disc = new ItemStack("stand:disc", 1)
                disc.setLore(["§r§7空光碟",
                    "",
                    "§r§7所收纳替身:",
                    "  §r§9空气",
                    "§r§7完成度:",
                    "  §r§90%%"
                    ])
                container.setItem(num, disc)
            }
            if (item.typeId == "stand:pluck_sword" && item.getLore() == "") {
                let pluck_sword = new ItemStack("stand:pluck_sword", 1)
                pluck_sword.setLore([
                    "",
                    "§r§7“拥有这把剑使你充满了勇气!”",
                    "§r技能§e「横扫」§r:",
                    "§r  对前方半径2.5格内的敌人造成10点不受附魔加成的固定伤害"
                    ])
                container.setItem(num, pluck_sword)
            }
            if (item.typeId == "stand:dio_sword" && item.getLore() == "") {
                let dio_sword = new ItemStack("stand:dio_sword", 1)
                dio_sword.setLore([
                    "",
                    "§r§7“我想要做的，乔斯达家都做过了”",
                    "§r技能§d「突进」§r:",
                    "§r  获得3秒速度IV"
                    ])
                container.setItem(num, dio_sword)
            }
        }
    }
}