//-----------------------------------------------------
//导入
//________________________________________________________________

import { world, system, ItemStack } from '@minecraft/server';

//-----------------------------------------------------
//变量
//________________________________________________________________

export let events = 
[
    ["test", "0"]
]
//-----------------------------------------------------
//事件
//________________________________________________________________

world.afterEvents.worldInitialize.subscribe(event => {
    let def = world.getDynamicProperty("events");
    if (!def) {
        world.setDynamicProperty("events", string(events))
        events = parse("events")
    } else {
        events = parse("events");
    }
})

world.afterEvents.itemUse.subscribe(event => {
    const item = event.itemStack;
    const player = event.source;
    if (item.typeId != "minecraft:apple")return;
    throw string(events);
})

system.runTimeout(() => {   
    system.runInterval(() => {
        natural_event()
        
        zombie_moon()
        for (const event of events) {
            if (event[0] == "test") {
                world.sendMessage(`${world.getAbsoluteTime()}`)
            }
            if (event[1] > 0) {
                event[1] -= 1
            }
            if (event[1] <= 0) {
                event_remove_event(event)
                removeEvent(event[0]);
            }
        }
    }, 1)
}, 20)

system.runTimeout(() => {   
    system.runInterval(() => {
        world.setDynamicProperty("events", string(events))
    }, 100)
}, 20)

//-----------------------------------------------------
//事件发生函数
//________________________________________________________________

function natural_event() {

    let event_open = world.getDynamicProperty("event_open") == "yes" ? true : false
    if (!event_open)return;

    //尸鬼月
    if (world.getMoonPhase == 4) {
        if (!haveEvent("zombie_moon") && randomNum(1, 1000000) <= 24) {
            world.sendMessage("§9今夜月明人尽望......")
            addEvent("zombie_moon", 14400)
        }
    } else {
        if (!haveEvent("zombie_moon") && randomNum(1, 1000000) <= 12) {
            world.sendMessage("§9今夜月明人尽望......")
            addEvent("zombie_moon", 14400)
        }
    }
}

function event_remove_event(event) {
    if (event[0] == "zombie_moon") {
        world.sendMessage("§9不知秋思落谁家......")
    }
}

//-----------------------------------------------------
//事件函数
//________________________________________________________________

function zombie_moon() {
    if (haveEvent("zombie_moon")) {
        world.getDimension("overworld").runCommand("fog @a push minecraft:fog_the_end zombie_moon")
        if (world.getTimeOfDay() < 12000 || world.getTimeOfDay() > 14000) {
            world.setTimeOfDay(13000)
        }
    } else {
        world.getDimension("overworld").runCommand("fog @a remove zombie_moon")
    }
}

//-----------------------------------------------------
//函数
//________________________________________________________________

//取随机整数
function randomNum(minNum, maxNum) {
    switch (arguments.length) {
        case 1:
            return parseInt(Math.random() * minNum + 1, 10);
            break;
        case 2:
            return parseInt(Math.random() * (maxNum - minNum + 1) + minNum, 10);
            break;
        default:
            return 0;
            break;
    }
};

export function haveEvent(id) {
    let result = false;
    for (const event of events) {
        if (event.indexOf(id) != -1) {
            result = true;
            return result;
        }
    }
    return result;
}

export function removeEvent(id) {
    let l = events.length
    let newEvents = [];
    for (let i = 0; i < l; i++) {
        if (events[i].indexOf(id) == -1) {
            newEvents.push(events[i])
        }
    }
    world.setDynamicProperty("events", string(newEvents))
    events = parse("events")
}

export function addEvent(id, tick) {
    let event = [ `${id}`, `${tick}` ]
    let newEvents = [];
    let l = events.length
    for (let i = 0; i < l; i++) {
        newEvents.push(events[i])
    }
    newEvents.push(event)
    events = newEvents
    world.setDynamicProperty("events", string(newEvents))
    return true;
}

export function parse(value) {
    let json = world.getDynamicProperty(value)
    if (typeof(json) === "string") {
        return JSON.parse(json);
    } else {
        return undefined;
    }
}

export function string(value) {
    return JSON.stringify(value);
}