//-----------------------------------------------------
//导入
//________________________________________________________________

import { world, system, ItemStack } from '@minecraft/server';
import { ActionFormData, MessageFormData, ModalFormData } from '@minecraft/server-ui';

//-----------------------------------------------------
//事件
//________________________________________________________________

world.afterEvents.itemUse.subscribe(event => {
    const item = event.itemStack;
    const player = event.source;
    openBook(player, item)
});

//-----------------------------------------------------
//函数
//________________________________________________________________

function openBook(player, item) {
    let paper;
    let PaperNext;
    let bookName = "none";
    if (item.typeId != "stand:guide_book") return;
    if (item.typeId == "stand:guide_book") {
        bookName = "guide_book"
    }
    if (item.getLore() == "") {
        paper = "0";
        PlayerItemSetLorePaperNext(player, item, "0")
    } else {
        paper = removeSectionSymbols(item.getLore()[0])
    }
    let ui = new ActionFormData()
        .title(`book:${bookName}:${padStart(paper ,5, '0')}`)
        .body(`第${paper}页`)
        
        .button("", "book:left")
        .button("", "book:right")

        .show(player).then(event => {
            paper = parseInt(paper)
            if (event.selection == 0) {
                PaperNext = `${(paper - 1) >= 0 ? (paper - 1) : 0 }`
                PlayerItemSetLorePaperNext(player, item, PaperNext)
                openBook2(player, player.getComponent("minecraft:inventory").container.getItem(player.selectedSlotIndex))
            }
            if (event.selection == 1) {
                PaperNext = `${(paper + 1) >= 0 ? (paper + 1) : 0 }`
                PlayerItemSetLorePaperNext(player, item, PaperNext)
                openBook2(player, player.getComponent("minecraft:inventory").container.getItem(player.selectedSlotIndex))
            }
        })
}

function openBook2(player, item) {
    let paper;
    let PaperNext;
    let bookName = "none";
    if (item.typeId != "stand:guide_book") return;
    if (item.typeId == "stand:guide_book") {
        bookName = "guide_book"
    }
    if (item.getLore() == "") {
        paper = "0";
        PlayerItemSetLorePaperNext(player, item, "0")
    } else {
        paper = removeSectionSymbols(item.getLore()[0])
    }
    let ui = new ActionFormData()
        .title(`book:${bookName}:${padStart(paper, 5, '0')}`)
        .body(`第${paper}页`)
        
        .button("", "book:left")
        .button("", "book:right")

        .show(player).then(event => {
            paper = parseInt(paper)
            if (event.selection == 0) {
                PaperNext = `${(paper - 1) >= 0 ? (paper - 1) : 0 }`
                PlayerItemSetLorePaperNext(player, item, PaperNext)
                openBook(player, player.getComponent("minecraft:inventory").container.getItem(player.selectedSlotIndex))
            }
            if (event.selection == 1) {
                PaperNext = `${(paper + 1) >= 0 ? (paper + 1) : 0 }`
                PlayerItemSetLorePaperNext(player, item, PaperNext)
                openBook(player, player.getComponent("minecraft:inventory").container.getItem(player.selectedSlotIndex))
            }
        })
}

function PlayerItemSetLorePaperNext(player, item, paper) {
    let newLore = addSectionSymbols(paper)
    item.setLore([`${newLore}`])
    let container = player.getComponent("minecraft:inventory").container
    container.setItem(player.selectedSlotIndex, item)
}

function addSectionSymbols(input) {
    // 将字符串拆分为字符数组，每个字符前添加 '§'，然后拼接成字符串
    return input.split('').map(char => `§${char}`).join('');
}

function removeSectionSymbols(input) {
    // 去除所有 '§' 符号
    return input.replace(/§/g, '');
}

function padStart(input, targetLength, padChar = ' ') {
    // 如果目标长度小于等于原字符串长度，直接返回原字符串
    if (targetLength <= input.length) {
        return input;
    }

    // 计算需要填充的长度
    const padLength = targetLength - input.length;

    // 生成填充字符串
    const padding = padChar.repeat(padLength);

    // 将填充字符串添加到原字符串的开头
    return padding + input;
}