// ⬜⬜⬜🏿🏿🏿🏻🏻🏻🏻
// ⬜⬜🏿🏿🏾🏾🏿🏻🏻🏻
// ⬜⬜🏿🏼🏽🏽🏼🏻🏻🏻
// ⬜⬜🏾🏽🏽🏽🏽🏻🏻🏻
// ⬜⬜🏾🏼🏽🏽🏼🏻🏻🏻
// ⬜⬜⬜🏾🏼🏼🏼🏻🏻🏻
// ⬜⬜⬜🏽🏾🏾🏻🏻🏻🏻
// ⬜⬜⬜🏼🏼🏽🏻🏻🏻🏻
// ⬜🏿🏿🏿🏿🏼🏿🏿🏻🏻//ジョゼフ・ジョスダはあなたが
// 🏿🏿🏿🏿🏿🏿🏿🏿🏿🏿​//乔瑟夫・乔斯达是你在看我吧！

//-----------------------------------------------------
//导入
//________________________________________________________________
import { world, system, ItemStack } from '@minecraft/server';
import { ActionFormData, ModalFormData } from '@minecraft/server-ui';
import { registerAsync, register } from '@minecraft/server-gametest';
import { score, set } from './score.js';
import { timeStop, timeStopEffect } from './timeStop.js';
import { attack, idAttack, getEntites } from './base/attack.js';
import { fightSkill, playerFsInitialize } from 'enhancement/dna.js'
import * as ui from './ui.js';
import * as summon from './base/summon.js';
import * as defend from './base/defend.js';
import { stepOnMet } from './ores/met.js';
import { standName } from 'disc/disc.js';
import { attackGetStand } from 'disc/arrow.js';
import { dio1_cd, dio1 } from 'monster/dio.js';
import { defendData } from 'base/defend.js';
import { upToNext } from 'sports/sports.js';
import { addEvent, removeEvent } from 'events/events.js';
import { playerResetFs, playerGetFs } from 'enhancement/dna.js';
import './items/diamond_sword.js';
import './items/book.js';
import './timeStop.js';
import './menu.js';
import './base/summon.js';
import './base/defend.js';
import './disc/disc.js';
import './disc/arrow.js';
import './combo/combo.js';
import './npc/npc.js';
import './npc/artist.js';
import './npc/jojo3.js';
import './enhancement/gb.js';
import './enhancement/dna.js';
import './monster/jj.js';
import './monster/dio.js';
import './monster/zombie.js';
import './ores/met.js';
import './items/roller.js';
import './items/dio_bag.js';
import './events/events.js';
import './sports/sports.js';

//-----------------------------------------------------
//一大堆替身
//________________________________________________________________

import './stands/sptw.js';
import './stands/kq.js';
import './stands/e3.js';
import './stands/cd.js';
import './stands/e.js';
import './stands/th.js';
import './stands/cp.js';
import './stands/hw.js';
import './stands/bc.js';
import './stands/tw.js';
import './stands/items/anbss.js';
import { sptw } from './stands/sptw.js';
import { kq } from './stands/kq.js';
import { e3 } from './stands/e3.js';
import { cdStand } from './stands/cd.js';
import { cp } from './stands/cp.js';
import { hw } from './stands/hw.js';
import { bc } from './stands/bc.js';
import { tw } from './stands/tw.js';
import { anbssAttack, anbs } from './stands/items/anbss.js';


//-----------------------------------------------------
//循环
//________________________________________________________________

system.runInterval(() => {
    for (const player of world.getPlayers()) {
        switch (score(player, "stand_type_id")) {
            case 1:
                sptw(player)
                break;
            case 2:
                kq(player)
                break;
            case 3:
                e3(player)
                break;
            case 4:
                cdStand(player)
                break;
            case 6:
                cp(player)
                break;
            case 7:
                hw(player)
                break;
            case 8:
                bc(player)
                break;
            case 9:
                tw(player)
                break;
        }
        
        anbs_player(player)
        timeStopEffect(player)
    }
}, 1)

system.runInterval(() => {
    for (const player of world.getPlayers()) {
    
        playerInitialize(player)
        timeStop(player)
        talentEffect(player)
        armorEffect(player)
        level8energy8(player)
        summon.playerSneaking(player)
        defend.playerDefend(player)
        stepOnMet(player)
        triggerEvent(player)
        upToNext(player)

        player.removeTag("paper")
        player.runCommand("scoreboard players set @s[scores={xuhua=0}] stand_fpp_invisibility 1")

        if (!player.hasTag("be_stopped_of_time")) {
            cd(player)
        }

        if (score(player, "aux_damage") > 0 && score(player, "stand_summon") > 0 && score(player, "stand_type_id") != 0 && !player.hasTag("be_stopped_of_time")) {
            skill(player)
        } else {
            player.runCommand("clear @s stand:skill")
        }
        if ((score(player, "stand_type_id") == 1 || score(player, "stand_type_id") == 9 ) && !player.hasTag("be_stopped_of_time_true")) {
            player.runCommand(`scoreboard players set @s active_in_ts ${parseInt(score(player, "stand_level")/5)}`)
        }
        if (score(player, "stand_type_id") == 1 || score(player, "stand_type_id") == 9) {} else {
            player.runCommand(`scoreboard players set @s active_in_ts 0`)
        }
        

        if (player.hasTag("drill")) {
            player.runCommand("kill @a[name=训练人偶(1)]")
            player.runCommand("kill @a[name=训练人偶(2)]")
            player.runCommand("kill @a[name=训练人偶(3)]")
            player.runCommand("kill @a[name=训练人偶(4)]")
            player.runCommand("kill @a[name=dabusi169(2)]")
            player.runCommand("kill @a[name=dabusi169(3)]")
            player.runCommand("kill @a[name=dabusi169(4)]")
        }

        player.runCommand("scoreboard players set @s[scores={stand_type_id=!4}] angry 0")
        player.runCommand("scoreboard players remove @s[scores={reset_cd=1..}] reset_cd 1")
        player.runCommand("scoreboard players set @s[scores={stand_energy=..0}] stand_energy 0")
        player.runCommand("scoreboard players set @s[scores={stand_energy=100..}] stand_energy 100")
        player.runCommand("scoreboard players set @s[scores={stand_level=..0}] stand_level 0")
        player.runCommand("scoreboard players set @s[scores={stand_level=100..}] stand_level 100")
        player.runCommand("scoreboard players set @s stop_time " + score(player, "stand_level"))
        player.runCommand("scoreboard players set @s selectedSlot " + player.selectedSlotIndex)
        player.runCommand("tag @s[m=creative] add 创造模式")
        player.runCommand("tag @s[m=!creative] remove 创造模式")

    }
}, 2)

system.runInterval(() => {
    for (const player of world.getPlayers()) {
        if (player.hasTag("ui")) {
            ui.repeat(player);
        }
    }
}, 2.5)

system.runInterval(() => {
    for (const player of world.getPlayers()) {
        player.removeTag("invisibility")
        try {
            const invisibility = player.getEffect("invisibility").amplifier
            if (invisibility >= 0) {
                player.addTag("invisibility")
            }
        } catch (e) {}
        if (!player.hasTag("invisibility") && player.hasTag("jojogo")) {
            let pL = player.location
            pL.y += 1
            player.spawnParticle("stand:jojogo", pL)
        }
    }
}, 4)

system.beforeEvents.watchdogTerminate.subscribe(event => {
    event.cancel = true
})

//-----------------------------------------------------
//事件
//________________________________________________________________

system.afterEvents.scriptEventReceive.subscribe(event => {
    const player = event.sourceEntity;
    const id = event.id;
    const message = event.message;
    if (id == "stand:eval") {
        try {
            eval(message)
        } catch (error) {
            world.sendMessage(`${error}`)
        }
    }
})

world.afterEvents.worldInitialize.subscribe(() => {
    world.getDimension("overworld").runCommand("function WorldScoreInitialize")
    if (!world.getDynamicProperty("break")) {
        world.setDynamicProperty("break", "no")
    }
    if (!world.getDynamicProperty("event_open")) {
        world.setDynamicProperty("event_open", "yes")
    }
})

world.afterEvents.itemStartUse.subscribe(event => {
    const item = event.itemStack;
    const player = event.source;
    player.runCommand("tag @s[tag=!be_stopped_of_time] add detect_attack")
});

world.afterEvents.itemUseOn.subscribe(event => {
    const item = event.itemStack;
    const player = event.source;
    const block = event.block;
    if (item.typeId == "stand:roller_spawn_egg" || item.typeId == "stand:roller_spawn_egg") {
    if (block.typeId != "minecraft:mob_spawner") return;
        player.runCommand(`setblock ${block.x} ${block.y} ${block.z} air`)
    }
});

world.afterEvents.itemUse.subscribe(event => {
    const item = event.itemStack;
    const player = event.source;
    if (item.typeId == "stand:skill") return;
    player.runCommand("tag @s[tag=!be_stopped_of_time] add detect_attack")
    system.runTimeout(() => {
        player.runCommand("tag @s remove detect_attack")
    }, 1)
});

world.afterEvents.itemStopUse.subscribe(event => {
    const item = event.itemStack;
    const player = event.source;
    player.runCommand("tag @s remove detect_attack")
});


world.afterEvents.entityDie.subscribe(event => {
    const entity = event.deadEntity
    try {
        entity.runCommand("scoreboard players add @a[r=5] stand_energy 5")
        
        if (entity.typeId == "minecraft:player") {
            if (score(entity, "stand_type_id") == 6) {
                entity.runCommand("scoreboard players set @s stand_summon 0")
                entity.runCommand(`kill @e[name="${entity.name}",type=stand:players]`)
            }
            entity.runCommand("function PlayerScoreInitialize")
        }
        if (entity.typeId == "stand:jojo3" && !entity.hasTag("be_stopped_of_time")) {
            entity.runCommand(`tellraw @a[r=10] {"rawtext":[{"translate": "jojo3.tellraw"}]}`)
        }
        if (entity.typeId == "stand:dio1" && !entity.hasTag("be_stopped_of_time")) {
            entity.runCommand(`tellraw @a[r=20] {"rawtext":[{"translate": "dio1.tellraw"}]}`)
        }
        if (entity.typeId == "stand:roller" && !entity.hasTag("dio_summon")) {
            let newItem = new ItemStack("stand:roller_spawn_egg", 1)
            entity.dimension.spawnItem(newItem, entity.location)
        }
        if (entity.typeId == "stand:ec") {
            let newItem = new ItemStack("minecraft:emerald", 1)
            entity.dimension.spawnItem(newItem, entity.location)
            if (!entity.hasTag("be_stopped_of_time")) return;
            entity.runCommand(`tellraw @a[r=10] {"rawtext":[{"translate": "ec.tellraw"}]}`)
        }
        if (entity.typeId == "stand:dz") {
            let newItem = new ItemStack("minecraft:emerald", 1)
            entity.dimension.spawnItem(newItem, entity.location)
            if (!entity.hasTag("be_stopped_of_time")) return;
            entity.runCommand(`tellraw @a[r=10] {"rawtext":[{"translate": "dz.tellraw"}]}`)
        }
        if (entity.typeId == "stand:jj" && !entity.hasTag("be_stopped_of_time")) {
            entity.runCommand(`tellraw @a[r=10] {"rawtext":[{"translate": "jj.tellraw2"}]}`)
        }
        if (entity.typeId == "stand:players") {
            entity.runCommand("kill @e[r=3,type=item]")
            entity.runCommand(`tp @a[name="${entity.nameTag}"] @s`)
            entity.runCommand(`scoreboard players set @a[name="${entity.nameTag}"] stand_summon 0`)
        }
        if (entity.typeId == "stand:anbs_player") {
            entity.runCommand("kill @e[r=3,type=item]")
        }
        entity.removeTag(`id${entity.id}`)
    } catch (e) {}
})

world.afterEvents.entityHurt.subscribe(event => {
    try {
        const entity = event.hurtEntity;
        const damagingEntity = event.damageSource.damagingEntity
        const damage = event.damage
        
        
        try {
            if (entity.typeId== "minecraft:player" && damagingEntity.typeId== "minecraft:player") {
                const item = damagingEntity.getComponent("minecraft:inventory").container.getItem(damagingEntity.selectedSlotIndex)
                attackGetStand(entity, damagingEntity, item)
            }
        } catch(error) {
            // world.sendMessage(`${error}`)
        }
        
        try {
            if (score(damagingEntity, "stand_type_id") == 2 && damagingEntity.typeId == "minecraft:player" && entity.nameTag != `§d${damagingEntity.nameTag} 枯萎穿心攻击`) {
                const car = damagingEntity.dimension.getEntities({
                    name: `§d${damagingEntity.nameTag} 枯萎穿心攻击`,
                    type: "stand:sheer_heart_attack"
                })[0];
                entity.runCommand(`tag @s add "attack${entity.id}"`)
                
                let oh = car.getComponent("minecraft:health").currentValue
                car.runCommand("effect @s instant_health 1 254 true")
                    
                car.runCommand(`damage @s 0 magic entity @e[tag="attack${entity.id}",c=1]`)
                entity.runCommand(`tag @e remove "attack${entity.id}"`)
                
                system.runTimeout(() => {
                    car.runCommand("effect @s instant_health 0 255 true")
                    car.getComponent("minecraft:health").setCurrentValue(oh)
                }, 1)
            }
            if (damagingEntity.typeId == "stand:sheer_heart_attack" && damagingEntity.id != entity.id) {
                entity.runCommand("playsound random.explode @a[r=20] ~~~ ")
                entity.runCommand("particle minecraft:huge_explosion_lab_misc_emitter ~~~")
                entity.runCommand("summon stand:boom ~ ~ ~ ~ ~ minecraft:explode")
            }
        } catch (error) {}
        
        try {
            if (damagingEntity.typeId == "stand:jj" && !entity.hasTag(`jj:${entity.id}`)) {
                const car = damagingEntity.dimension.getEntities({
                    tags: [`jj:${damagingEntity.id}`],
                    type: "stand:sheer_heart_attack"
                })[0];
                
                let oh = car.getComponent("minecraft:health").currentValue
                car.runCommand("effect @s instant_health 1 254 true")
                
                entity.runCommand(`tag @s add "attack${entity.id}"`)
                car.runCommand(`damage @s 0 magic entity @e[tag="attack${entity.id}",c=1]`)
                entity.runCommand(`tag @e remove "attack${entity.id}"`)
                
                system.runTimeout(() => {
                    car.runCommand("effect @s instant_health 0 255 true")
                    car.getComponent("minecraft:health").setCurrentValue(oh)
                }, 1)
            }
        } catch (error) {}
        
        try {
            if (score(damagingEntity, "stand_type_id") == 7 && damagingEntity.typeId == "minecraft:player" && entity.nameTag != `§b${damagingEntity.nameTag} 公路之星`) {
                const footprints = damagingEntity.dimension.getEntities({
                    name: `§b${damagingEntity.nameTag} 公路之星`,
                    type: "stand:footprints"
                })[0];
                entity.runCommand(`tag @s add "attack${entity.id}"`)
                
                let oh = footprints.getComponent("minecraft:health").currentValue
                footprints.runCommand("effect @s instant_health 1 254 true")
                    
                footprints.runCommand(`damage @s 0 magic entity @e[tag="attack${entity.id}",c=1]`)
                entity.runCommand(`tag @e remove "attack${entity.id}"`)
                
                system.runTimeout(() => {
                    footprints.runCommand("effect @s instant_health 0 255 true")
                    footprints.getComponent("minecraft:health").setCurrentValue(oh)
                }, 1)
                if (score(damagingEntity, "stand_level") == 100) {
                    const footprints2 = damagingEntity.dimension.getEntities({
                        name: `§b${damagingEntity.nameTag} 公路之星`,
                        type: "stand:footprints"
                    })[1];
                    entity.runCommand(`tag @s add "attack${entity.id}"`)
                    
                    oh = footprints2.getComponent("minecraft:health").currentValue
                    footprints2.runCommand("effect @s instant_health 1 254 true")
                    
                    footprints2.runCommand(`damage @s 0 magic entity @e[tag="attack${entity.id}",c=1]`)
                    entity.runCommand(`tag @e remove "attack${entity.id}"`)
                    
                    system.runTimeout(() => {
                        footprints2.runCommand("effect @s instant_health 0 255 true")
                        footprints2.getComponent("minecraft:health").setCurrentValue(oh)
                    }, 1)
                }
            }
            if (damagingEntity.typeId == "stand:footprints" && damagingEntity.id != entity.id) {
                entity.runCommand(`effect @e[name="${damagingEntity.nameTag.replace("§b", "").replace(" 公路之星", "")}"] regeneration 4 2`)
                entity.runCommand(`scoreboard players add @e[name="${damagingEntity.nameTag.replace("§b", "").replace(" 公路之星", "")}"] stand_energy 5`)
                entity.runCommand("effect @s regeneration 5 3")
                entity.runCommand("playsound random.drink @a ~~~ 100 1 0")
                entity.runCommand("particle minecraft:heart_particle ~ ~0.15 ~")
            }
        } catch (e) {}
        
        try {
            if (score(damagingEntity, "stand_type_id") == 8 && damagingEntity.typeId == "minecraft:player" && entity.nameTag != `§a${damagingEntity.nameTag} 极恶中队`) {
                const entities = damagingEntity.dimension.getEntities({
                    name: `§a${damagingEntity.nameTag} 极恶中队`,
                    families: ["bc"]
                });
                for (const bc of entities) {
                    entity.runCommand(`tag @s add "attack${entity.id}"`)
                    
                    let oh = bc.getComponent("minecraft:health").currentValue
                    bc.runCommand("effect @s instant_health 1 254 true")
                    
                    bc.runCommand(`damage @s 0 magic entity @e[tag="attack${entity.id}",c=1]`)
                    entity.runCommand(`tag @e remove "attack${entity.id}"`)
                    
                    system.runTimeout(() => {
                        bc.runCommand("effect @s instant_health 0 255 true")
                        bc.getComponent("minecraft:health").setCurrentValue(oh)
                    }, 1)
                }
            }
        } catch (e) {}
        
        if (entity.hasTag("be_stopped_of_time")) {
            const damage = event.damage
            entity.runCommand("scoreboard players add @s ts_damage " + parseInt(damage))
            entity.getComponent("minecraft:health")
                .setCurrentValue(entity.getComponent("minecraft:health")
                .currentValue + damage)
        }
        if (entity.hasTag("SimulatedPlayer")) {
            if (damagingEntity.typeId == "minecraft:player") {
                const health = parseInt(entity.getComponent("minecraft:health")
                    .currentValue)
                entity.runCommand("title " + damagingEntity.name + " actionbar §c" + health)
            }
        }
        if (damagingEntity.typeId == "minecraft:player" && score(damagingEntity, "stand_type_id") != 6) {
            entity.runCommand(`execute as @s[family=!bc,type=!stand:sheer_heart_attack,type=!stand:footprints] at @s run scoreboard players add @a[name="${damagingEntity.name}"] stand_energy 3`)
        }
        if (damagingEntity.typeId == "stand:ec") {
            entity.runCommand("effect @s nausea 20 1")
        }
    } catch (error) {}
})

world.afterEvents.entityDie.subscribe((event) => {
    const entity = event.deadEntity
    try {
        if (entity.typeId === "minecraft:player") {
            entity.disconnect()
        }
    } catch (err) {}
});

//-----------------------------------------------------
//函数
//________________________________________________________________

function anbs_player(player) {
    if (player.hasTag("anbs_player")) {
        const anbs_player_ = player.dimension.getEntities({
            name: `§d${player.nameTag} 阿努比斯神`,
            type: "stand:anbs_player"
        });
        if (!anbs_player_[0]) {
            player.removeTag("anbs_player")
        }
    }
}

function talentEffect(player) {
    let speed = 0
    let slowness = 0
    try {
        speed = player.getEffect("speed").amplifier + 1
    } catch (e) {}
    try {
        slowness = player.getEffect("slowness").amplifier + 1
    } catch (e) {}
    if (score(player, "speed") != 0 && !player.hasTag("no_use_speed")) {
        // player.runCommand(`effect @s speed ${score(player, "speed") != 0 ? 1 : 0} ${(score(player, "speed") -1) != -1 ? (score(player, "speed") -1) : 0} true`)
        let movement = (score(player, "speed")*0.015-slowness*0.03+speed*0.015)+0.12
        if (player.isSprinting || player.isJumping) {
            movement = movement + 0.03
        }
        player.getComponent("minecraft:movement").setCurrentValue(movement)
        if (score(player, "speed") == 3) {
            player.runCommand("effect @s jump_boost 1 1 true")
        }
    }
    let hb = -1
    try {
        hb = player.getEffect("health_boost").amplifier
    } catch (e) {}
    if (hb != (score(player, "healthy") - 1) && score(player, "healthy") != 0 && !player.hasTag("time_stop_health")) {
        player.runCommand(`effect @s health_boost 114514 ${score(player, "healthy") - 1} true`)
        player.runCommand("effect @s instant_health 1 255 true")
        system.runTimeout(() => {
            player.runCommand("effect @s instant_health 0 255 true")
        }, 2)
    }
}

function level8energy8(player) {
    player.runCommand("scoreboard players set @s[tag=level8] stand_level 100")
    player.runCommand("scoreboard players set @s[tag=energy8] stand_energy 100")
}

function playerInitialize(player) {
    if (!player.hasTag("playerInitialize")) {
        player.addTag("playerInitialize")
        player.runCommand("function ScoreInitialize");
        player.runCommand("function PlayerSetScoreInitialize");
        set(player, "stand_type_id", 0)
        set(player, "stand_summon", 0)
        playerFsInitialize(player)
    }
    if (!player.hasTag("give_arrow")) {
        player.addTag("give_arrow")
        player.runCommand("give @s johnny3150:stand_arrow 1 2")
    }
    if (!player.hasTag("give_setting")) {
        player.addTag("give_setting")
        player.runCommand("give @s stand:setting")
    }
    if (!player.hasTag("give_guide_book")) {
        player.addTag("give_guide_book")
        player.runCommand("give @s stand:guide_book")
    }
}

function cd(player) {
    player.runCommand("scoreboard players remove @s[scores={stand_skill_cd_1=1..}] stand_skill_cd_1 1")
    player.runCommand("scoreboard players remove @s[scores={stand_skill_cd_2=1..}] stand_skill_cd_2 1")
    player.runCommand("scoreboard players remove @s[scores={stand_skill_cd_3=1..}] stand_skill_cd_3 1")
    player.runCommand("scoreboard players remove @s[scores={stand_skill_cd_4=1..}] stand_skill_cd_4 1")
    player.runCommand("scoreboard players remove @s[scores={stand_skill_cd_1=1..}] stand_skill_cd_1 1")
    player.runCommand("scoreboard players remove @s[scores={stand_skill_cd_2=1..}] stand_skill_cd_2 1")
    player.runCommand("scoreboard players remove @s[scores={stand_skill_cd_3=1..}] stand_skill_cd_3 1")
    player.runCommand("scoreboard players remove @s[scores={stand_skill_cd_4=1..}] stand_skill_cd_4 1")
}

function setItem(player, num) {
    try {
        const container = player.getComponent("minecraft:inventory").container;
        let item = container.getItem(num);
        if (item) {
            if (item.typeId == "stand:skill" && num > 3 || item.typeId == "stand:skill" && num != player.selectedSlotIndex) {
            let air = new ItemStack("minecraft:air", 1)
                container.setItem(num, air)
            }
        }
    } catch (error) {
        // world.sendMessage(`${error}`)
    }
}

function skill(player) {
    const typeId = "stand:skill";
    if (player.selectedSlotIndex < 4) {
        player.runCommand(`replaceitem entity @s slot.hotbar ${player.selectedSlotIndex} keep ${typeId} 1 0 {
            "minecraft:item_lock": {
                "mode": "lock_in_inventory"
            }
        }`)
    }
    for (var i = 0; i < 35; i++) {
        setItem(player, i)
    }
}

function item2(entity) {
    for (var i = 0; i < 35; i++) {
        entity.runCommand(`replaceitem entity @s slot.inventory ${i} keep stand:skill2 1 0 {
                "minecraft:item_lock": {
                "mode": "lock_in_inventory"
                }
            }`)
    }
    for (var i = 0; i < 8; i++) {
        entity.runCommand(`replaceitem entity @s slot.hotbar ${i} keep stand:skill2 1 0 {
                "minecraft:item_lock": {
                "mode": "lock_in_inventory"
                }
            }`)
    }
}

function armorEffect(player) {
    player.removeTag("jojo3")
    player.runCommand(`tag 
        @s[hasitem=
                 [
                     {item=stand:jo3mz,quantity=1,location=slot.armor.head},
                     {item=stand:jo3dy,quantity=1,location=slot.armor.chest},
                     {item=stand:jo3ck,quantity=1,location=slot.armor.legs},
                     {item=stand:jo3cx,quantity=1,location=slot.armor.feet}
                 ]
            ]
        add jojo3
    `)
    player.runCommand(`effect 
        @s[hasitem=
                 [
                     {item=stand:bwfd,quantity=1,location=slot.armor.head},
                     {item=stand:bwdy,quantity=1,location=slot.armor.chest},
                     {item=stand:bwck,quantity=1,location=slot.armor.legs},
                     {item=stand:bwcx,quantity=1,location=slot.armor.feet}
                 ]
            ]
        village_hero 2 1 true
    `)
    player.runCommand(`effect 
        @s[hasitem=
                 [
                     {item=stand:xsgfd,quantity=1,location=slot.armor.head},
                     {item=stand:xsgdy,quantity=1,location=slot.armor.chest},
                     {item=stand:xsgck,quantity=1,location=slot.armor.legs},
                     {item=stand:xsgcx,quantity=1,location=slot.armor.feet}
                 ]
            ]
        strength 2 2 true
    `)

}

export function triggerEvent(player) {
    if (score(player, "xuhua") == 1 && !defendData[player.name]["isDefend"]) {
        if (score(player, "stand_fpp_invisibility") != 0) {
            player.triggerEvent("sync:stand_fpp_invisibility_false")
        } else {
            player.triggerEvent("sync:stand_fpp_invisibility_true")
        };
    }
    if (score(player, "xuhua") == 1 && defendData[player.name]["isDefend"]) {
        player.triggerEvent("sync:stand_fpp_invisibility_true")
    }
    if (score(player, "xuhua") == 0) {
        player.triggerEvent("sync:stand_fpp_invisibility_false")
    }
    if (player.hasTag("jojo3")) {
        player.triggerEvent("sync:sp_true")
    } else {
        player.triggerEvent("sync:sp_false")
    };
    let tr = score(player, "tr")
    let tg = score(player, "tg")
    let tb = score(player, "tb")
    let ta = score(player, "ta")
    
    set(player, "r", tr)
    set(player, "g", tg)
    set(player, "b", tb)
    set(player, "a", ta)
    
    if (player.hasTag("crazy")) {
        set(player, "r", 20)
        set(player, "g", 0)
        set(player, "b", 0)
        set(player, "a", 2)
    }

    player.triggerEvent("sync:stand_time_stop_hud_invisibility")
    player.triggerEvent("sync:stand_type_id")
    player.triggerEvent("sync:stand_invisibility")
    player.triggerEvent("sync:offset_x")
    player.triggerEvent("sync:offset_z")
    player.triggerEvent("sync:stand_summon")
    player.triggerEvent("sync:r")
    player.triggerEvent("sync:g")
    player.triggerEvent("sync:b")
    player.triggerEvent("sync:a")
}

function attack2(player, entity) {
    entity.applyDamage(0, {
        cause: "entityAttack",
        damagingEntity: player
    })
}

//-----------------------------------------------------
//Gametest
//________________________________________________________________

register("人偶", "创建", (test) => {
    {
        var SimulatedPlayer = test.spawnSimulatedPlayer({
            x: 0,
            y: -60,
            z: 0
        }, "训练人偶")
        SimulatedPlayer.runCommand("tag @s[tag=!SimulatedPlayer] add SimulatedPlayer")
        SimulatedPlayer.runCommand("tag @s[tag=SimulatedPlayer] add drill")
        SimulatedPlayer.runCommand("tp @p[tag=!SimulatedPlayer]")
        SimulatedPlayer.runCommand("effect @s health_boost 114514 39 true")
        SimulatedPlayer.runCommand("effect @s instant_health 1 255 true")
    }
})
    .maxTicks(20 * 60 * 60 * 24 * 365)
    .structureName("xboyMinemcSIM:void");

register("小强", "创建", (test) => {
    {
        var SimulatedPlayer = test.spawnSimulatedPlayer({
            x: 0,
            y: -60,
            z: 0
        }, "dabusi169")
        SimulatedPlayer.runCommand("tag @s[tag=!SimulatedPlayer] add SimulatedPlayer")
        SimulatedPlayer.runCommand("tag @s[tag=SimulatedPlayer] add drill")
        SimulatedPlayer.runCommand("tp @p[tag=!SimulatedPlayer]")
        SimulatedPlayer.runCommand("effect @s health_boost 114514 39 true")
        SimulatedPlayer.runCommand("effect @s instant_health 1 255 true")
    }
})
    .maxTicks(20 * 60 * 60 * 24 * 365)
    .structureName("xboyMinemcSIM:void");