//-----------------------------------------------------
//导入
//________________________________________________________________

import { ItemStack, world, system } from '@minecraft/server';
import { score, set } from 'score.js';
import { events, haveEvent } from 'events/events.js';
import { attack, projectile,  getEntites, breakBlock } from 'base/attack.js';
import { twSkill, attacks } from 'stands/tw.js';

//-----------------------------------------------------
//迪奥1
//________________________________________________________________

export let dio1_cd ={
    "dio1:id": {
        "ice": 0,
        "eye_shoot": 0
    }
}

world.afterEvents.entityHurt.subscribe(event => {
    try {
        const entity = event.hurtEntity;
        const damagingEntity = event.damageSource.damagingEntity
        const cause = event.damageSource.cause;
        if (damagingEntity.hasTag("be_stopped_of_time"))return;
        if (damagingEntity.hasTag("dio") && cause == "entityAttack") {
            system.runTimeout(() => {
                if (!entity.hasTag("defend:true")) {
                    damagingEntity.runCommand("particle minecraft:camera_shoot_explosion ~~1.25~")
                    damagingEntity.runCommand("playsound no_do_human @a ~~~ 100 1 0")
                    damagingEntity.runCommand("playsound stone_mask_become @a ~~~ 100 1 0")
                    damagingEntity.runCommand("summon stand:dio1 ~~~")
                    damagingEntity.runCommand("summon minecraft:zombie ~~~")
                    damagingEntity.runCommand("summon minecraft:zombie ~~~")
                    damagingEntity.runCommand("summon minecraft:zombie ~~~")
                    damagingEntity.runCommand("summon minecraft:zombie ~~~")
                    damagingEntity.remove()
                }
            }, 0.01)
        }
        if (damagingEntity.typeId == "stand:dio1") {
            damagingEntity.runCommand("scoreboard players add @s mr.level 1")
            if (score(damagingEntity, "mr.level") >= 5) {
                damagingEntity.runCommand("particle minecraft:camera_shoot_explosion ~~1.25~")
                damagingEntity.runCommand("summon stand:dio3 ~~~")
                damagingEntity.remove()
            }
        }
    } catch (error) {}
})

world.afterEvents.entityHurt.subscribe(event => {
    try {
        const entity = event.hurtEntity;
        const damagingEntity = event.damageSource.damagingEntity
        const cause = event.damageSource.cause;
        if (damagingEntity.hasTag("be_stopped_of_time"))return;
        if (damagingEntity.typeId == "stand:dio1" && cause == "entityAttack") {
            system.runTimeout(() => {
                if (!entity.hasTag("defend:true")) {
                    if (dio1_cd[damagingEntity.id]["ice"] == 0) {
                        dio1_cd[damagingEntity.id]["ice"] = 100
                        ice(entity)
                    }
                }
            }, 0.01)
        }
    } catch (error) {}
})

export function dio1(entity) {
    if (!dio1_cd[entity.id]) {
        dio1_cd[entity.id] = {
            "ice": 0,
            "eye_shoot": 0
        }
    }
    if (dio1_cd[entity.id]["ice"] > 0) {
        dio1_cd[entity.id]["ice"] -= 1
    }
    if (dio1_cd[entity.id]["eye_shoot"] > 0) {
        dio1_cd[entity.id]["eye_shoot"] -= 1
    }
    if (entity.target && !entity.hasTag("be_stopped_of_time")) {
        var points = [entity.target.location, entity.location];
        points.dist = function() {
            var p1 = this[0];
            var p2 = this[1];
            var a = p2.x - p1.x;
            var b = p2.z - p1.z;
            var c = p2.y - p1.y;
            return Math.sqrt(a * a + b * b + c * c);
        };
        if (points.dist() > 4 && points.dist() < 30) {
            if (dio1_cd[entity.id]["eye_shoot"] == 0) {
                dio1_cd[entity.id]["eye_shoot"] = 300
                eye_shoot(entity)
            }
        }
    }
}

//冰冻
function ice(entity) {
    entity.runCommand("particle stand:ice ~~1.25~")
    entity.runCommand("playsound random.glass @a ~~~ 100 1 0")
    entity.runCommand("effect @s slowness 5 1 true")
    entity.runCommand("damage @s 2 freezing")
}

//空裂眼刺惊
function eye_shoot(player) {
    player.runCommand("particle stand:sonic_explosion ^^1.5^1")
    let detect = "";
    let detect2 = "";
    for (let i = 0; i < 30; i++) {
        detect = `${detect} if block ^-0.15^1.5^${1+i} air `
        detect2 = `${detect2} if block ^0.15^1.5^${1+i} air `
        player.runCommand(`execute as @s at @s ${detect} anchored eyes run particle stand:eye_shoot ^-0.15^^${1+i}`)
        player.runCommand(`execute as @s at @s ${detect2} anchored eyes run particle stand:eye_shoot ^0.15^^${1+i}`)
    };
    shoots(player, 30, 5)
    player.runCommand("playsound mob.witch.drink @a ~~~ 100 1.5 0")
    player.runCommand("effect @s blindness 3 1 true")
}

//射击
function shoots(player, damage, kc) {
    let entities = getEntites(player, 30)
    for (let i = 0; i < entities.length; i++) {
        projectile(player, entities[i].entity, damage, kc, entities[i].distance)
    }
}

//-----------------------------------------------------
//迪奥3(兼high)
//________________________________________________________________

world.afterEvents.entityDie.subscribe((event) => {
    const entity = event.deadEntity;
    if (entity.typeId == "stand:dio3") {
        entity.runCommand("particle minecraft:camera_shoot_explosion ~~1.25~")
        entity.runCommand("summon stand:dio3h ~~~")
        entity.runCommand(`tellraw @a[r=10] {"rawtext":[{"translate": "dio3.tellraw"}]}`)
        entity.remove()
    }
    if (entity.typeId == "stand:dio3h") {
        let newItem = new ItemStack("stand:dio_bag", 1)
        entity.dimension.spawnItem(newItem, entity.location)
    }
});

export let dio3_cd ={
    "dio3:id": {
        "fly_sword": 0
    }
}

const co = ["a", "b", "c"]

world.afterEvents.entityHurt.subscribe(event => {
    try {
        const entity = event.hurtEntity;
        const damagingEntity = event.damageSource.damagingEntity;
        const cause = event.damageSource.cause;
        if (damagingEntity.hasTag("be_stopped_of_time"))return;
        if (damagingEntity.typeId != "stand:dio3" || cause == "magic" || cause == "ramAttack") return;
        damagingEntity.runCommand("scoreboard players add @s mr.co 0")
        damagingEntity.runCommand("scoreboard players add @s mr.level 5")

        let animation = co[score(damagingEntity, "mr.co")]
        let skill = new twSkill(damagingEntity)
        
        //普攻
        if (animation == "a" || animation == "b") {
            damagingEntity.removeTag("barrage")
            if (damagingEntity.hasTag("time_attack")) {
                skill.whack()
                damagingEntity.removeTag("time_attack")
                damagingEntity.runCommand("scoreboard players set @s stand_skill_cd_2 100")
            } else {
                skill.m(animation)
            }
        }
        
        //连打
        if (animation == "c" && !damagingEntity.hasTag("barrage")) {
            damagingEntity.addTag("barrage")
            skill.barrage()
            system.runTimeout(() => {
                damagingEntity.removeTag("barrage")
                damagingEntity.runCommand("scoreboard players add @s mr.co 1")
                if (damagingEntity.hasTag("boss2")) {
                    skill.tpEntity()
                }
            }, 50)
        }

        if (!damagingEntity.hasTag("barrage")) {
            damagingEntity.runCommand("scoreboard players add @s mr.co 1")
        }
        damagingEntity.runCommand("scoreboard players set @s[scores={mr.co=4..}] mr.co 0")
        damagingEntity.runCommand("scoreboard players set @s[scores={mr.level=100..}] mr.level 100")
    } catch (error) {}
})

//high
world.afterEvents.entityHurt.subscribe(event => {
    try {
        const entity = event.hurtEntity;
        const damagingEntity = event.damageSource.damagingEntity;
        const cause = event.damageSource.cause;
        if (damagingEntity.hasTag("be_stopped_of_time"))return;
        if (damagingEntity.typeId != "stand:dio3h" || cause == "magic" || cause == "ramAttack") return;
        damagingEntity.runCommand("scoreboard players add @s mr.co 0")
        damagingEntity.runCommand("scoreboard players add @s mr.level 5")

        let animation = co[score(damagingEntity, "mr.co")]
        let skill = new twSkill(damagingEntity)
        
        //普攻
        if (animation == "a" || animation == "b") {
            damagingEntity.removeTag("barrage")
            if (damagingEntity.hasTag("time_attack")) {
                roller(entity)
                damagingEntity.removeTag("time_attack")
            } else {
                skill.m(animation)
            }
        }
        
        //连打
        if (animation == "c" && !damagingEntity.hasTag("barrage")) {
            damagingEntity.addTag("barrage")
            skill.barrage()
            system.runTimeout(() => {
                damagingEntity.removeTag("barrage")
                damagingEntity.runCommand("scoreboard players add @s mr.co 1")
                if (damagingEntity.hasTag("boss2")) {
                    skill.tpEntity()
                }
            }, 50)
        }

        if (!damagingEntity.hasTag("barrage")) {
            damagingEntity.runCommand("scoreboard players add @s mr.co 1")
        }
        damagingEntity.runCommand("scoreboard players set @s[scores={mr.co=4..}] mr.co 0")
        damagingEntity.runCommand("scoreboard players set @s[scores={mr.level=100..}] mr.level 100")
    } catch (error) {}
})

export function dio3(entity) {
    if (!dio3_cd[entity.id]) {
        dio3_cd[entity.id] = {
            "fly_sword": 0
        }
    }
    if (dio3_cd[entity.id]["fly_sword"] > 0) {
        dio3_cd[entity.id]["fly_sword"] -= 1
    }
    
    entity.runCommand("scoreboard players set @s stand_level 100")
    entity.runCommand("scoreboard players set @s time_stop 100")
    entity.runCommand("scoreboard players add @s stand_skill_cd_2 0")
    if (entity.typeId == "stand:dio3h") {
        entity.runCommand("scoreboard players set @s stand_skill_cd_2 0")
    }
    entity.runCommand("scoreboard players add @s mr.level 0")
    if (system.currentTick % 30 === 0) {
        entity.runCommand("scoreboard players add @s mr.level 1")
        entity.runCommand("scoreboard players set @s[scores={mr.level=100..}] mr.level 100")
    }
    if (!entity.hasTag("be_stopped_of_time_true") && entity.hasTag("boss2")) {
        entity.runCommand(`scoreboard players set @s active_in_ts 20`)
    }
    if (entity.target && !entity.hasTag("be_stopped_of_time")) {
        var points = [entity.target.location, entity.location];
        points.dist = function() {
            var p1 = this[0];
            var p2 = this[1];
            var a = p2.x - p1.x;
            var b = p2.z - p1.z;
            var c = p2.y - p1.y;
            return Math.sqrt(a * a + b * b + c * c);
        };
        if (points.dist() > 5 && points.dist() < 20 && !entity.hasTag("barrage")) {
            if (dio3_cd[entity.id]["fly_sword"] == 0) {
                dio3_cd[entity.id]["fly_sword"] = 40
                let skill = new twSkill(entity)
                entity.runCommand(`tp ~~~ facing @e[tag="id${entity.target.id}"]`)
                skill.m("c")
            }
        }
    }
    let health = parseInt(entity.getComponent("minecraft:health").currentValue)
    if (health <= 199 && !entity.hasTag("boss2")) {
        entity.addTag("boss2")
        let skill = new twSkill(entity)
        entity.runCommand("scoreboard players set @s stand_skill_cd_2 100")
        skill.timeStop()
    }
    if (entity.typeId == "stand:dio3h" && !entity.hasTag("boss2")) {
        entity.addTag("boss2")
        let skill = new twSkill(entity)
        entity.runCommand("scoreboard players set @s[type=!stand:dio3h] stand_skill_cd_2 100")
        skill.timeStop()
    }
    if (score(entity, "mr.level") >= 100 && entity.hasTag("boss2") && !entity.hasTag("barrage")) {
        entity.runCommand("scoreboard players set @s mr.level 0")
        let skill = new twSkill(entity)
        entity.runCommand("scoreboard players set @s[type=!stand:dio3h] stand_skill_cd_2 100")
        skill.timeStop()
    }
}

export function roller(entity) {
    let location = {
        x: entity.location.x,
        y: entity.location.y,
        z: entity.location.z
    }
    const roller = entity.dimension.spawnEntity("stand:roller", location)
    roller.addTag("dio_summon")
    roller.addTag("be_stopped_of_time")
    roller.addTag("be_stopped_of_time_true")
    system.runTimeout(() => {  
        roller.addTag("boom")
    }, 5)
}

//-----------------------------------------------------
//函数
//________________________________________________________________

//取随机整数
function randomNum(minNum, maxNum) {
    switch (arguments.length) {
        case 1:
            return parseInt(Math.random() * minNum + 1, 10);
            break;
        case 2:
            return parseInt(Math.random() * (maxNum - minNum + 1) + minNum, 10);
            break;
        default:
            return 0;
            break;
    }
};
