//-----------------------------------------------------
//导入
//________________________________________________________________

import { ItemStack,  world, system } from '@minecraft/server';
import { ActionFormData, MessageFormData, ModalFormData } from '@minecraft/server-ui';
import { score, set } from 'score.js';
import { attack, projectile, getEntites, breakBlock } from 'base/attack.js';
import { attacks } from 'stands/sptw.js';

//-----------------------------------------------------
//变量
//________________________________________________________________

const co = ["c", "a", "b", "c", "o"]

//-----------------------------------------------------
//事件
//________________________________________________________________

world.afterEvents.entityHurt.subscribe(event => {
    try {
        const entity = event.hurtEntity;
        const damagingEntity = event.damageSource.damagingEntity;
        const cause = event.damageSource.cause;
        if (damagingEntity.typeId != "stand:jojo3" || cause == "magic") return;
        damagingEntity.runCommand("scoreboard players add @s mr.co 0")

        let animation = co[score(damagingEntity, "mr.co")]
        damagingEntity.runCommand("playanimation @s animation.stand.sptw.m1" + animation)
        
        //普攻
        if (animation == "a" || animation == "b") {
            damagingEntity.removeTag("barrage")
            attacks(damagingEntity, 10, 10)
            let ora = randomNum(1, 4)
            damagingEntity.runCommand("playsound ora_" + ora + " @a ~~~ 100 1 0")
        }
        
        //连打
        if (animation == "o" && !damagingEntity.hasTag("barrage")) {
            damagingEntity.runCommand("playanimation @s animation.stand.sptw.barrage")
            damagingEntity.runCommand("playsound barrage_ora @a ~~~ 100 1 0")
            damagingEntity.addTag("barrage")
            let barrage = system.runInterval(() => {
                attacks(damagingEntity, 16, 10)
            }, 4)
            system.runTimeout(() => {
                system.clearRun(barrage)
                damagingEntity.removeTag("barrage")
                damagingEntity.runCommand("scoreboard players add @s mr.co 1")
                system.runTimeout(() => {
                    attacks(damagingEntity, 20, 60)
                }, 2)
            }, 50)
        }

        if (!damagingEntity.hasTag("barrage")) {
            damagingEntity.runCommand("scoreboard players add @s mr.co 1")
        }
        damagingEntity.runCommand("scoreboard players set @s[scores={mr.co=5..}] mr.co 0")
    } catch (error) {}
})

function randomNum(minNum, maxNum) {
    switch (arguments.length) {
        case 1:
            return parseInt(Math.random() * minNum + 1, 10);
            break;
        case 2:
            return parseInt(Math.random() * (maxNum - minNum + 1) + minNum, 10);
            break;
        default:
            return 0;
            break;
    }
};