//-----------------------------------------------------
//导入
//________________________________________________________________

import { ItemStack,  world, system } from '@minecraft/server';
import { ActionFormData,MessageFormData,  ModalFormData } from '@minecraft/server-ui';
import { score, set } from 'score.js';
import { standName } from 'disc/disc.js'

//-----------------------------------------------------
//函数
//________________________________________________________________

//取随机整数
function randomNum(minNum, maxNum) {
    switch (arguments.length) {
        case 1:
            return parseInt(Math.random() * minNum + 1, 10);
            break;
        case 2:
            return parseInt(Math.random() * (maxNum - minNum + 1) + minNum, 10);
            break;
        default:
            return 0;
            break;
    }
};

function clearArrow(player) {
    for (let i = 0; i < 37; i++) {
        if (i > 36) {
            throw "给我停下来啊！！！";
            return false;
        }
        const container = player.getComponent("minecraft:inventory").container;
        const item = container.getItem(i);
        if (item) {
            if (item.typeId == "johnny3150:stand_arrow" && item.getLore() == "") {
                let air = new ItemStack("minecraft:air", 1)
                container.setItem(i, air)
                return true;
            }
        }
    }
}

function getArrow(player, id) {
    player.removeTag("make_ready")
    clearArrow(player)
    let arrow = new ItemStack("johnny3150:stand_arrow", 1)
    arrow.setLore(["§r§7替身:",`  §r§9${standName[id]}`])
    player.dimension.spawnItem(arrow, player.location)
    player.runCommand("playsound smithing_table.use @a")
    return true;
}

function ready(player) {
    if (player.hasTag("make_ready")) {
        return true;
    } else {
        return false;
    }
}

function tellarwNoReady(player) {
    player.runCommand(`tellraw @s[tag=!make_ready] {"rawtext":[{"translate":"make.need.no"}]}`)
}

function anbsTalk(player) {
    let n = randomNum(1, 4)
    let ui = new ActionFormData()
        .title({ translate: "npc.anbs.title" })
        if (n==1) { ui.body({ translate: "npc.anbs.body1" }) }
        if (n==2) { ui.body({ translate: "npc.anbs.body2" }) }
        if (n==3) { ui.body({ translate: "npc.anbs.body3" }) }
        if (n==4) { ui.body({ translate: "npc.anbs.body4" }) }
        ui.button({ translate: "ui.leave" }, "")
        .show(player)
};

function etTalk(player) {
    let ui = new ActionFormData()
        .title({ translate: "npc.et.title" })
        .body({ translate: "npc.et.body" })
        .button({ translate: "npc.et.button.1" }, "textures/items/the_stand_arrow")
        .button({ translate: "ui.leave" }, "")
        .show(player).then(event => {
            if (event.selection!=0)return
            etMakeArrow(player)
    })
};

function etMakeArrow(player) {
    let ui = new ModalFormData()
        .title({ translate: "npc.et.title" })
        .dropdown({ translate: "ui.choose.stand.cb" }, standName, 0)
        .show(player).then(event => {
            if (event.formValues[0] == 0)return
            clearToMakeArrow(player, event.formValues[0])
    })
}

function clearToMakeArrow(player, id) {
    let ui = new MessageFormData()
        .title({ translate: "npc.et.make.title" })
        .button1({ translate: "npc.et.make.no" })
        .button2({ translate: "npc.et.make.yes" })
        switch (id) {
            case 1:
                 ui.body({ translate: "npc.et.make.sptw.need" })
                 break;
            case 2:
                 ui.body({ translate: "npc.et.make.kq.need" })
                 break;
            case 3:
                 ui.body({ translate: "npc.et.make.e3.need" })
                 break;
            case 4:
                 ui.body({ translate: "npc.et.make.cd.need" })
                 break;
            case 5:
                 ui.body({ translate: "npc.et.make.e.need" })
                 break;
            case 6:
                 ui.body({ translate: "npc.et.make.cp.need" })
                 break;
            case 7:
                 ui.body({ translate: "npc.et.make.hw.need" })
                 break;
            case 8:
                 ui.body({ translate: "npc.et.make.bc.need" })
                 break;
            case 9:
                 ui.body({ translate: "npc.et.no.able.make" })
                 break;
        }
        ui.show(player).then(event => {
        if (event.selection == 1) {
            switch (id) {
                case 1:
                     player.runCommand("tag @s[hasitem=[{item=johnny3150:stand_arrow,quantity=1..},{item=diamond,quantity=3..},{item=clock,quantity=1..}]] add make_ready")
                     tellarwNoReady(player)
                     if (ready(player)) {
                         if (getArrow(player, id)) {
                            player.runCommand("clear @s diamond 0 3")
                            player.runCommand("clear @s clock 0 1")
                         } else {
                            tellarwNoReady(player)
                         }
                     }
                     break;
                case 2:
                     player.runCommand("tag @s[hasitem=[{item=johnny3150:stand_arrow,quantity=1..},{item=gunpowder,quantity=44..},{item=tnt,quantity=4..}]] add make_ready")
                     tellarwNoReady(player)
                     if (ready(player)) {
                         if (getArrow(player, id)) {
                            player.runCommand("clear @s gunpowder 0 44")
                            player.runCommand("clear @s tnt 0 4")
                         } else {
                            tellarwNoReady(player)
                         }
                     }
                     break;
                case 3:
                     player.runCommand("tag @s[hasitem=[{item=johnny3150:stand_arrow,quantity=1..},{item=turtle_egg,quantity=1..},{item=experience_bottle,quantity=16..},{item=noteblock,quantity=1..},{item=potion,data=42,quantity=1..}]] add make_ready")
                     tellarwNoReady(player)
                     if (ready(player)) {
                         if (getArrow(player, id)) {
                            player.runCommand("clear @s turtle_egg 0 1")
                            player.runCommand("clear @s noteblock 0 1")
                            player.runCommand("clear @s experience_bottle 0 16")
                            player.runCommand("clear @s potion 42 1")
                         } else {
                            tellarwNoReady(player)
                         }
                     }
                     break;
                case 4:
                     player.runCommand("tag @s[hasitem=[{item=johnny3150:stand_arrow,quantity=1..},{item=diamond,quantity=4..},{item=cooked_beef,quantity=5..}]] add make_ready")
                     tellarwNoReady(player)
                     if (ready(player)) {
                         if (getArrow(player, id)) {
                            player.runCommand("clear @s diamond 0 4")
                            player.runCommand("clear @s cooked_beef 0 5")
                         } else {
                            tellarwNoReady(player)
                         }
                     }
                     break;
                case 5:
                     player.runCommand("tag @s[hasitem=[{item=johnny3150:stand_arrow,quantity=1..},{item=paper,quantity=5..}]] add make_ready")
                     tellarwNoReady(player)
                     if (ready(player)) {
                         if (getArrow(player, id)) {
                            player.runCommand("clear @s paper 0 5")
                         } else {
                            tellarwNoReady(player)
                         }
                     }
                     break;
                case 6:
                     player.runCommand("tag @s[hasitem=[{item=johnny3150:stand_arrow,quantity=1..},{item=redstone_block,quantity=5..}]] add make_ready")
                     tellarwNoReady(player)
                     if (ready(player)) {
                         if (getArrow(player, id)) {
                            player.runCommand("clear @s redstone_block 0 5")
                         } else {
                            tellarwNoReady(player)
                         }
                     }
                     break;
                case 7:
                     player.runCommand("tag @s[hasitem=[{item=johnny3150:stand_arrow,quantity=1..},{item=quartz_bricks,quantity=5..}]] add make_ready")
                     tellarwNoReady(player)
                     if (ready(player)) {
                         if (getArrow(player, id)) {
                            player.runCommand("clear @s quartz_bricks 0 5")
                         } else {
                            tellarwNoReady(player)
                         }
                     }
                     break;
                case 8:
                     player.runCommand("tag @s[hasitem=[{item=johnny3150:stand_arrow,quantity=1..},{item=bow,quantity=1..},{item=iron_block,quantity=5..}]] add make_ready")
                     tellarwNoReady(player)
                     if (ready(player)) {
                         if (getArrow(player, id)) {
                            player.runCommand("clear @s bow 0 1")
                            player.runCommand("clear @s iron_block 0 5")
                            getArrow(player, id)
                         } else {
                            tellarwNoReady(player)
                         }
                     }
                     break;
            }
        }
    })
};
//-----------------------------------------------------
//事件
//________________________________________________________________

system.afterEvents.scriptEventReceive.subscribe(event => {
    const player = event.sourceEntity;
    const id = event.id;
    const message = event.message;
    if (id != "npc:talk")return
     switch (message) {
         case 'et':
             etTalk(player)
             break;
         case 'anbs':
             anbsTalk(player)
             break;
     }
});