//-----------------------------------------------------
//导入
//________________________________________________________________

import { ItemStack, world, system } from '@minecraft/server';
import { ActionFormData, MessageFormData, ModalFormData } from '@minecraft/server-ui';
import { score, set } from 'score.js';

//-----------------------------------------------------
//函数
//________________________________________________________________

export function upToNext(player) {
    
    const upText1 = [
        '一股力量充盈了你的身躯  §r§b气力等级增加',
        '你现在可以扛起64组铁块!  §r§b气力等级增加',
        '你现在可以扛起64组铁砧!  §r§b气力等级增加',
        '你现在可以扛起64组金块!  §r§b气力等级增加',
        '“地表最强生物!”  §r§b气力等级已满'
    ]
    
    const upText2 = [
        '你感受到了风的气息  §r§b敏捷等级增加',
        '高天之风裹携着你的躯体  §r§b敏捷等级增加',
        '“只要不断前进,道路就会不断延伸”  §r§b敏捷等级已满'
    ]
    
    const upText3 = [
        '史蒂夫开始深入思考 §r§b巧思等级增加',
        '史蒂夫继续思考 §r§b巧思等级增加',
        '史蒂夫思考绿宝石的花销  §r§b巧思等级增加',
        '史蒂夫思考家里的钻石  §r§b巧思等级增加',
        '史蒂夫思考床的质量  §r§b巧思等级增加',
        '“晚安,史蒂夫” §r§b巧思等级已满'
    ]
    
    const upText4 = [
        '“人类的赞歌就是「勇气」的赞歌!” §r§b精神等级增加',
        '“所谓「觉悟」,即是在黑暗中开辟一条前进的「道路」!” §r§b精神等级增加',
        '“我的近路,就是绕「远路」!” §r§b精神等级已满'
    ]
    
    if (score(player, "life_level") < 3) {
        if (score(player, "strong") >= 2 && score(player, "speed") >= 1 && score(player, "clever") >= 2 && score(player, "life_level") == 0) {
            player.sendMessage(`${upText4[score(player, "life_level")]}`)
            player.runCommand("scoreboard players set @s life_level 1")
        }
        if (score(player, "strong") >= 3 && score(player, "speed") >= 2 && score(player, "clever") >= 4 && score(player, "life_level") < 2) {
            player.sendMessage(`${upText4[score(player, "life_level")]}`)
            player.runCommand("scoreboard players set @s life_level 2")
        }
        if (score(player, "strong") >= 5 && score(player, "speed") >= 3 && score(player, "clever") >= 6 && score(player, "life_level") < 3) {
            player.sendMessage(`${upText4[score(player, "life_level")]}`)
            player.runCommand("scoreboard players set @s life_level 3")
        }
    }
    
    if (score(player, "healthy") < parseInt( ( score(player, "speed")+score(player, "strong") )/0.8 )*2) {
        player.runCommand(`scoreboard players set @s healthy ${parseInt( ( score(player, "speed")+score(player, "strong") )/0.8 )*2}`)
    }
    
    if (score(player, "strong") < 5 && score(player, "strong_point") >= parseInt(score(player, "strong")**2+600)) {
        player.sendMessage(`${upText1[score(player, "strong")]}`)
        player.runCommand("scoreboard players add @s strong 1")
        player.runCommand("scoreboard players set @s strong_point 0")
        player.runCommand("playsound random.levelup @a ~ ~ ~ ")
    }
    
    if (score(player, "speed") < 3 && score(player, "speed_point") >= parseInt(score(player, "speed")**2+400)) {
        player.sendMessage(`${upText2[score(player, "speed")]}`)
        player.runCommand("scoreboard players add @s speed 1")
        player.runCommand("scoreboard players set @s speed_point 0")
        player.runCommand("playsound random.levelup @a ~ ~ ~ ")
        player.getComponent("minecraft:movement").setCurrentValue(score(player, "speed")*0.015+0.12)
    }
    
    if (score(player, "clever") < 6 && score(player, "clever_point") >= parseInt(score(player, "clever")**2+100)) {
        player.sendMessage(`${upText3[score(player, "clever")]}`)
        player.runCommand("scoreboard players add @s clever 1")
        player.runCommand("scoreboard players set @s clever_point 0")
        player.runCommand("playsound random.levelup @a ~ ~ ~ ")
    }
    
    if (system.currentTick % 10 === 0) {
        if (player.isJumping || player.isSwimming || player.isSprinting ) {
            player.runCommand("scoreboard players add @s speed_point 1")
        }
    }
}

//-----------------------------------------------------
//事件
//________________________________________________________________

world.afterEvents.playerBreakBlock.subscribe(event => {
    const player = event.player;
    if (player.typeId != "minecraft:player")return;
    player.runCommand("scoreboard players add @s strong_point 4")
});

world.afterEvents.entityHurt.subscribe(event => {
    try {
        const player = event.damageSource.damagingEntity;
        if (player.typeId == "minecraft:player") {
            player.runCommand("scoreboard players add @s strong_point 2")
        }
    } catch (error) {
        // world.sendMessage(`${error}`)
    }
})