//-----------------------------------------------------
//导入
//________________________________________________________________

import { ItemStack, world, system } from '@minecraft/server';
import { score, set } from 'score.js';
import { triggerEvent } from 'main.js';
import { attack, projectile, getEntites, breakBlock } from 'base/attack.js';

//-----------------------------------------------------
//本体
//________________________________________________________________
export function bc(player) {

    if (score(player, "stand_summon") == 1 && score(player, "stand_skill_cd_4") > 0) {
        player.runCommand(`tp @e[name="§a${player.name} 极恶中队",rm=20,r=100,tag=!tp] @s`)
        player.runCommand(`tag @e[name="§a${player.name} 极恶中队",rm=40,r=200,tag=tp] remove tp`)
    }

    if (player.hasTag("detect_attack") && score(player, "stand_summon") == 1 && !player.hasTag("be_stopped_of_time")) {

        switch (player.selectedSlotIndex) {
            case 0:
                if (score(player, "stand_skill_cd_4") == 0 && score(player, "stand_energy") >= 25) {
                    player.runCommand("scoreboard players remove @s stand_energy 25")
                    player.runCommand("scoreboard players set @s stand_skill_cd_4 1600")
                    player.runCommand(`summon stand:bcp ^-0.2^^0.3 ~ ~ ? "§a${player.name} 极恶中队"`)
                    player.runCommand(`summon stand:bcp ^0.2^^0.3 ~ ~ ? "§a${player.name} 极恶中队"`)
                    if (score(player, "stand_level") >= 25) {
                        player.runCommand(`summon stand:bcp ^^^0.3 ~ ~ ? "§a${player.name} 极恶中队"`)
                        player.runCommand(`summon stand:bcp ^0.3^^ ~ ~ ? "§a${player.name} 极恶中队"`)
                        player.runCommand(`summon stand:bcp ^-0.3^^ ~ ~ ? "§a${player.name} 极恶中队"`)
                    }
                    if (score(player, "stand_level") >= 50) {
                        player.runCommand(`summon stand:tank ^0.25^^ ~ ~ ? "§a${player.name} 极恶中队"`)
                    }
                    if (score(player, "stand_level") >= 75) {
                        player.runCommand(`summon stand:tank ^-0.25^^ ~ ~ ? "§a${player.name} 极恶中队"`)
                    }
                    if (score(player, "stand_level") == 100) {
                        player.runCommand(`summon stand:ah64a ^-0.25^^ ~ ~ ? "§a${player.name} 极恶中队"`)
                    }
                    player.runCommand(`execute as @e[name="§a${player.name} 极恶中队"] at @s run particle stand:bc_summon ^^0.5^`)
                    player.runCommand("playsound armor.equip_gold @a ~~~ 100 1.5 0")
                    const entities = player.dimension.getEntities({
                        name: `§a${player.name} 极恶中队`,
                        families: ["bc"]
                    });
                    for (const bc of entities) {
                        bc.getComponent("minecraft:tameable").tame(player)
                    }
                }
                break;
        }
    }

}

world.afterEvents.entityHurt.subscribe(event => {
    const entity = event.hurtEntity;
    const damagingEntity = event.damageSource.damagingEntity
    const damage = event.damage
    try {
        if (entity.nameTag.replace("§a", "").replace(" 极恶中队", "") == damagingEntity.name && damagingEntity.isSneaking && entity.getComponent("minecraft:type_family")?.hasTypeFamily("bc")) {
            system.runTimeout(() => {
                entity.runCommand("stopsound @a[r=10] game.player.hurt")
                entity.runCommand("tp ~~-0.1~ true")
                entity.runCommand("tp ~~-0.1~ true")
                entity.runCommand("tp ~~-0.1~ true")
                entity.runCommand("tp ~~-0.1~ true")
                entity.runCommand("tp ~~-0.1~ true")
                entity.runCommand("tp ~~-0.1~ true")
                if (entity.hasTag("tp")) {
                    entity.removeTag("tp")
                } else {
                    entity.addTag("tp")
                }
                damagingEntity.runCommand("playsound armor.equip_iron @a ~~~ 100 1 0")
            }, 1)
            
            entity.getComponent("minecraft:health").setCurrentValue(entity.getComponent("minecraft:health").currentValue+damage)
        }
    } catch (e) {
        // world.sendMessage(`${e}`)
    }
})

//-----------------------------------------------------
//函数
//________________________________________________________________

export function bcNoSkill(player) {
    function score(player, objective) {
        try {
            return world.scoreboard.getObjective(objective)
                .getScore(player.scoreboardIdentity)
        } catch (e) {
            return 0;
        }
    }
    if (score(player, "stand_skill_cd_4") == 0) {
        return true;
    } else {
        return false;
    }
}