//-----------------------------------------------------
//导入
//________________________________________________________________

import { ItemStack, world, system } from '@minecraft/server';
import { ActionFormData, ModalFormData } from '@minecraft/server-ui';
import { score, set } from 'score.js';
import { triggerEvent } from 'main.js';
import { attack, projectile, getEntites, breakBlock, breakGetBlock } from 'base/attack.js';
import { defendData } from 'base/defend.js';

//-----------------------------------------------------
//初始变量
//________________________________________________________________

let combo = {
    "playerName": {
        "m": "a",
        "time": 0
    }
}

let cd5 = {
    "playerName": {
        "cd": 0
    }
}

let sounds_value = 0

let target_id = {
    "playerName": {
        "id": 0
    }
}

//-----------------------------------------------------
//本体
//________________________________________________________________

export function cdStand(player) {
        //初始化
        if (combo[player.name] == undefined) {
            combo[player.name] = {
                "m": "a",
                "time": 0
            }
        }
        
        if (target_id[player.name] == undefined) {
            target_id[player.name] = {
                "id": 0
            }
        }
        
        if (combo[player.name]["time"] > 0) {
            combo[player.name]["time"] -= 1
        }

        if (cd5[player.name] == undefined) {
            cd5[player.name] = {
                "cd": 0
            }
        }
        if (cd5[player.name]["cd"] > 0) {
            cd5[player.name]["cd"] -= 1
        }
        
        const entity = player.dimension.getEntities({
            tags: [`id${target_id[player.name]["id"]}`]
        })[0]
        if (entity) {
            const head = entity.getHeadLocation();
            const location = {
                x: head.x,
                y: head.y + 1.5,
                z: head.z
            }
            const location2 = {
                x: entity.location.x,
                y: entity.location.y + 1,
                z: entity.location.z
            }
            player.spawnParticle("stand:blood_sign", location)
            if (system.currentTick % 5 === 0) {
                entity.dimension.spawnParticle("stand:blood_cloud", location2)
            }
            entity.runCommand(`execute as @s at @s anchored feet if block ~~~ water run tag @a[name="${player.name}"] add cd:target:reset`)
            entity.runCommand(`execute as @s at @s anchored feet if block ~~~ flowing_water run tag @a[name="${player.name}"] add cd:target:reset`)
            if (player.hasTag("cd:target:reset")) {
                target_id[player.name] = {
                    "id": 0
                }
            }
        }

        if (player.hasTag("detect_attack") && score(player, "stand_summon") == 1 && !player.hasTag("be_stopped_of_time")) {
            switch (player.selectedSlotIndex) {

                //普普通通的连招
                case 0:
                    if (cdNoSkill(player) && !player.isSneaking && defendData[player.name]["isDefend"] != true) {
                        player.runCommand("playanimation @s animation.stand.cd.m1" + combo[player.name]["m"])

                        combo[player.name]["time"] = 9
                        sounds_value = sounds_value + 1
                        sounds_value = sounds_value > 3 ? 1 : sounds_value
                        //登记
                        let entities = getEntites(player, 4)
                        if (entities[0] != undefined) {} else {
                            player.runCommand("playsound game.player.attack.strong @a ~~~ 100 1 0")
                        }
                        player.runCommand("scoreboard players set @s stand_fpp_invisibility 0")
                        triggerEvent(player)
                        attacks(player, (7 * (score(player, "stand_level") / 100) + 7), 10)
                        breakBlock(player, 5)
                        system.runTimeout(() => {
                            if (combo[player.name]["time"] == 0 && cdNoSkill(player)) {
                                player.runCommand("scoreboard players set @s stand_fpp_invisibility 1")
                                triggerEvent(player)
                            }
                        }, 12)
                        if (combo[player.name]["m"] == "a") {
                            combo[player.name]["m"] = "b"
                            player.runCommand("playsound dora" + sounds_value + " @a ~~~ 100 1 0")
                            return;
                        }
                        if (combo[player.name]["m"] == "b") {
                            combo[player.name]["m"] = "a"
                            player.runCommand("playsound dora" + sounds_value + " @a ~~~ 100 1 0")
                            return;
                        }
                    }
                    if (cdNoSkill(player) && player.isSneaking && cd5[player.name]["cd"] == 0) {
                        cd5[player.name]["cd"] = 20
                        const container = player.getComponent("minecraft:inventory")
                            .container;
                        let item2 = container.getItem(player.selectedSlotIndex);
                        try {
                            player.runCommand(`setblock 114514 -500 114514 ${item2.typeId}`)
                        } catch (error) {
                            return;
                        }
                        let item = new ItemStack(item2.typeId, 1)
                        player.runCommand(`clear @s ${item2.typeId} 0 ${item2.amount}`)
                        item.setLore(["§r§7Crazy Diamond", `§r§7${player.dimension.id}`, `§r§7${player.location.x}`, `§r§7${player.location.y}`, `§r§7${player.location.z}`])
                        player.dimension.spawnItem(item, player.location)
                        item2.amount -= 1
                        player.dimension.spawnItem(item2, player.location)
                    }
                    break;

                    //dora!dora!!dora!!!
                case 1:
                    if (cdNoSkill(player) && score(player, "stand_skill_cd_2") == 0) {
                        system.runTimeout(() => {
                            player.runCommand("scoreboard players set @s stand_fpp_invisibility 0")
                            triggerEvent(player)
                            player.runCommand("playanimation @s animation.stand.cd.barrage")
                        }, 2);
                        player.runCommand("scoreboard players set @s stand_skill_cd_2 60")
                        player.runCommand("playsound barrage_dora @a ~~~ 100 1 0")
                        let barrage = system.runInterval(() => {
                            attacks(player, (7 * (score(player, "stand_level") / 100) + 7), 5)
                            player.runCommand("effect @s slowness 1 0 true")
                        }, 5)
                        system.runTimeout(() => {
                            system.clearRun(barrage)
                            system.runTimeout(() => {
                                attacks(player, (14 * (score(player, "stand_level") / 100) + 14), 50)
                                system.runTimeout(() => {
                                    player.runCommand("scoreboard players set @s stand_fpp_invisibility 1")
                                    triggerEvent(player)
                                }, 10)
                            }, 2)
                        }, 50)
                    }
                    break;
                case 2:
                    if (cdNoSkill(player) && score(player, "stand_skill_cd_3") == 0 && score(player, "stand_energy") > 0 && !player.isSneaking) {
                        player.runCommand("scoreboard players set @s stand_skill_cd_3 40")
                        player.runCommand("scoreboard players set @s stand_fpp_invisibility 0")
                        triggerEvent(player)
                        player.runCommand("playsound repair @a ~~~ 100 1 0")
                        player.runCommand("playanimation @s animation.stand.cd.repair")
                        player.runCommand("effect @s slowness 2 1 true")
                        let repair_system = system.runInterval(() => {
                            player.selectedSlotIndex = 2
                            let entities = !getEntites(player, 5)[0] ? undefined : getEntites(player, 5)[0].entity
                            repair(player, repair_system, entities)
                            player.runCommand("scoreboard players remove @s[scores={stand_energy=1..}] stand_energy 1")
                            if (player.hasTag("detect_attack") && score(player, "stand_skill_cd_3") < 30 || score(player, "stand_energy") == 0) {
                                system.clearRun(repair_system)
                                triggerEvent(player)
                                player.runCommand("playanimation @s animation.stand.e3.null")
                                player.runCommand("scoreboard players set @s stand_fpp_invisibility 1")
                                player.runCommand("scoreboard players add @s stand_skill_cd_3 1")
                                player.runCommand("effect @s slowness 0 1 true")
                            }
                        }, 2)
                        system.runTimeout(() => {
                            if (repair_system) {
                                system.clearRun(repair_system)
                                triggerEvent(player)
                                player.runCommand("scoreboard players set @s stand_fpp_invisibility 1")
                                player.runCommand("effect @s slowness 0 1 true")
                            }
                        }, 40)
                    }
                    if (cdNoSkill(player) && score(player, "stand_skill_cd_3") == 0 && score(player, "stand_energy") > 0 && player.isSneaking) {
                        const container = player.getComponent("minecraft:inventory").container;
                        let item = container.getItem(player.selectedSlotIndex);
                        try {
                            player.runCommand(`setblock 114514 -500 114514 ${item.typeId}`)
                            const startPoint = {
                                x: player.location.x,
                                y: player.location.y,
                                z: player.location.z
                            };
                            const target = player.dimension.getEntities({
                                tags: [`id${target_id[player.name]["id"]}`],
                            })[0];
                            if (target && player.isSneaking) {
                                const endPoint = target.location;
                                const distance = calculateDistance(startPoint, endPoint);                
                                const dynamicBezierCurvePoints = generateRandomDynamicBezierCurve(startPoint, endPoint);
                                if (distance < 100) {
                                    player.addTag("cd:repair")
                                    player.runCommand("playsound repair @a ~~~ 100 1 0")
                                    player.runCommand("scoreboard players set @s stand_skill_cd_3 80")
                                    blood(player, player.location, target)
                                }
                                return;
                            }
                        } catch (error) {}
                        player.runCommand("scoreboard players set @s stand_skill_cd_3 20")
                        player.runCommand("damage @s 2")
                        player.runCommand("playsound mob.witch.drink @a ~~~ 100 1.2 0")
                        let detect = "";
                        let unless = "";
                        for (let i = 0; i < 19; i=i+1) {
                            detect = `${detect} if block ^^1.5^${1+i} air `
                            unless = ` unless block ^^1.5^${1+i} air `
                            player.runCommand(`execute as @s at @s ${detect} run particle stand:blood ^^1.65^${1+i}`)
                            player.runCommand(`execute as @s at @s ${detect} run particle stand:blood ^^1.7^${0.8+i}`)
                            player.runCommand(`execute as @s at @s ${detect} run particle stand:blood ^^1.85^${0.7+i}`)
                            player.runCommand(`execute as @s at @s ${detect} run particle stand:blood ^^1.9^${0.65+i}`)
                            player.runCommand(`execute as @s at @s ${detect} run particle stand:blood ^^2.1^${0.6+i}`)
                            player.runCommand(`execute as @s at @s ${detect} run particle stand:blood ^^2.15^${0.55+i}`)
                            player.runCommand(`execute as @s at @s ${detect} run particle stand:blood ^^2.1^${0.52+i}`)
                            player.runCommand(`execute as @s at @s ${detect} run particle stand:blood ^^1.5^${1+i}`)
                            player.runCommand(`execute as @s at @s ${detect} run particle stand:blood ^^1.35^${0.8+i}`)
                            player.runCommand(`execute as @s at @s ${detect} run particle stand:blood ^^1.3^${0.7+i}`)
                            player.runCommand(`execute as @s at @s ${detect} run particle stand:blood ^^1.2^${0.65+i}`)
                            player.runCommand(`execute as @s at @s ${detect} run particle stand:blood ^^1^${0.6+i}`)
                            player.runCommand(`execute as @s at @s ${detect} run particle stand:blood ^^0.8^${0.55+i}`)
                            if (shoots(player, (2 * (score(player, "stand_level") / 100) + 2), 1, i+1)) {
                                return;
                            }
                        };
                    }
                    break;
                case 3:
                    if (cdNoSkill(player) && score(player, "angry") == 100 && score(player, "stand_skill_cd_4") == 0) {
                        player.runCommand("scoreboard players set @s stand_skill_cd_4 650")
                        player.runCommand("fog @s push minecraft:fog_crimson_forest crazy")
                        player.runCommand("scoreboard players set @s angry 0")
                        player.runCommand("playsound yee @a ~~~ 10000 1 10")
                        player.runCommand(`effect @s strength 20 3 true`)
                        player.runCommand("effect @s absorption 20 2 true")
                        player.runCommand("effect @s speed 20 2 true")
                        player.runCommand("effect @s jump_boost 20 2 true")
                        player.runCommand("particle stand:angry ~~1~")
                        player.addTag("crazy")
                        player.sendMessage("§c我已经怒不可遏了!")
                        let angry_system = system.runInterval(() => {
                            player.runCommand("particle stand:angry_campfire_smoke_particle ~~0.5~")
                        })
                        system.runTimeout(() => {
                            system.clearRun(angry_system)
                            player.removeTag("crazy")
                            player.runCommand("fog @s pop crazy")
                        }, 380)
                    }
                    break;
            }
        }
    
}

world.afterEvents.entityHurt.subscribe(event => {
    try {
        var entity = event.hurtEntity;
        if (entity.typeId == "minecraft:player" && score(entity, "stand_type_id") == 4) {
            let i = 0;
            let angry = system.runInterval(() => {
                i += 1
                entity.runCommand("scoreboard players add @s[scores={angry=..99}] angry 1")
                if (i > (2 + parseInt(event.damage)*2)) {
                    system.clearRun(angry)
                }
            })
        }
    } catch (e) {}
})

//-----------------------------------------------------
//函数
//________________________________________________________________

export function cdNoSkill(player) {
    function score(player, objective) {
        try {
            return world.scoreboard.getObjective(objective)
                .getScore(player.scoreboardIdentity)
        } catch (e) {
            return 0;
        }
    }
    if (combo[player.name]["time"] == 0 && score(player, "stand_skill_cd_2") == 0 && !player.hasTag("cd:repair")) {
        return true;
    } else {
        return false;
    }
}

function attacks(player, damage, kc) {
    let entities = getEntites(player, 4)
    for (let i = 0; i < entities.length; i++) {
        attack(player, entities[i].entity, damage, kc, entities[i].distance)
    }
    if (entities[0] == undefined) {
        player.runCommand("playsound game.player.attack.strong @a ~ ~ ~ 100 2")
    }
}

function shoots(player, damage, kc, di) {
    let entities = getEntites(player, di)
    for (let i = 0; i < entities.length; i++) {
        projectile(player, entities[i].entity, damage, kc, entities[i].distance)
    }
    if (entities[0]) {
        target_id[player.name]["id"] = entities[0].entity.id
        entities[0].entity.runCommand("particle stand:skill ~~~")
        return true;
    } else {
        return false;
    }
}

//修东西
function repair(player, repair_system, entity) {
    player.runCommand("function repair")
    if (entity) {
        if (entity.hasComponent("minecraft:health")) {
            entity.runCommand("effect @s regeneration 5 5")
        }
        if (entity.getComponent("minecraft:item")) {
            let item = entity.getComponent("minecraft:item").itemStack
            if (item.getLore()[0] == "§r§7Crazy Diamond" && item.getLore()[1] == `§r§7${player.dimension.id}` && item.typeId != "minecraft:tnt") {
                // 测试路径生成
                system.clearRun(repair_system)
                triggerEvent(player)
                player.runCommand("playanimation @s animation.stand.e3.null")
                player.runCommand("scoreboard players set @s stand_fpp_invisibility 1")
                player.runCommand("effect @s slowness 0 1 true")
                let blockTypeId = item.typeId
                const startPoint = {
                    x: player.location.x,
                    y: player.location.y,
                    z: player.location.z
                };
                const endPoint = {
                    x: parseInt(item.getLore()[2].replace("§r§7", "")),
                    y: parseInt(item.getLore()[3].replace("§r§7", "")),
                    z: parseInt(item.getLore()[4].replace("§r§7", ""))
                };
                const distance = calculateDistance(startPoint, endPoint);
                if (distance > 100) return

                entity.remove()
                const dynamicBezierCurvePoints = generateRandomDynamicBezierCurve(startPoint, endPoint);
                let i = 0;
                if (!player.isSneaking) {
                    let tp = system.runInterval(() => {
                        i += 1
                        let point = dynamicBezierCurvePoints[i]
                        if (i >= (parseInt(calculateDistance(startPoint, endPoint)) - 3)) {
                            player.runCommand(`setblock ${parseInt(item.getLore()[2].replace("§r§7", ""))} ${parseInt(item.getLore()[3].replace("§r§7", ""))} ${parseInt(item.getLore()[4].replace("§r§7", ""))} ${blockTypeId} destroy`);
                            player.runCommand("effect @s resistance 0 255 true");
                            player.runCommand("camera @s clear");
                            system.clearRun(tp);
                            return;
                        } else {
                            player.runCommand(`tp ${point.x} ${point.y} ${point.z}`)
                            player.runCommand("particle stand:repair2 ~~1~")
                            player.runCommand("camera @s set minecraft:third_person")
                            player.runCommand("effect @s resistance 1 255 true")
                        }
                    })
                }
                else {
                    let tp = system.runInterval(() => {
                    i += 1
                    if (i >= (parseInt(calculateDistance(startPoint, endPoint)) - 2)) {
                        system.clearRun(tp);
                        player.runCommand(`setblock ${parseInt(item.getLore()[2].replace("§r§7", ""))} ${parseInt(item.getLore()[3].replace("§r§7", ""))} ${parseInt(item.getLore()[4].replace("§r§7", ""))} ${blockTypeId} destroy`);
                        return
                    }
                    let point = dynamicBezierCurvePoints[i]
                        player.runCommand(`particle stand:repair2 ${point.x} ${point.y + 1} ${point.z}`)
                    })
                }
            }
            if (item.getLore()[0] == "§r§7Crazy Diamond" && item.getLore()[1] == `§r§7${player.dimension.id}` && item.typeId == "minecraft:tnt") {
                // 测试路径生成
                const startPoint = {
                    x: entity.location.x,
                    y: entity.location.y,
                    z: entity.location.z
                };
                const endPoint = {
                    x: parseInt(item.getLore()[2].replace("§r§7", "")),
                    y: parseInt(item.getLore()[3].replace("§r§7", "")),
                    z: parseInt(item.getLore()[4].replace("§r§7", ""))
                };
                const distance = calculateDistance(startPoint, endPoint);
                if (distance > 100) return
                if (item.amount > 1) {
                    let newItem = item
                    item.amount -= 1
                    player.dimension.spawnItem(newItem, entity.location)
                }

                const dimension = player.dimension
                const dynamicBezierCurvePoints = generateRandomDynamicBezierCurve(startPoint, endPoint);
                let i = 0;
                let tp = system.runInterval(() => {
                    i += 1
                    let point = dynamicBezierCurvePoints[i]
                    dimension.runCommand(`particle stand:repair2 ${point.x} ${point.y+1} ${point.z}`)
                     if (i >= (parseInt(calculateDistance(startPoint, endPoint)) - 2)) {
                        system.clearRun(tp);
                        dimension.runCommand(`summon tnt ${point.x} ${point.y} ${point.z}`);
                    }
                })
                entity.remove();
            }
            if (item.getLore()[0] != "§r§7Crazy Diamond" && item.getLore()[1] != `§r§7${player.dimension.id}` && item.typeId == "minecraft:glass") {
                // 测试路径生成
                const startPoint = {
                    x: entity.location.x,
                    y: entity.location.y,
                    z: entity.location.z
                };
                const target = player.dimension.getEntities({
                    tags: [`id${target_id[player.name]["id"]}`],
                })[0];
                if (!target) return
                const endPoint = target.location
                const distance = calculateDistance(startPoint, endPoint);
                if (distance > 100) return;
                if (item.amount > 1) {
                    let newItem = item
                    item.amount -= 1
                    player.dimension.spawnItem(newItem, entity.location)
                }
                glass2(player, entity.location, target)
                entity.remove()
            }
            if (item.hasComponent("minecraft:durability") && item.getComponent("minecraft:durability")?.damage != 0 && item.typeId != "johnny3150:stand_arrow") {
                let newItem = new ItemStack(item.typeId, 1)
                player.dimension.spawnItem(newItem, entity.location)
                entity.remove()
            }
            
            if (item.getLore()[0] != "§r§7Crazy Diamond" && item.getLore()[1] != `§r§7${player.dimension.id}` && item.typeId == "minecraft:end_crystal") {
                // 测试路径生成
                const startPoint = {
                    x: entity.location.x,
                    y: entity.location.y,
                    z: entity.location.z
                };
                const target = player.dimension.getEntities({
                    tags: [`id${target_id[player.name]["id"]}`],
                })[0];
                if (!target) return
                const endPoint = target.location
                const distance = calculateDistance(startPoint, endPoint);
                if (distance > 100) return;
                if (item.amount > 1) {
                    let newItem = item
                    item.amount -= 1
                    player.dimension.spawnItem(newItem, entity.location)
                }
                end_crystal2(player, entity.location, target)
                entity.remove()
            }
            
        }
    }
}

//自闭链1号机
function glass(player, startPoint, target) {
    const endPoint = target.location
    const dynamicBezierCurvePoints = generateRandomDynamicBezierCurve(startPoint, endPoint);
    let i = 0;
    let tp = system.runInterval(() => {
        i += 1
        const distance = calculateDistance(target.location, endPoint);
        if (distance > 3) {
            glass2(player, dynamicBezierCurvePoints[i], target);
            system.clearRun(tp);
            return
        }
        if (!target) {
            entity.remove();
            system.clearRun(tp);
            return;
        }
        if (player.dimension != target.dimension) {
            system.clearRun(tp);
            return
        }
        if (i >= (parseInt(calculateDistance(startPoint, endPoint)) - 2)) {
            system.clearRun(tp);
            target.runCommand("playsound random.glass @a[r=20] ~~~ 100 1 0");
            target.runCommand(`damage @s[r=3,type=!item,name=!"${player.nameTag}"] 10`);
            target.runCommand("effect @s wither 3 3 true");
            target.runCommand("particle stand:red_sparkler_emitter ~~1~");
            return;
        }
        let point = dynamicBezierCurvePoints[i]
        player.dimension.runCommand(`tp ${point.x} ${point.y} ${point.z}`)
        player.dimension.runCommand(`particle stand:repair2 ${point.x} ${point.y+1} ${point.z}`)
    })
}

//EVA二号机
function glass2(player, startPoint, target) {
    const endPoint = target.location
    const dynamicBezierCurvePoints = generateRandomDynamicBezierCurve(startPoint, endPoint);
    let i = 0;
    let tp = system.runInterval(() => {
        i += 1
        const distance = calculateDistance(target.location, endPoint);
        if (distance > 3) {
            glass(player, dynamicBezierCurvePoints[i], target);
            system.clearRun(tp);
            return
        }
        if (!target) {
            system.clearRun(tp);
            return;
        }
        if (player.dimension.id != target.dimension.id) {
            system.clearRun(tp);
            return
        }

        if (i >= (parseInt(calculateDistance(startPoint, endPoint)) - 2)) {
            target.runCommand("playsound random.glass @a[r=20] ~~~ 100 1 0");
            target.runCommand(`damage @s[r=3,type=!item,name=!"${player.nameTag}"] 10`);
            target.runCommand("effect @s wither 3 3 true");
            target.runCommand("particle stand:red_sparkler_emitter ~~1~");
            system.clearRun(tp);
            return;
        }
        let point = dynamicBezierCurvePoints[i]
        player.dimension.runCommand(`particle stand:repair2 ${point.x} ${point.y+1} ${point.z}`)
    })
}

//自闭链1号机
function blood(player, startPoint, target) {
    const endPoint = target.location
    const dynamicBezierCurvePoints = generateRandomDynamicBezierCurve(startPoint, endPoint);
    let i = 0;
    let tp = system.runInterval(() => {
        i += 1
        const distance = calculateDistance(target.location, endPoint);
        if (!target) {
            player.removeTag("cd:repair")
            system.clearRun(tp);
            return;
        }
        if (player.dimension != target.dimension) {
            system.clearRun(tp);
            return
        }
        if (i >= (parseInt(calculateDistance(startPoint, endPoint)) - 2)) {
            const distance = calculateDistance(target.location, endPoint);
            if (distance > 3) {
                blood(player, player.location, target);
                system.clearRun(tp);
                return
            } else {
                system.clearRun(tp);
                player.runCommand("effect @s resistance 0 255 true");
                player.runCommand("camera @s clear");
                player.removeTag("cd:repair")
                return;
            }
        }
        let point = dynamicBezierCurvePoints[i]
        player.runCommand(`tp ${point.x} ${point.y} ${point.z}`)
        player.runCommand("particle stand:repair2 ~~1~")
        player.runCommand("camera @s set minecraft:third_person")
        player.runCommand("effect @s resistance 1 255 true")
        player.runCommand(`tp ~~~ facing @e[tag="id${target_id[player.name]["id"]}",c=1]`)
    })
}

//EVA二号机
function blood2(player, startPoint, target) {
    const endPoint = target.location
    const dynamicBezierCurvePoints = generateRandomDynamicBezierCurve(startPoint, endPoint);
    let i = 0;
    let tp = system.runInterval(() => {
        i += 1
        if (!target) {
            player.removeTag("cd:repair")
            system.clearRun(tp);
            return;
        }
        if (player.dimension != target.dimension) {
            system.clearRun(tp);
            return
        }
        if (i >= (parseInt(calculateDistance(startPoint, endPoint)) - 2)) {
            const distance = calculateDistance(target.location, endPoint);
            if (distance > 3) {
                blood(player, player.location, target);
                system.clearRun(tp);
                return
            } else {
                system.clearRun(tp);
                player.runCommand("effect @s resistance 0 255 true");
                player.runCommand("camera @s clear");
                player.removeTag("cd:repair")
                return;
            }
        }
        let point = dynamicBezierCurvePoints[i]
        player.runCommand(`tp ${point.x} ${point.y} ${point.z}`)
        player.runCommand("particle stand:repair2 ~~1~")
        player.runCommand("camera @s set minecraft:third_person")
        player.runCommand("effect @s resistance 1 255 true")
        player.runCommand(`tp ~~~ facing @e[tag="id${target_id[player.name]["id"]}",c=1]`)
    })
}

//自闭链1号机
function end_crystal(player, startPoint, target) {
    const endPoint = target.location
    const dynamicBezierCurvePoints = generateRandomDynamicBezierCurve(startPoint, endPoint);
    let i = 0;
    let tp = system.runInterval(() => {
        i += 1
        if (!target) {
            entity.remove();
            system.clearRun(tp);
            return;
        }
        if (player.dimension != target.dimension) {
            system.clearRun(tp);
            return
        }
        if (i >= (parseInt(calculateDistance(startPoint, endPoint)) - 2)) {
            system.clearRun(tp);
            const distance = calculateDistance(target.location, endPoint);
            if (distance > 1.5) {
                end_crystal2(player, dynamicBezierCurvePoints[i], target);
                system.clearRun(tp);
                return
            } else {
                target.runCommand("summon ender_crystal ~ ~ ~ ~ ~ minecraft:crystal_explode");
                system.clearRun(tp);
                return;
            }
        }
        let point = dynamicBezierCurvePoints[i]
        player.dimension.runCommand(`tp ${point.x} ${point.y} ${point.z}`)
        player.dimension.runCommand(`particle stand:repair2 ${point.x} ${point.y+1} ${point.z}`)
    })
}

//EVA二号机
function end_crystal2(player, startPoint, target) {
    const endPoint = target.location
    const dynamicBezierCurvePoints = generateRandomDynamicBezierCurve(startPoint, endPoint);
    let i = 0;
    let tp = system.runInterval(() => {
        i += 1
        if (!target) {
            system.clearRun(tp);
            return;
        }
        if (player.dimension.id != target.dimension.id) {
            system.clearRun(tp);
            return
        }

        if (i >= (parseInt(calculateDistance(startPoint, endPoint)) - 2)) {
            const distance = calculateDistance(target.location, endPoint);
            if (distance > 1.5) {
                end_crystal2(player, dynamicBezierCurvePoints[i], target);
                system.clearRun(tp);
                return
            } else {
                target.runCommand("summon ender_crystal ~ ~ ~ ~ ~ minecraft:crystal_explode");
                system.clearRun(tp);
                return;
            }
            return;
        }
        let point = dynamicBezierCurvePoints[i]
        player.dimension.runCommand(`tp ${point.x} ${point.y} ${point.z}`)
        player.dimension.runCommand(`particle stand:repair2 ${point.x} ${point.y+1} ${point.z}`)
    })
}

// 生成两点之间的随机应变的贝塞尔曲线
function generateRandomDynamicBezierCurve(startPoint, endPoint) {
    // 随机生成控制点的偏移量
    const controlPoint1Offset = {
        x: Math.random() * 5,
        y: Math.random() * 5,
        z: Math.random() * 5
    };
    const controlPoint2Offset = {
        x: Math.random() * 5,
        y: Math.random() * 5,
        z: Math.random() * 5
    };

    // 控制点1
    const controlPoint1 = {
        x: startPoint.x + controlPoint1Offset.x,
        y: startPoint.y + controlPoint1Offset.y,
        z: startPoint.z + controlPoint1Offset.z
    };

    // 控制点2
    const controlPoint2 = {
        x: endPoint.x + controlPoint2Offset.x,
        y: endPoint.y + controlPoint2Offset.y,
        z: endPoint.z + controlPoint2Offset.z
    };

    // 步数
    const steps = parseInt(calculateDistance(startPoint, endPoint));
    const points = [];

    for (let t = 0; t <= 1; t += 1 / steps) {
        const x = (1 - t) ** 3 * startPoint.x + 3 * (1 - t) ** 2 * t * controlPoint1.x + 3 * (1 - t) * t ** 2 * controlPoint2.x + t ** 3 * endPoint.x;
        const y = (1 - t) ** 3 * startPoint.y + 3 * (1 - t) ** 2 * t * controlPoint1.y + 3 * (1 - t) * t ** 2 * controlPoint2.y + t ** 3 * endPoint.y;
        const z = (1 - t) ** 3 * startPoint.z + 3 * (1 - t) ** 2 * t * controlPoint1.z + 3 * (1 - t) * t ** 2 * controlPoint2.z + t ** 3 * endPoint.z;

        points.push({
            x, y, z
        });
    }

    return points;
}

//测距
function calculateDistance(point1, point2) {
    const deltaX = point2.x - point1.x;
    const deltaY = point2.y - point1.y;
    const deltaZ = point2.z - point1.z;

    const distanceSquared = deltaX ** 2 + deltaY ** 2 + deltaZ ** 2;
    const distance = Math.sqrt(distanceSquared);

    return distance.toFixed(2);
}