//-----------------------------------------------------
//导入
//________________________________________________________________

import { ItemStack, world, system, EntityComponentTypes } from '@minecraft/server';
import { score, set } from 'score.js';
import { triggerEvent } from 'main.js';
import { attack, projectile, getEntites, breakBlock } from 'base/attack.js';
import { fightSkill } from 'enhancement/dna.js'
import { defendData } from 'base/defend.js';

//-----------------------------------------------------
//初始变量
//________________________________________________________________

let combo = {
    "playerName": {
        "m": "a",
        "time": 0
    }
}
let hurtTime = {
    "playerName": {
        "time": 0
    }
}

//-----------------------------------------------------
//事件
//________________________________________________________________
    export function cp(player) {

        //没有变量自己造
        if (combo[player.name] == undefined) {
            combo[player.name] = {
                "m": "a",
                "time": 0
            }
        }

        //减时间
        if (combo[player.name]["time"] > 0) {
            combo[player.name]["time"] -= 1
        }

        if (score(player, "stand_energy") == 0 && score(player, "stand_summon") == 1 && cpNoSkill(player)) {
            player.runCommand("scoreboard players set @s stand_summon 0")
            player.runCommand(`tp @s @e[c=1,name="${player.name}",type=stand:players]`)
            player.runCommand(`tp @e[c=1,name="${player.name}",type=stand:players] 1145141 -500 0`)
        }
        if (score(player, "stand_energy") > 0 && score(player, "stand_summon") == 1 && system.currentTick % 5 === 0) {
            player.runCommand("scoreboard players remove @s stand_energy 1")
            if (system.currentTick % 6 === 0) {
                const fs = new fightSkill(player);
                if (fs.getFightSkill()["fs"].indexOf("恢复") == -1) return;
                player.runCommand("scoreboard players add @s[scores={stand_energy=..99}] stand_energy 1")
            }
        }
        if (score(player, "stand_energy") < 100 && score(player, "stand_summon") == 1) {
            charge(player)
        }
        if (score(player, "stand_energy") > 0 && player.isInWater && score(player, "stand_summon") == 1) {
            uncharge(player)
        }
        if (score(player, "stand_summon") == 1 && system.currentTick % 20 === 0) {
            player.runCommand("function cp/energy")
            
            if (score(player, "life_level") == 1) {
                player.runCommand(`effect @e[name="${player.name}",type=stand:players] resistance 5 0 true`)
            }
            if (score(player, "life_level") == 2) {
                player.runCommand(`effect @e[name="${player.name}",type=stand:players] resistance 5 1 true`)
            }
            if (score(player, "life_level") == 3) {
                player.runCommand(`effect @e[name="${player.name}",type=stand:players] resistance 5 0 true`)
            }
        }

        if (player.hasTag("detect_attack") && score(player, "stand_summon") == 1 && !player.hasTag("be_stopped_of_time")) {

            switch (player.selectedSlotIndex) {

                //普普通通的连招
                case 0:
                    if (cpNoSkill(player) && defendData[player.name]["isDefend"] != true) {
                        player.runCommand("playanimation @s animation.stand.cp.m1" + combo[player.name]["m"])

                        combo[player.name]["time"] = 7
                        player.runCommand("scoreboard players set @s stand_fpp_invisibility 0")
                        triggerEvent(player)

                        attacks(player, (5 * (score(player, "stand_level") / 100) + 5), 8)
                        breakBlock(player, 4)

                        let entities = getEntites(player, 4)
                        if (!entities[0]) {
                            player.runCommand("playsound game.player.attack.strong @a ~~~ 100 1 0")
                        }

                        system.runTimeout(() => {
                            if (combo[player.name]["time"] == 0 && cpNoSkill(player)) {
                                player.runCommand("scoreboard players set @s stand_fpp_invisibility 1")
                                triggerEvent(player)
                                combo[player.name]["m"] = "a"
                            }
                        }, 20)

                        //招式
                        if (combo[player.name]["m"] == "a") {
                            combo[player.name]["m"] = "b"
                            return;
                        }
                        if (combo[player.name]["m"] == "b") {
                            combo[player.name]["m"] = "a"
                            return;
                        }
                    }
                    break;
                case 1:
                    if (cpNoSkill(player) && score(player, "stand_skill_cd_2") == 0) {
                        system.runTimeout(() => {
                            player.runCommand("scoreboard players set @s stand_fpp_invisibility 0")
                            triggerEvent(player)
                            player.runCommand("playanimation @s animation.stand.cp.barrage")
                        }, 2);
                        player.runCommand("scoreboard players set @s stand_skill_cd_2 70")
                        let barrage = system.runInterval(() => {
                            attacks(player, (5 * (score(player, "stand_level") / 100) + 5), 3)
                            player.runCommand("effect @s slowness 1 0 true")
                            let entities = getEntites(player, 4)
                            if (!entities[0]) {
                                player.runCommand("playsound game.player.attack.strong @a ~~~ 100 1 0")
                            }
                            if (score(player, "stand_summon") == 0) {
                                system.clearRun(barrage)
                                player.runCommand("playanimation @s animation.player.scale")
                            }
                        }, 4)
                        system.runTimeout(() => {
                            if (barrage) {
                                system.clearRun(barrage)
                                system.runTimeout(() => {
                                    attacks(player, (10 * (score(player, "stand_level") / 100) + 10), 30)
                                    system.runTimeout(() => {
                                        player.runCommand("scoreboard players set @s stand_fpp_invisibility 1")
                                        triggerEvent(player)
                                    }, 10)
                                }, 2)
                            }
                        }, 50)
                    }
                    break;
                case 2:
                    if (score(player, "stand_skill_cd_3") == 0 && score(player, "stand_energy") > 5) {
                        player.runCommand("scoreboard players set @s stand_skill_cd_3 100")
                        player.runCommand("scoreboard players remove @s stand_energy 5")
                        player.runCommand("function cp/discharge")
                        player.runCommand("particle stand:electric_spark_particle ~~1.25~")
                        player.runCommand("playsound random.orb @a[r=10] ~~~ 0.5 0.75")
                        player.runCommand("playanimation @s animation.humanoid.brandish_spear move 1")
                    }
                    break;
                case 3:
                    if (score(player, "stand_skill_cd_4") == 0 && score(player, "stand_energy") > 20) {
                        player.runCommand("scoreboard players set @s stand_skill_cd_4 100")
                        player.runCommand("effect @s resistance 2 255 true")
                        player.runCommand("particle stand:cp_summon ~~1~")
                        player.runCommand("particle stand:cp_ground ~~~")
                        player.runCommand("playanimation @s animation.evoker.casting.v1.0 move 1.5")
                        player.runCommand("playsound beacon.ambient @a ~~~ 100 1 0")
                        player.runCommand("tp @s @s")
                        player.runCommand("camera @s set minecraft:free pos ^^2^3 facing @s")
                        let ts_tp = system.runInterval(() => {
                            player.runCommand("tp @s @s")
                            if (score(player, "stand_summon") == 0) {
                                system.clearRun(ts_tp)
                                player.runCommand("camera @s clear")
                                player.runCommand("playanimation @s animation.player.scale")
                            }
                        }, 1)
                        system.runTimeout(() => {
                            if (ts_tp) {
                                system.clearRun(ts_tp)
                                player.runCommand("scoreboard players remove @s stand_energy 20")
                                player.runCommand("execute as @e[r=7,type=!stand:players,rm=0.1,family=!inanimate,type=!item] at @s run summon minecraft:lightning_bolt")
                                player.runCommand("summon minecraft:lightning_bolt ^^^3")
                                player.runCommand("execute as @e[r=7,type=!stand:players,rm=0.1,family=!inanimate,type=!item] at @s run damage @s 15 lightning")
                                player.runCommand("effect @s fire_resistance 4 1 true")
                                player.runCommand("playsound random.orb @a[r=10] ~~~ 0.5 0.9")
                                player.runCommand("camerashake add @a[r=10] 0.25 0.2 positional")
                                player.runCommand("camera @s clear")
                            }
                        }, 20)
                        
                    }
                    break;
            }
        }
    }


//放电
world.afterEvents.entityHurt.subscribe(event => {
    var player = event.hurtEntity
    if (event.damageSource.damagingEntity) {
        var entity = event.damageSource.damagingEntity
    } else {
        var entity = undefined
    }
    if (entity) {
        if (score(entity, "stand_energy") >= 1 && score(entity, "stand_summon") == 1 && score(entity, "stand_type_id") == 6) {
            player.runCommand("particle stand:electric_spark_particle ~~1~")
            player.runCommand("particle stand:electric_spark_particle ~~1~")
            player.runCommand("effect @s wither 2 5 true")
        }
    }
});

//维度
world.afterEvents.playerDimensionChange.subscribe(event => {
    var player = event.player
    var dimension = event.fromDimension
    var location = event.fromLocation
    if (score(player, "stand_type_id") == 6 && score(player, "stand_summon") == 1) {
        var teleportOptions = {
            dimension: dimension,
        }
        player.teleport(location, teleportOptions)
    }
});

//-----------------------------------------------------
//函数
//________________________________________________________________

export function cpNoSkill(player) {
    function score(player, objective) {
        try {
            return world.scoreboard.getObjective(objective)
                .getScore(player.scoreboardIdentity)
        } catch (e) {
            return 0;
        }
    }
    if (score(player, "stand_skill_cd_2") == 0 && score(player, "stand_skill_cd_4") < 70 && combo[player.name]["time"] == 0) {
        return true;
    } else {
        return false;
    }
}

function attacks(player, damage, kc) {
    let entities = getEntites(player, 4)
    for (let i = 0; i < entities.length; i++) {
        attack(player, entities[i].entity, damage, kc, entities[i].distance)
    }
}

function randomNum(minNum, maxNum) {
    switch (arguments.length) {
        case 1:
            return parseInt(Math.random() * minNum + 1, 10);
            break;
        case 2:
            return parseInt(Math.random() * (maxNum - minNum + 1) + minNum, 10);
            break;
        default:
            return 0;
            break;
    }
};

//充电
function charge(player) {
    var block = player.dimension.getBlock({
        x: player.location.x,
        y: player.location.y,
        z: player.location.z
    });
    var redStonePower = block.getRedstonePower()
    if (!redStonePower) {
        redStonePower = 0
    }
    if (redStonePower >= 1) {
        if (!player.isSneaking) {
            if (system.currentTick % 1 === 0) {
                player.runCommand("particle stand:sparkler_emitter ~~1.25~")
                player.runCommand("playsound random.orb @a[r=10] ~~~ 0.5 0.4")
            }
        } else {
            player.runCommand("effect @s invisibility 1 1 true")
        }
        player.runCommand("scoreboard players add @s stand_energy 1")
    }
    block = player.dimension.getBlock({
        x: player.location.x,
        y: (player.location.y - 1),
        z: player.location.z
    });
    redStonePower = block.getRedstonePower()
    if (!redStonePower) {
        redStonePower = 0
    }
    if (redStonePower >= 1) {
        if (!player.isSneaking) {
            if (system.currentTick % 1 === 0) {
                player.runCommand("particle stand:sparkler_emitter ~~1.25~")
                player.runCommand("playsound random.orb @a[r=10] ~~~ 0.5 0.4")
            }
        } else {
            player.runCommand("effect @s invisibility 1 1 true")
        }
        player.runCommand("scoreboard players add @s stand_energy 1")
    }
}

//失电
function uncharge(player) {
    if (score(player, "stand_energy") == 0) return;
    player.runCommand("particle minecraft:death_explosion_emitter ~~1.25~")
    player.runCommand("playsound random.fizz @a[r=10] ~~~ 0.5 0.4")
    player.runCommand("scoreboard players remove @s stand_energy 1")
}

//召唤
export function summonPlayer(player) {
    player.runCommand(`summon stand:players  ~ ~ ~ ~ ~ ? "${player.name}"`)
    const equipmentCompPlayer = player.getComponent(EntityComponentTypes.Equippable);
    if (equipmentCompPlayer) {
        try {
            player.runCommand(`replaceitem entity @e[name=${player.name},type=stand:players] slot.armor.head 0 ${equipmentCompPlayer?.getEquipment("Head").typeId??"air"} 1 32767 {"keep_on_death":{}}`)
        } catch (e) {}
        try {
            player.runCommand(`replaceitem entity @e[name=${player.name},type=stand:players] slot.armor.chest 0 ${equipmentCompPlayer?.getEquipment("Chest").typeId??"air"} 1 32767 {"keep_on_death":{}}`)
        } catch (e) {}
        try {
            player.runCommand(`replaceitem entity @e[name=${player.name},type=stand:players] slot.armor.legs 0 ${equipmentCompPlayer?.getEquipment("Legs").typeId??"air"} 1 32767 {"keep_on_death":{}}`)
        } catch (e) {}
        try {
            player.runCommand(`replaceitem entity @e[name=${player.name},type=stand:players] slot.armor.feet 0 ${equipmentCompPlayer?.getEquipment("Feet").typeId??"air"} 1 32767 {"keep_on_death":{}}`)
        } catch (e) {}
    }
}