//-----------------------------------------------------
//导入
//________________________________________________________________

import { ItemStack, world, system } from '@minecraft/server';
import { ActionFormData, ModalFormData } from '@minecraft/server-ui';
import { score, set } from 'score.js';
import { triggerEvent } from 'main.js';
import { attack, projectile, getEntites, breakBlock } from 'base/attack.js';
import { defendData } from 'base/defend.js';

//-----------------------------------------------------
//初始变量
//________________________________________________________________

let combo = {
    "playerName": {
        "m": "a",
        "time": 0
    }
}

//-----------------------------------------------------
//本体
//________________________________________________________________

export

function e3(player) {

        //初始化
        if (combo[player.name] == undefined) {
            combo[player.name] = {
                "m": "a",
                "time": 0
            }
        }
        if (combo[player.name]["time"] > 0) {
            combo[player.name]["time"] -= 1
        }

        if (player.hasTag("detect_attack") && score(player, "stand_summon") == 1 && !player.hasTag("be_stopped_of_time")) {

            switch (player.selectedSlotIndex) {

                case 0:
                    if (e3NoSkill(player) && defendData[player.name]["isDefend"] != true) {
                        player.runCommand("playanimation @s animation.stand.e3.m1" + combo[player.name]["m"])

                        combo[player.name]["time"] = 8
                        player.runCommand("scoreboard players set @s stand_fpp_invisibility 0")
                        triggerEvent(player)

                        attacks(player, (5 * (score(player, "stand_level") / 100) + 5), 8)
                        breakBlock(player, 4)

                        system.runTimeout(() => {
                            if (combo[player.name]["time"] == 0 && e3NoSkill(player)) {
                                player.runCommand("scoreboard players set @s stand_fpp_invisibility 1")
                                triggerEvent(player)
                                combo[player.name]["m"] = "a"
                            }
                        }, 14)

                        //招式
                        if (combo[player.name]["m"] == "a") {
                            combo[player.name]["m"] = "b"
                            return;
                        }
                        if (combo[player.name]["m"] == "b") {
                            combo[player.name]["m"] = "a"
                            return;
                        }
                    }
                    break;
                case 1:
                    if (e3NoSkill(player) && score(player, "stand_skill_cd_2") == 0) {
                        system.runTimeout(() => {
                            player.runCommand("scoreboard players set @s stand_fpp_invisibility 0")
                            triggerEvent(player)
                            player.runCommand("playanimation @s animation.stand.e3.barrage")
                        }, 2);
                        player.runCommand("scoreboard players set @s stand_skill_cd_2 70")
                        let barrage = system.runInterval(() => {
                            player.runCommand("effect @s slowness 1 0 true")
                            attacks(player, (5 * (score(player, "stand_level") / 100) + 5), 3)
                        }, 2)
                        system.runTimeout(() => {
                            system.clearRun(barrage)
                            system.runTimeout(() => {
                                attacks(player, (10 * (score(player, "stand_level") / 100) + 10), 30)
                                system.runTimeout(() => {
                                    player.runCommand("scoreboard players set @s stand_fpp_invisibility 1")
                                    triggerEvent(player)
                                }, 10)
                            }, 2)
                        }, 50)
                    }
                    break;
                case 2:
                    if (e3NoSkill(player) && score(player, "stand_skill_cd_3") == 0) {
                        player.runCommand("scoreboard players set @s stand_fpp_invisibility 0")
                        triggerEvent(player)
                        player.runCommand("playsound shit @a ~~~ 100 1 0")
                        player.runCommand("playanimation @s animation.stand.e3.shoot")
                        player.runCommand("effect @s slowness 2 1 true")
                        player.runCommand("scoreboard players set @s stand_skill_cd_3 120")
                        let effect_system = system.runInterval(() => {
                            effect(player)
                            player.selectedSlotIndex = 2
                            if (player.hasTag("detect_attack") && score(player, "stand_skill_cd_3") < 110 || player.hasTag("be_stopped_of_time")) {
                                system.clearRun(effect_system)
                                triggerEvent(player)
                                player.runCommand("playanimation @s animation.stand.e3.null")
                                player.runCommand("scoreboard players set @s stand_fpp_invisibility 1")
                                player.runCommand("scoreboard players add @s stand_skill_cd_3 1")
                                player.runCommand("effect @s slowness 0 1 true")
                            }
                        })
                        system.runTimeout(() => {
                            if (effect_system) {
                                system.clearRun(effect_system)
                                triggerEvent(player)
                                player.runCommand("scoreboard players set @s stand_fpp_invisibility 1")
                                player.runCommand("effect @s slowness 0 1 true")
                            }
                        }, 40)
                    }
                    break;
                case 3:
                    if (e3NoSkill(player) && score(player, "stand_skill_cd_4") == 0 && score(player, "stand_level") >= 40 && score(player, "stand_energy") >= 25) {
                        player.runCommand("playsound shit @a ~~~")
                        player.runCommand("particle stand:e3g ~~1~")
                        player.runCommand("scoreboard players remove @s stand_energy 25")
                        player.runCommand("playsound conduit.activate @a ~~~ 100 1 0")
                        set(player, "stand_skill_cd_4", (180 * (score(player, "stand_level") / 100) + 180))
                        const r = (5 * (score(player, "stand_level") / 100) + 5)
                        let gravity = system.runInterval(() => {
                            if (!player.hasTag("be_stopped_of_time")) {
                                player.runCommand(`tag @e[rm=1,r=${r},type=!item,type=!boat,type=!chest_minecart,type=!xp_orb,tag=!gravity] add gravity`)
                                player.runCommand(`scoreboard players set @e[rm=1,r=${r},type=!item,type=!boat,type=!chest_minecart,type=!xp_orb,tag=!gravity] gravity_time 0`)
                            }
                        }, 1)
                        system.runTimeout(() => {
                            system.clearRun(gravity)
                            player.runCommand("playsound conduit.deactivate @a ~~~ 100 1 0")
                        }, (100 * (score(player, "stand_level") / 100) + 100))
                    }
                    break
            }
        }
    
}

//-----------------------------------------------------
//函数
//________________________________________________________________

export

function e3NoSkill(player) {
    function score(player, objective) {
        try {
            return world.scoreboard.getObjective(objective)
                .getScore(player.scoreboardIdentity)
        } catch (e) {
            return 0;
        }
    }
    if (combo[player.name]["time"] == 0 && score(player, "stand_skill_cd_2") == 0) {
        return true;
    } else {
        return false;
    }
}

function attacks(player, damage, kc) {
    let entities = getEntites(player, 4)
    for (let i = 0; i < entities.length; i++) {
        attack(player, entities[i].entity, damage, kc, entities[i].distance)
    }
    if (entities[0] == undefined) {
        player.runCommand("playsound game.player.attack.strong @a ~~~ 100 2 0")
    }
}

function effect(player) {
    let entities = getEntites(player, 8)
    for (let i = 0; i < entities.length; i++) {
        entities[i].entity.addTag("gravity")
        entities[i].entity.runCommand("scoreboard players set @s gravity_time 0")
    }
}

//取随机整数
function randomNum(minNum, maxNum) {
    switch (arguments.length) {
        case 1:
            return parseInt(Math.random() * minNum + 1, 10);
            break;
        case 2:
            return parseInt(Math.random() * (maxNum - minNum + 1) + minNum, 10);
            break;
        default:
            return 0;
            break;
    }
};