//-----------------------------------------------------
//导入
//________________________________________________________________

import { ItemStack, world, system, EntityComponentTypes } from '@minecraft/server';
import { attack, idAttack, getEntites } from 'base/attack.js';
import { score, set } from 'score.js';
import { compress, decompress } from 'text/compress.js'

//-----------------------------------------------------
//变量
//________________________________________________________________

let anbss = {
    "player.name": {
        "cd": 0
    }
}

//-----------------------------------------------------
//事件
//________________________________________________________________

world.afterEvents.itemUse.subscribe(event => {
    const item = event.itemStack;
    const player = event.source;
    if (item.typeId != "stand:anbss") return;
    
    if (!anbss[player.name]) {
        anbss[player.name] = {
            "cd": 0
        }
    }
    
    if (player.isSneaking) {
        if ( anbss[player.name]["cd"] == 0 ) {
            if (score(player, "stand_type_id") == 6 && score(player, "stand_summon") == 1)return;
                if (score(player, "stand_energy") >= 50) {
                    player.runCommand("scoreboard players remove @s stand_energy 50")
                    anbss[player.name]["cd"] = 300
                    const name = player.name
                    system.runTimeout(() => {
                        anbss[name]["cd"] = 0
                    }, 300)
                    anbssSkill(player)
                } else {
                    player.sendMessage("§7必须献给「阿努比斯神」更多的精神力")
                }
            
            
        } else {
            player.sendMessage(`§7「阿努比斯神」无力回应你的召唤`)
        }
    }
});

system.afterEvents.scriptEventReceive.subscribe(event => {
    const player = event.sourceEntity;
    const id = event.id;
    const message = event.message;
    if (id == "stand:anbssAttack") {
        anbssAttack(player)
    }
    if (id == "stand:idAttack") {
        idAttack(message, player.id, parseInt(4*(anbssDamageA(world.getEntity(message))+1)), 5.010203, -1)
    }
})

world.afterEvents.entityHurt.subscribe(event => {
    
    try {
        const entity = event.hurtEntity;
        const player = event.damageSource.damagingEntity
                
        
    } catch(error) {
        world.sendMessage(`${error}`)
    }
})

//-----------------------------------------------------
//函数
//________________________________________________________________

//取随机整数
function randomNum(minNum, maxNum) {
    switch (arguments.length) {
        case 1:
            return parseInt(Math.random() * minNum + 1, 10);
            break;
        case 2:
            return parseInt(Math.random() * (maxNum - minNum + 1) + minNum, 10);
            break;
        default:
            return 0;
            break;
    }
};

function anbssSkill(player) {

    const anbs_player = player.dimension.spawnEntity("stand:anbs_player", player.location)
    anbs_player.nameTag = `§d${player.nameTag} 阿努比斯神`
    
    //装备
    const equipmentCompPlayer = player.getComponent(EntityComponentTypes.Equippable);
    if (equipmentCompPlayer) {
        try {
            anbs_player.runCommand(`replaceitem entity @s slot.armor.head 0 ${equipmentCompPlayer?.getEquipment("Head").typeId??"air"} 1 32767 {"keep_on_death":{}}`)
        } catch (e) {}
        try {
            anbs_player.runCommand(`replaceitem entity @s slot.armor.chest 0 ${equipmentCompPlayer?.getEquipment("Chest").typeId??"air"} 1 32767 {"keep_on_death":{}}`)
        } catch (e) {}
        try {
            anbs_player.runCommand(`replaceitem entity @s slot.armor.legs 0 ${equipmentCompPlayer?.getEquipment("Legs").typeId??"air"} 1 32767 {"keep_on_death":{}}`)
        } catch (e) {}
        try {
            anbs_player.runCommand(`replaceitem entity @s slot.armor.feet 0 ${equipmentCompPlayer?.getEquipment("Feet").typeId??"air"} 1 32767 {"keep_on_death":{}}`)
        } catch (e) {}
    }
    
    anbs_player.runCommand("effect @s strength 114514 1 true")
    anbs_player.runCommand(`effect @s speed ${score(player, "speed") - 1 > 0 ? 114514 : 0} ${score(player, "speed") - 1 > 0 ? score(player, "speed") - 1 : 0} true`)
    if (score(player, "speed") == 3) {
        anbs_player.runCommand(`effect @s jump_boost 114514 1 true`)
    }
    
    //精神
    if (score(player, "life_level") >= 1) {
        anbs_player.runCommand("effect @s speed 114514 0 true")
    }
    if (score(player, "life_level") >= 2) {
        anbs_player.runCommand("effect @s strength 114514 2 true")
    }
    if (score(player, "life_level") >= 3) {
        anbs_player.runCommand("effect @s resistance 114514 0 true")
    }
    
    //生命
    anbs_player.getComponent("health").setCurrentValue(player.getComponent("health").currentValue)
    const old_anbs_player = anbs_player.getComponent("health").currentValue
    
    //叠层
    set(anbs_player, "mr.a",parseInt(anbssDamageA(player)*100))
    
    //玩家循环
    player.addTag("anbs_player")
    let anbsS = system.runInterval(() => {
        try  {
            if (player && anbs_player) {
                player.runCommand(`tp @s[tag=anbs_player] ${player.location.x} ${anbs_player.location.y+500} ${player.location.z}`)
                anbs_player.runCommand(`execute as @s at @s run camera @p[name="${player.name}",tag=anbs_player] set minecraft:free pos ^^1.7^0.5 facing ^^1.5^3 `)
                player.runCommand("scoreboard players set @s[scores={stand_skill_cd_1=..2}] stand_skill_cd_1 2")
                player.runCommand("scoreboard players set @s[scores={stand_skill_cd_2=..2}] stand_skill_cd_2 2")
                player.runCommand("scoreboard players set @s[scores={stand_skill_cd_3=..2}] stand_skill_cd_3 2")
                player.runCommand("scoreboard players set @s[scores={stand_skill_cd_4=..2}] stand_skill_cd_4 2")
                if (player.hasTag("time_stopper")) {
                    anbs_player.addTag("time_stopper")
                } else {
                    anbs_player.removeTag("time_stopper")
                }
                if (!player.hasTag("anbs_player")) {
                    if (anbs_player.getComponent("health").currentValue == old_anbs_player) {
                        player.getComponent("health").setCurrentValue(player.getComponent("health").currentValue)
                    } else {
                        player.getComponent("health").setCurrentValue(anbs_player.getComponent("health").currentValue)
                    }
                    anbs_player.runCommand(`tp @a[name="${player.name}"] ~~~`)
                    player.runCommand("camera @s clear")
                    anbs_player.remove()
                    system.clearRun(anbsS);
                }
            } else {
                player.runCommand("camera @s clear")
                player.runCommand("kill")
                system.clearRun(anbsS);
                if (anbs_player) {
                    try {
                        anbs_player.remove()
                    } catch(error) {}
                }
            }
        } catch(error) {
            system.clearRun(anbsS);
            
        }
    }, 1);
    
    system.runTimeout(() => {
        player.removeTag("anbs_player")
    }, 300)
    
    system.runTimeout(() => {
        player.runCommand("camera @s clear")
        if (anbs_player) {
            try {
                anbs_player.remove()
            } catch(error) {}
        }
    }, 310)
}

export function anbssLore(player, entity) {
    if (
         player.getComponent("minecraft:inventory").container.getItem(player.selectedSlotIndex) && 
         player.getComponent("minecraft:inventory").container.getItem(player.selectedSlotIndex).typeId == "stand:anbss"
    ) 
    {
       let n = randomNum(1, 10)
        if (n==1) { player.sendMessage({ translate: "npc.anbs.body1" }) }
        if (n==2) { player.sendMessage({ translate: "npc.anbs.body2" }) }
        if (n==3) { player.sendMessage({ translate: "npc.anbs.body3" }) }
        if (n==4) { player.sendMessage({ translate: "npc.anbs.body4" }) }
        let container = player.getComponent("minecraft:inventory").container
        let item = container.getItem(player.selectedSlotIndex)
        let lore = item.getLore()
        if (lore == "") {
            lore = ["§r初始伤害: 4", "§r造成当前伤害25%%的破甲伤害;潜行移动进行突进;潜行使用召唤§d阿努比斯神§r", "§r击杀倍率(击杀不同种类生物以增加倍率):", "§r0%%", "§r§7",]
        }
        let l = lore.length
        let index_of = false
        for (let i = 0; i < l; i++) {
            if (lore[i].indexOf(compress(entity.typeId.replace("minecraft:", ""))) != -1) {
                index_of = true;
            }
        }
        if (!index_of) {
            let try_lore = false
            let tried = false
            for (let i = 0; i < l; i++) {
                if (i > 3 && `${lore[i]}${compress(entity.typeId.replace("minecraft:", ""))} `.length<=50) {
                    lore[i] = `${lore[i]}${compress(entity.typeId.replace("minecraft:", ""))} `
                    lore[3] = `§r${parseInt(lore[3].replace("§r", ""))+parseInt(133.3/(parseInt(lore[3].replace("§r", ""))+13.3)+6)}%%`
                    item.setLore(lore)
                    container.setItem(player.selectedSlotIndex, item)
                    return;
                }
                if (i == l - 1) {
                    lore[l] = `${lore[l]??"§r§7"}${compress(entity.typeId.replace("minecraft:", ""))} `
                    lore[3] = `§r${parseInt(lore[3].replace("§r", ""))+parseInt(133.3/(parseInt(lore[3].replace("§r", ""))+13.3)+6)}%%`
                    item.setLore(lore)
                    container.setItem(player.selectedSlotIndex, item)
                    return;
                }
            }
        }
       
    }
}

export function anbssDamageA(player) {
    if (player.typeId == "stand:anbs_player") {
        return score(player, "mr.a")/50
    }
    if (
         player.getComponent("minecraft:inventory").container.getItem(player.selectedSlotIndex) && 
         player.getComponent("minecraft:inventory").container.getItem(player.selectedSlotIndex).typeId == "stand:anbss"
    ) 
    {
       
        let container = player.getComponent("minecraft:inventory").container
        let item = container.getItem(player.selectedSlotIndex)
        let lore = item.getLore()
        if (lore == "") {
            return 0;
        } else {
            return parseInt(lore[3].replace("§r", ""))/100;
        }
    } else {
        return 0;
    }
}

export function anbssAttack(player) {
    player.runCommand("scoreboard players set @s tf 1")
    player.runCommand("playsound sweep @a ~~~ 100 1.1 0")
    player.runCommand("camerashake add @s 0.2 0.1 positional")
    system.runTimeout(() => {
        player.runCommand("scoreboard players set @s tf 0")
    }, 7.5)
    if( player.isSneaking){
        const v = player.getVelocity();
	    let abs_v = v.x*v.x + v.z*v.z;
	    if( abs_v > 0.01 ){
		    abs_v = 0.01
	    }
	    const d = player.getViewDirection();
	    player.applyKnockback(d.x,d.z,abs_v*400,0)
	}
    
    //attack(player, entity, amount, strength, distance)
    if (!player.isSneaking && player.typeId == "minecraft:player") {
        player.runCommand(`execute as @s at @s positioned ^^1.5^2.1 run execute as @e[r=2,type=!stand:paper] run scriptevent stand:idAttack ${player.id}`)
    }
    if (!player.isSneaking && player.typeId == "stand:anbs_player") {
        player.runCommand(`execute as @s at @s positioned ^^1.5^3.1 run execute as @e[r=3,type=!stand:paper] run scriptevent stand:idAttack ${player.id}`)
    }
}

export function anbs(player) {
    if (player.getComponent("minecraft:inventory").container.getItem(player.selectedSlotIndex) && player.getComponent("minecraft:inventory").container.getItem(player.selectedSlotIndex).typeId == "stand:anbss") {
    
        const entities = player.dimension.getEntities({
            name: `§d${player.nameTag} 阿努比斯神`,
            type: "stand:anbs"
        });
        
        if (!entities[0] && !player.hasTag("anbs_person")) {
            const anbs = player.dimension.spawnEntity("stand:anbs", player.location)
            anbs.nameTag = `§d${player.nameTag} 阿努比斯神`
            anbs.getComponent("minecraft:tameable").tame(player)
        }
        
    } 
    // else {
        // const entities = player.dimension.getEntities({
            // name: `§d${player.nameTag} 阿努比斯神`,
            // type: "stand:anbs"
        // });
        // if (entities[0]) {
            // entities[0].remove()
        // }
    // }
}