//-----------------------------------------------------
//导入
//________________________________________________________________

import { ItemStack, world, system } from '@minecraft/server';
import { ActionFormData,  ModalFormData} from '@minecraft/server-ui';
import { score, set } from 'score.js'; 
import { triggerEvent } from 'main.js';
import { attack, projectile, getEntites, breakBlock } from 'base/attack.js';
import { defendData } from 'base/defend.js';

//-----------------------------------------------------
//初始变量
//________________________________________________________________

export let combo = {
    "playerName": {
        "m": "a",
        "time": 0
    }
}

export let comboBoomId = {
    "playerName": 114514
}

let skillBoom = {
    "playerName": {
        "type": "entity",
        "id": 114514,
        "location": {
            "x": 0,
            "y": 0,
            "z": 0
        },
        "touch": true
    }
}

//-----------------------------------------------------
//本体
//________________________________________________________________

export function kq(player) {

        player.runCommand(`tp @e[name="§d${player.name} 枯萎穿心攻击",rm=20,r=100] @s`)
        //初始化
        if (skillBoom[player.name] == undefined) {
            skillBoom[player.name] = {
                "type": "entity",
                "id": 114514,
                "location": {
                    "x": 0,
                    "y": 0,
                    "z": 0
                },
                "dimension": "overworld",
                "touch": true
            }
        }
        if (combo[player.name] == undefined) {
            combo[player.name] = {
                "m": "a",
                "time": 0
            }
        }
        if (combo[player.name]["time"] > 0) {
            combo[player.name]["time"] -= 1
        }

        //TNT标记
        try { tntSign(player) } catch(error) {}

        if (player.hasTag("detect_attack") && score(player, "stand_summon") == 1 && !player.hasTag("be_stopped_of_time")) {

            switch (player.selectedSlotIndex) {

                //攻→攻→炸
                case 0:
                    if (kqNoSkill(player) && defendData[player.name]["isDefend"] != true) {
                        if (player.hasTag("combo_c")) {
                            combo[player.name]["m"] = "c"
                            player.removeTag("combo_c")
                        }
                        if (player.hasTag("combo_c2")) {
                            combo[player.name]["m"] = "c"
                            player.removeTag("combo_c2")
                        }
                        
                        player.runCommand("playanimation @s animation.stand.kq.m1" + combo[player.name]["m"])

                        combo[player.name]["time"] = 8
                        player.runCommand("scoreboard players set @s stand_fpp_invisibility 0")
                        triggerEvent(player)

                        if (combo[player.name]["m"] == "a" || combo[player.name]["m"] == "b") {
                            attacks(player, (6 * (score(player, "stand_level") / 100) + 6), 10)
                            breakBlock(player, 4)
                            //登记
                            let entities = getEntites(player, 3.5)
                            if (entities[0] != undefined) {
                                comboBoomId[player.name] = entities[0].entity.id
                            } else {
                                player.runCommand("playsound game.player.attack.strong @a ~~~ 100 1 0")
                            }
                        };
                        if (combo[player.name]["m"] == "c") {
                            system.runTimeout(() => {
                                player.runCommand("playsound boom @a ~~~ 100 1 0")
                                try {
                                    entityBoom(world.getEntity(comboBoomId[player.name]), player)
                                    comboBoomId[player.name] = 114514
                                } catch (e) {}
                            }, 5)
                        };

                        system.runTimeout(() => {
                            if (combo[player.name]["time"] == 0) {
                                player.runCommand("scoreboard players set @s stand_fpp_invisibility 1")
                                triggerEvent(player)
                                combo[player.name]["m"] = "a"
                            }
                        }, 12)

                        //招式
                        switch (combo[player.name]["m"]) {
                            case 'a':
                                combo[player.name]["m"] = "b"
                                break;
                            case 'b':
                                combo[player.name]["m"] = "c"
                                break;
                            case 'c':
                                combo[player.name]["m"] = "a"
                                break;
                        }
                    }
                    break;
                case 1:
                    if (kqNoSkill(player) && score(player, "stand_skill_cd_2") == 0) {
                        system.runTimeout(() => {
                            player.runCommand("scoreboard players set @s stand_fpp_invisibility 0")
                            triggerEvent(player)
                            player.runCommand("playanimation @s animation.stand.kq.barrage")
                        }, 2);
                        player.runCommand("scoreboard players set @s stand_skill_cd_2 60")
                        let barrage = system.runInterval(() => {
                            player.runCommand("scoreboard players set @s stand_fpp_invisibility 0")
                            triggerEvent(player)
                            attacks(player, (6 * (score(player, "stand_level") / 100) + 6), 3)
                            player.runCommand("effect @s slowness 1 0 true")
                            let entities = getEntites(player, 4)
                            if (entities[0] != undefined) {
                                comboBoomId[player.name] = entities[0].entity.id
                            } else {
                                player.runCommand("playsound game.player.attack.strong @a ~~~ 100 1 0")
                            }
                        }, 4)
                        system.runTimeout(() => {
                            system.clearRun(barrage)
                            system.runTimeout(() => {
                                let entities = getEntites(player, 4)
                                if (entities[0] != undefined) {
                                    comboBoomId[player.name] = entities[0].entity.id
                                } else {
                                    player.runCommand("playsound game.player.attack.strong @a ~~~ 100 1 0")
                                }
                                attacks(player, (12 * (score(player, "stand_level") / 100) + 12), 30)
                                system.runTimeout(() => {
                                    player.runCommand("scoreboard players set @s stand_fpp_invisibility 1")
                                    triggerEvent(player)
                                }, 10)
                            }, 2)
                        }, 50)
                    }
                    break;
                case 2:
                    if (skillBoom[player.name]["touch"] && kqNoSkill(player) && !player.isSneaking) {
                        let entity;
                        let block;
                        player.runCommand("scoreboard players set @s stand_skill_cd_3 5")
                        if (getEntites(player, 4)[0] != undefined) {
                            entity = getEntites(player, 4)[0].entity
                        }
                        if (player.getBlockFromViewDirection({
                            maxDistance: 4
                        }) != undefined) {
                            block = player.getBlockFromViewDirection({
                                maxDistance: 4
                            })
                                .block
                        }
                        if (entity) {
                            player.runCommand("scoreboard players set @s stand_fpp_invisibility 0")
                            player.runCommand("playanimation @s animation.stand.kq.touch")
                            attacks(player, 0, 35)
                            system.runTimeout(() => {
                                player.runCommand("scoreboard players set @s stand_fpp_invisibility 1")
                            }, 10)
                            player.runCommand("scoreboard players set @s stand_skill_cd_3 20")
                            player.runCommand("playsound block.enchanting_table.use @a ~~~ 100 1 0")
                            entity.runCommand("particle stand:kq_entity_touch ~~1~")
                            skillBoom[player.name] = {
                                "type": "entity",
                                "id": entity.id,
                                "location": {
                                    "x": 0,
                                    "y": 0,
                                    "z": 0
                                },
                                "dimension": "overworld",
                                "touch": false
                            }
                        }
                        if (!entity && block) {
                            player.runCommand("scoreboard players set @s stand_fpp_invisibility 0")
                            player.runCommand("playanimation @s animation.stand.kq.touch")
                            system.runTimeout(() => {
                                player.runCommand("scoreboard players set @s stand_fpp_invisibility 1")
                            }, 10)
                            player.runCommand("scoreboard players set @s stand_skill_cd_3 20")
                            player.runCommand("playsound block.enchanting_table.use @a ~~~ 100 1 0")
                            skillBoom[player.name] = {
                                "type": "block",
                                "id": 114514,
                                "location": {
                                    "x": block.x,
                                    "y": block.y,
                                    "z": block.z
                                },
                                "dimension": player.dimension.id,
                                "touch": false
                            }
                            player.dimension.spawnParticle("stand:kq_block_touch", {
                                x: (block.x + 0.5),
                                y: (block.y + 0.5),
                                z: (block.z + 0.5)
                            })
                        }
                    }
                    if (!skillBoom[player.name]["touch"] && kqNoSkill(player) && !player.isSneaking) {
                        player.runCommand("scoreboard players set @s stand_skill_cd_3 20")
                        player.runCommand("playanimation @s animation.stand.kq.boom")
                        system.runTimeout(() => {
                            player.runCommand("playsound boom @a ~~~ 100 1 0")
                            try {
                                entityBoom(world.getEntity(skillBoom[player.name]["id"]), player)
                            } catch (e) {}
                            if (skillBoom[player.name]["type"] == "block") {
                                blockBoom(player.dimension.getBlock({
                                    x: skillBoom[player.name]["location"]["x"],
                                    y: skillBoom[player.name]["location"]["y"],
                                    z: skillBoom[player.name]["location"]["z"]
                                }), player)
                            }
                            skillBoom[player.name] = {
                                "type": "entity",
                                "id": 114514,
                                "location": {
                                    "x": 0,
                                    "y": 0,
                                    "z": 0
                                },
                                "dimension": "overworld",
                                "touch": true
                            }
                        }, 10)
                    }
                    if (player.isSneaking && kqNoSkill(player)) {
                        player.runCommand("scoreboard players set @s stand_skill_cd_3 5")
                        let boomText = skillBoom[player.name]["type"] == "entity" ? `id: ${skillBoom[player.name]["id"] != 114514 ? skillBoom[player.name]["id"] : "无"}` : `x: ${skillBoom[player.name]["location"]["x"]}\ny: ${skillBoom[player.name]["location"]["y"]}\nz: ${skillBoom[player.name]["location"]["z"]}\n维度: ${skillBoom[player.name]["dimension"]}`
                        let ui = new ActionFormData()
                            .title({
                            translate: "ui.stand.kq.boom"
                        })
                            .body(boomText)
                            .button({
                            translate: "ui.leave"
                        }, "")
                            .show(player)
                    }
                    break;
                case 3:
                    if (score(player, "stand_skill_cd_4") == 0 && score(player, "stand_level") == 100 && score(player, "stand_energy") >= 60) {
                        player.runCommand("scoreboard players set @s stand_skill_cd_4 300")
                        player.runCommand("scoreboard players remove @s stand_energy 60")
                        player.runCommand(`summon stand:sheer_heart_attack ^^^0.5 ~ ~ ? "§d${player.name} 枯萎穿心攻击" `)
                        player.runCommand("particle stand:kqs_summon ^^1.25^0.5")
                        player.runCommand("playsound kq.car @a ~~~ 100 1 0")
                        const car = player.dimension.getEntities({
                            name: `§d${player.name} 枯萎穿心攻击`,
                            type: "stand:sheer_heart_attack"
                        })[0];
                        car.getComponent("minecraft:tameable").tame(player)
                    }
                    break
            }
        }
    
}

//-----------------------------------------------------
//函数
//________________________________________________________________

export

function kqNoSkill(player) {
    function score(player, objective) {
        try {
            return world.scoreboard.getObjective(objective)
                .getScore(player.scoreboardIdentity)
        } catch (e) {
            return 0;
        }
    }
    if (combo[player.name]["time"] == 0 && score(player, "stand_skill_cd_3") == 0 && score(player, "stand_skill_cd_2") == 0) {
        return true;
    } else {
        return false;
    }
}

//3.5格长的攻击距离！
export function attacks(player, damage, kc) {
    let entities = getEntites(player, 3.5)
    for (let i = 0; i < entities.length; i++) {
        attack(player, entities[i].entity, damage, kc, entities[i].distance)
    }
}

//艺术 = 爆炸
export function entityBoom(entity, player) {
    entity.runCommand("particle minecraft:lava_particle ~~1~")
    entity.runCommand("particle minecraft:huge_explosion_lab_misc_emitter ~~~")
    entity.runCommand("playsound random.explode @a[r=20] ~~~")
    entity.runCommand(`damage @e[r=3.5,name=!${player.nameTag}] 35 entity_explosion entity @a[name=${player.name}]`)
}

function blockBoom(block, player) {
    player.runCommand(`execute as @s in ${skillBoom[player.name]["dimension"].replace("minecraft:", "")} positioned ${block.x} ${block.y} ${block.z} run particle minecraft:lava_particle ~~1~`)
    player.runCommand(`execute as @s in ${skillBoom[player.name]["dimension"].replace("minecraft:", "")} positioned ${block.x} ${block.y} ${block.z} run particle minecraft:huge_explosion_lab_misc_emitter ~~~`)
    player.runCommand(`execute as @s in ${skillBoom[player.name]["dimension"].replace("minecraft:", "")} positioned ${block.x} ${block.y} ${block.z} run playsound random.explode @a[r=20] ~~~`)
    player.runCommand(`execute as @s in ${skillBoom[player.name]["dimension"].replace("minecraft:", "")} positioned ${block.x} ${block.y} ${block.z} run damage @e[r=4,name=!${player.name}] 35 entity_explosion entity @a[name=${player.name}]`)
}

//取随机整数
function randomNum(minNum, maxNum) {
    switch (arguments.length) {
        case 1:
            return parseInt(Math.random() * minNum + 1, 10);
            break;
        case 2:
            return parseInt(Math.random() * (maxNum - minNum + 1) + minNum, 10);
            break;
        default:
            return 0;
            break;
    }
};

//tnt图标
function tntSign(player) {
    if (skillBoom[player.name]["type"] == "block" && !skillBoom[player.name]["touch"]) {
        let location6 = {
            x: skillBoom[player.name]["location"]["x"],
            y: skillBoom[player.name]["location"]["y"] + 2,
            z: skillBoom[player.name]["location"]["z"]
        }
        player.spawnParticle("stand:tnt", location6)
    }
    if (player.dimension.getEntities({
        excludeNames: [`${player.name}`],
        location: player.location,
        maxDistance: 100,
        minDistance: 2,
        tags: [`id${skillBoom[player.name]["id"]}`]
    })[0]) {
        let location2 = player.dimension.getEntities({
            excludeNames: [`${player.name}`],
            location: player.location,
            maxDistance: 100,
            minDistance: 2,
            tags: [`id${skillBoom[player.name]["id"]}`]
        })[0].getHeadLocation();
        let location5 = player.dimension.getEntities({
            excludeNames: [`${player.name}`],
            location: player.location,
            maxDistance: 100,
            minDistance: 2,
            tags: [`id${skillBoom[player.name]["id"]}`]
        })[0].getHeadLocation();
        location5.y += 1.5
        let location1 = player.location
        location1.y += 2
        location2.x -= player.location.x
        location2.y -= player.location.y
        location2.z -= player.location.z
        var points = [{
            x: location1.x,
            z: location1.z,
            y: location1.y
        }, {
            x: location5.x,
            z: location5.z,
            y: location5.y
        }];
        points.dist = function() {
            var p1 = this[0];
            var p2 = this[1];
            var a = p2.x - p1.x;
            var b = p2.z - p1.z;
            var c = p2.y - p1.y;
            return Math.sqrt(a * a + b * b + c * c);
        };
        let d1 = points.dist()
        try {
            points = [{
                x: location1.x,
                z: location1.z,
                y: location1.y
            }, {
                x: player.dimension.getBlockFromRay(location1, location2) ? player.dimension.getBlockFromRay(location1, location2)
                    .block.location.x : location1.x,
                z: player.dimension.getBlockFromRay(location1, location2) ? player.dimension.getBlockFromRay(location1, location2)
                    .block.location.z : location1.z,
                y: player.dimension.getBlockFromRay(location1, location2) ? player.dimension.getBlockFromRay(location1, location2)
                    .block.location.y : location1.y
            }];
        } catch (e) {
            points = [{
                x: 0,
                y: 0,
                z: 0
            }, {
                x: 0,
                y: 0,
                z: 0
            }]
        }
        points.dist = function() {
            var p1 = this[0];
            var p2 = this[1];
            var a = p2.x - p1.x;
            var b = p2.z - p1.z;
            var c = p2.y - p1.y;
            return Math.sqrt(a * a + b * b + c * c);
        };
        // player.runCommand(`say "${points.dist()}  :  ${d1}"`)
        if (points.dist() < d1 && points.dist() != 0 || points.dist() == d1 && points.dist() != 0) {
            let location3 = player.dimension.getBlockFromRay(location1, location2)
                .block.location
            let face = player.dimension.getBlockFromRay(location1, location2)
                .face
            switch (face) {
                case "East":
                    location3.x += 0.25
                    break;
                case "North":
                    location3.z -= 0.25
                    break;
                case "South":
                    location3.z += 0.25
                    break;
                case "West":
                    location3.x -= 0.25
                    break;
            }
            let location4 = {
                x: location3.x + player.dimension.getBlockFromRay(location1, location2)
                    .faceLocation.x,
                y: location3.y + player.dimension.getBlockFromRay(location1, location2)
                    .faceLocation.y,
                z: location3.z + player.dimension.getBlockFromRay(location1, location2)
                    .faceLocation.z
            }

            player.spawnParticle("stand:tnt", location4)
        }
        if (points.dist() > d1 || points.dist() == 0) {
            player.spawnParticle("stand:tnt", location5)
        }
    }
}