//-----------------------------------------------------
//导入
//________________________________________________________________

import { ItemStack,  world,  system } from '@minecraft/server';
import { score, set } from 'score.js';
import { triggerEvent } from 'main.js';
import { attack, projectile, getEntites, breakBlock } from 'base/attack.js';
import { defendData } from 'base/defend.js';

//-----------------------------------------------------
//初始变量
//________________________________________________________________

let combo = {
    "playerName": {
        "m": "a",
        "time": 0
    }
}
let hurtTime = {
    "playerName": {
        "time": 0
    }
}

//-----------------------------------------------------
//事件
//________________________________________________________________
export

function sptw(player) {

        //没有变量自己造
        if (combo[player.name] == undefined) {
            combo[player.name] = {
                "m": "a",
                "time": 0
            }
        }
        if (hurtTime[player.name] == undefined) {
            hurtTime[player.name] = {
                "time": 0
            }
        }

        //减时间
        if (combo[player.name]["time"] > 0) {
            combo[player.name]["time"] -= 1
        }
        if (hurtTime[player.name]["time"] > 0) {
            hurtTime[player.name]["time"] -= 1
        }

        if (player.hasTag("detect_attack") && score(player, "stand_summon") == 1 && !player.hasTag("be_stopped_of_time")) {

            switch (player.selectedSlotIndex) {

                //普普通通的连招
                case 0:
                    if (sptwNoSkill(player) && defendData[player.name]["isDefend"] != true) {
                        player.runCommand("playanimation @s animation.stand.m1" + combo[player.name]["m"])

                        combo[player.name]["time"] = 9
                        var ora = randomNum(1, 4)
                        player.runCommand("scoreboard players set @s stand_fpp_invisibility 0")
                        triggerEvent(player)
                        attacks(player, (8 * (score(player, "stand_level") / 100) + 8), 10)
                        breakBlock(player, 5)
                        system.runTimeout(() => {
                            if (combo[player.name]["time"] == 0 && sptwNoSkill(player)) {
                                player.runCommand("scoreboard players set @s stand_fpp_invisibility 1")
                                triggerEvent(player)
                            }
                        }, 11.9)
                        if (combo[player.name]["m"] == "a") {
                            combo[player.name]["m"] = "b"
                            player.runCommand("playsound ora_" + ora + " @a ~~~ 100 1 0")
                            return;
                        }
                        if (combo[player.name]["m"] == "b") {
                            combo[player.name]["m"] = "a"
                            player.runCommand("playsound ora_" + ora + " @a ~~~ 100 1 0")
                            return;
                        }
                    }
                    break;

                    //ora!ora!!ora!!!
                case 1:
                    if (sptwNoSkill(player) && score(player, "stand_skill_cd_2") == 0) {
                        system.runTimeout(() => {
                            player.runCommand("scoreboard players set @s stand_fpp_invisibility 0")
                            triggerEvent(player)
                            player.runCommand("playanimation @s animation.stand.sptw.barrage")
                        }, 2);
                        player.runCommand("playsound barrage_ora @a ~~~ 100 1 0")
                        player.runCommand("scoreboard players set @s stand_skill_cd_2 60")
                        let barrage = system.runInterval(() => {
                            player.runCommand("scoreboard players set @s stand_fpp_invisibility 0")
                            triggerEvent(player)
                            attacks(player, (8 * (score(player, "stand_level") / 100) + 8), 10)
                            player.runCommand("effect @s slowness 1 0 true")
                        }, 4)
                        system.runTimeout(() => {
                            system.clearRun(barrage)
                            system.runTimeout(() => {
                                attacks(player, (16 * (score(player, "stand_level") / 100) + 16), 60)
                                system.runTimeout(() => {
                                    player.runCommand("scoreboard players set @s stand_fpp_invisibility 1")
                                    triggerEvent(player)
                                }, 10)
                            }, 2)
                        }, 50)
                    }
                    break;

                    //寒冰射手
                case 2:
                    if (sptwNoSkill(player) && score(player, "stand_skill_cd_3") == 0) {
                        player.runCommand("scoreboard players set @s stand_fpp_invisibility 0")
                        triggerEvent(player)
                        player.runCommand("playsound sptw_saying @a ~~~ 100 1 0")
                        player.runCommand("playanimation @s animation.stand.sptw.shoot")
                        player.runCommand("effect @s slowness 2 2 true")
                        player.runCommand("scoreboard players set @s stand_skill_cd_3 100")
                        let shoot = system.runInterval(() => {
                            player.selectedSlotIndex = 2
                            if (player.hasTag("detect_attack") && score(player, "stand_skill_cd_3") < 90 || player.hasTag("be_stopped_of_time")) {
                                system.clearRun(shoot)
                                player.runCommand("particle stand:sonic_explosion ^^1.5^1")
                                let detect = "";
                                let unless = "";
                                for (let i = 0; i < 30; i++) {
                                    detect = `${detect} if block ^^1.5^${1+i} air `
                                    unless = ` unless block ^^1.5^${1+i} air `
                                    player.runCommand(`execute as @s at @s ${detect} run particle stand:balloon_gas_particle ^^1.5^${1+i}`)
                                    player.runCommand(`execute as @s at @s ${unless} run particle minecraft:basic_flame_particle ^^1.7^${1+i}`)
                                };
                                shoots(player, (10 * (score(player, "stand_level") / 100) + 10), 2)
                                player.runCommand("playsound shoot @a ~~~ 100 1 0")
                                player.runCommand("playanimation @s animation.stand.sptw.null move 0")
                                player.runCommand("scoreboard players set @s stand_fpp_invisibility 1")
                                player.runCommand("scoreboard players add @s stand_skill_cd_3 1")
                                triggerEvent(player)
                                player.runCommand("effect @s slowness 0 3 true")
                            }
                        })
                        system.runTimeout(() => {
                            system.clearRun(shoot)
                            player.runCommand("scoreboard players set @s[scores={stand_skill_cd_3=0}] stand_fpp_invisibility 1")
                            triggerEvent(player)
                            player.runCommand("effect @s slowness 0 3 true")
                        }, 40)
                    }
                    break;

                    //时间停止
                case 3:

                    //可以感觉到的
                    if (sptwNoSkill(player) && score(player, "stand_skill_cd_4") == 0 && !player.isSneaking) {
                        if (score(player, "stand_energy") == 100 && score(player, "stand_level") >= 20) {
                            player.runCommand("scoreboard players set @s stand_skill_cd_4 " + (score(player, "stop_time") * 2 + 70))
                            set(player, "stand_energy", 0)
                            player.sendMessage("Star Platinum,")
                            player.runCommand("playanimation @s animation.stand.sptw.ts")
                            player.runCommand("camera @s set minecraft:free pos ^-1^2^2.5 facing @s")
                            player.runCommand("effect @s resistance 1 255 true")
                            let ts_tp = system.runInterval(() => {
                                player.runCommand("tp @s @s")
                            }, 1)
                            system.runTimeout(() => {
                                player.sendMessage("§eThe...")
                                player.runCommand("playsound ts @a[r=100]")
                            }, 5)
                            system.runTimeout(() => {
                                system.clearRun(ts_tp)
                                player.sendMessage("§eWorld!")
                                player.runCommand("camera @s clear")
                                player.runCommand("tag @s[tag=!be_stopped_of_time] add time_stop_start")
                                player.runCommand("effect @s resistance 0 255 true")
                            }, 20)
                            player.runCommand("scoreboard players set @s stand_fpp_invisibility 0")
                            system.runTimeout(() => {
                                player.runCommand("scoreboard players set @s stand_fpp_invisibility 1")
                            }, 20)
                        }
                    }
                    
                    if (score(player, "stand_skill_cd_4") < (score(player, "stop_time") * 2) && player.isSneaking && player.hasTag("time_stopper")) {
                        player.addTag("stop_time_stop")
                    }

                    //感觉不到的~
                    if (sptwNoSkill(player) && score(player, "stand_skill_cd_4") == 0 && player.isSneaking && !player.hasTag("time_stopper")) {
                        if (score(player, "stand_level") >= 20) {
                            player.runCommand("playsound tp @a ~~~ 100 1 0")
                            player.runCommand("effect @s blindness 1 1 true")
                            player.runCommand("tp ^^1^1 true")
                            player.runCommand("tp ^^^1 true")
                            player.runCommand("tp ^^^1 true")
                            player.runCommand("tp ^^^1 true")
                            player.runCommand("tp ^^^1 true")
                            player.runCommand("tp ^^^1 true")
                            player.runCommand("tp ^^^1 true")
                            player.runCommand("tp ^^^1 true")
                            player.runCommand("tp ^^^1 true")
                            player.runCommand("scoreboard players set @s stand_skill_cd_4 20")
                        }
                    }
                    break;
            }
        }
    
}

world.afterEvents.entityHurt.subscribe(event => {
    try {
        var entity = event.hurtEntity;
        if (entity.typeId == "minecraft:player" && score(entity, "stand_type_id") == 1) {
            if (hurtTime[entity.name]["time"] == 0) {
                hurtTime[entity.name]["time"] = 400
                entity.runCommand(`effect @s strength 5 2 true`)
                //呀卡马西！
                entity.runCommand("playsound sptw_saying2 @a ~~~ 10000 1 0")
                entity.runCommand("particle stand:angry ~~1~")
            }
        }
    } catch (e) {}
})

//-----------------------------------------------------
//函数
//________________________________________________________________

//检测是否在放技能
//"放技能的时候放技能就会同时放2个技能" ---- Johnny3150
export

function sptwNoSkill(player) {
    function score(player, objective) {
        try {
            return world.scoreboard.getObjective(objective)
                .getScore(player.scoreboardIdentity)
        } catch (e) {
            return 0;
        }
    }
    if (score(player, "stand_skill_cd_2") == 0 && score(player, "stand_skill_cd_3") < 90 && score(player, "stand_skill_cd_4") < (score(player, "stop_time") * 2 + 50) && combo[player.name]["time"] == 0) {
        return true;
    } else {
        return false;
    }
}

//3.5格长的攻击距离！
export function attacks(player, damage, kc) {
    let entities = getEntites(player, 4.5)
    for (let i = 0; i < entities.length; i++) {
        if (player.typeId != "stand:jojo3") {
            attack(player, entities[i].entity, damage, kc, entities[i].distance)
        }
        if (player.typeId == "stand:jojo3" && entities[i].entity.typeId != "minecraft:player" && entities[i].entity.typeId != "stand:jojo3") {
            attack(player, entities[i].entity, damage, kc, entities[i].distance)
        }
    }
}

//30格长的射程!!
function shoots(player, damage, kc) {
    let entities = getEntites(player, 30)
    for (let i = 0; i < entities.length; i++) {
        projectile(player, entities[i].entity, damage, kc, entities[i].distance)
    }
}

//取随机整数
function randomNum(minNum, maxNum) {
    switch (arguments.length) {
        case 1:
            return parseInt(Math.random() * minNum + 1, 10);
            break;
        case 2:
            return parseInt(Math.random() * (maxNum - minNum + 1) + minNum, 10);
            break;
        default:
            return 0;
            break;
    }
};