//-----------------------------------------------------
//导入
//________________________________________________________________

import { ItemStack,  world,  system } from '@minecraft/server';
import { score, set } from 'score.js';
import { triggerEvent } from 'main.js';
import { attack, projectile, getEntites, breakBlock } from 'base/attack.js';
import { defendData } from 'base/defend.js';

//-----------------------------------------------------
//初始变量
//________________________________________________________________

let combo = {
    "playerName": {
        "m": "a",
        "time": 0
    }
}

let fly_sword_list = {
    "playerName": {
        "id": "0"
    }
}

let sound_cd = {
    "playerName": {
        "eat_bread": 0,
        "target_is_near": 0,
        "world_is_best": 0
    }
}

let time_stop = {
    "playerName": {
        "time": 0
    }
}

//-----------------------------------------------------
//事件
//________________________________________________________________
export function tw(player) {

    //没有变量自己造
    if (combo[player.name] == undefined) {
        combo[player.name] = {
            "m": "a",
            "time": 0
        }
    }

    if (fly_sword_list[player.name] == undefined) {
        fly_sword_list[player.name] = {
            "id": "0"
        }
    }

    if (sound_cd[player.name] == undefined) {
        sound_cd[player.name] = {
            "eat_bread": 0,
            "target_is_near": 0,
            "world_is_best": 0
        }
    }

    if (time_stop[player.name] == undefined) {
        time_stop[player.name] = {
            "time": 0
        }
    }

    //减时间
    if (combo[player.name]["time"] > 0) {
        combo[player.name]["time"] -= 1
    }

    if (sound_cd[player.name]["eat_bread"] > 0) {
        sound_cd[player.name]["eat_bread"] -= 1
    }

    if (sound_cd[player.name]["target_near"] > 0) {
        sound_cd[player.name]["target_near"] -= 1
    }

    if (sound_cd[player.name]["world_is_best"] > 0) {
        sound_cd[player.name]["world_is_best"] -= 1
    }

    if (time_stop[player.name]["time"] > 0) {
        time_stop[player.name]["time"] -= 1
    }

    if (player.getComponent("minecraft:health").currentValue > 0 && player.getComponent("minecraft:health").currentValue <= 8 && time_stop[player.name]["time"] == 0 && score(player, "stand_level") >= 20) {
        time_stop[player.name]["time"] = 6000
        const skill = new twSkill(player)
        skill.timeStop()
        system.runTimeout(() => {
            player.runCommand("playsound eat_dinner @a ~~~ 100 1 0")
        }, 30)
    }

    if (sound_cd[player.name]["target_is_near"] == 0) {
        player.runCommand(`execute as @e[tag="target:${player.id}",r=5] at @s run execute as @a[name="${player.name}"] at @s run playsound target_is_near @a ~~~ 100 1 0 `)
        player.runCommand(`execute as @e[tag="target:${player.id}",r=5] at @s run tag @a[name="${player.name}"] add target_is_near`)
    }
    if (player.hasTag("target_is_near")) {
        sound_cd[player.name]["target_is_near"] = 3600
        player.removeTag("target_is_near")
    }

    const entity = player.dimension.getEntities({
        location: player.location,
        maxDistance: 30,
        tags: [`id${fly_sword_list[player.name]["id"]}`]
    })[0]
    if (entity) {
        const head = entity.getHeadLocation();
        const location = {
            x: head.x,
            y: head.y + 1.5,
            z: head.z
        }
        player.spawnParticle("stand:fly_sword", location)
    }

    if (player.hasTag("detect_attack") && score(player, "stand_summon") == 1 && !player.hasTag("be_stopped_of_time")) {

        const skill = new twSkill(player)

        switch (player.selectedSlotIndex) {
            case 0:
                if (twNoSkill(player) && defendData[player.name]["isDefend"] != true) {
                    combo[player.name]["time"] = 7
                    system.runTimeout(() => {
                        if (combo[player.name]["time"] == 0 && twNoSkill(player)) {
                            player.runCommand("scoreboard players set @s stand_fpp_invisibility 1")
                            triggerEvent(player)
                        }
                    }, 12)
                    combo[player.name]["m"] = skill.m(combo[player.name]["m"])
                }
                break;

            case 1:
                if (score(player, "stand_skill_cd_2") == 0 && !player.hasTag("time_stopper")) {
                    skill.tpEntity()
                }

                if (twNoSkill(player) && score(player, "stand_skill_cd_2") == 0 && player.hasTag("time_stopper") && score(player, "stand_level") >= 40) {
                    skill.whack()
                }
                break;

            case 2:
                if (twNoSkill(player) && score(player, "stand_skill_cd_3") == 0) {
                    skill.barrage()
                }
                break;

                //砸瓦鲁多！
            case 3:

                if (twNoSkill(player) && score(player, "stand_skill_cd_4") == 0 && !player.isSneaking) {
                    if (score(player, "stand_energy") == 100 && score(player, "stand_level") >= 20) {
                        skill.timeStop()
                    }
                }

                if (score(player, "stand_skill_cd_4") < (score(player, "stop_time") * 2) && player.isSneaking && player.hasTag("time_stopper")) {
                    player.addTag("stop_time_stop")
                }

                if (twNoSkill(player) && score(player, "stand_skill_cd_4") == 0 && score(player, "stand_level") >= 20 && player.isSneaking && !player.hasTag("time_stopper")) {
                    skill.timeStopTp()
                }
                break;
        }
    }

}


//-----------------------------------------------------
//类
//________________________________________________________________

export class twSkill {
    constructor(player) {
        this.player = player;
    }

    m(combo) {
        if (this.player.typeId == "minecraft:player") {
            this.player.runCommand("scoreboard players set @s stand_fpp_invisibility 0")
            triggerEvent(this.player)
            attacks(this.player, (6 * (score(this.player, "stand_level") / 100) + 6), 10)
            breakBlock(this.player, 5)
        } else {
            attacks(this.player, 12, 10)
        }
        this.player.runCommand(`playanimation @s animation.stand.tw.m1${combo}`)

        if (combo == "a") {
            this.player.runCommand("playsound game.player.attack.strong @a ~~~ 100 1 0")
            return "b";
        }
        if (combo == "b") {
            this.player.runCommand("playsound game.player.attack.strong @a ~~~ 100 1 0")
            return "c";
        }
        if (combo == "c") {
            this.shoot()
            return "a";
        }
    }

    tpEntity() {
        if (this.player.typeId == "minecraft:player") {
            set(this.player, "stand_skill_cd_2", 40)
        }
        if (this.player.typeId == "minecraft:player") {        
            if (fly_sword_list[this.player.name] && fly_sword_list[this.player.name]["id"] != "0") {
                this.player.runCommand(`effect @e[tag="id${fly_sword_list[this.player.name]["id"]}",r=30,c=1] blindness 1 1 true`)
                this.player.runCommand(`effect @e[tag="id${fly_sword_list[this.player.name]["id"]}",r=30,c=1] slowness 1 2 true`)
                this.player.runCommand(`execute as @e[tag="id${fly_sword_list[this.player.name]["id"]}",r=30,c=1] at @s run playsound tp @a ~~~ 100 1 0`)
                this.player.runCommand(`execute as @e[tag="id${fly_sword_list[this.player.name]["id"]}",r=30,c=1] at @s if block ^^^-1 air if  block ^^^-1 air run tp @e[tag="id${this.player.id}"] ^^^-1 facing @s `)
                this.player.runCommand(`execute as @e[tag="id${fly_sword_list[this.player.name]["id"]}",r=30,c=1] at @s unless block ^^^-1 air unless block ^^^-1 air run tp @e[tag="id${this.player.id}"] ^^^-0.1 facing @s `)
                this.player.runCommand(`execute as @e[tag="id${fly_sword_list[this.player.name]["id"]}",r=30,c=1] at @s unless block ^^^-1 air unless block ^^^-1 air run tp ^^1^1`)
                this.player.runCommand(`execute as @e[tag="id${fly_sword_list[this.player.name]["id"]}",r=30,c=1] run tag @e[tag="id${this.player.id}"] add tp:return`)
            }
            if (this.player.hasTag("tp:return")) {
                this.player.removeTag("tp:return")
                this.player.runCommand("particle stand:tw ~~1.25~")
                throw "tp is finished";
                return;
            }
        }
        this.player.runCommand(`effect @e[type=player,r=20,rm=0.1,c=1] blindness 1 1 true`)
        this.player.runCommand(`effect @e[type=player,r=20,rm=0.1,c=1] slowness 1 2 true`)
        this.player.runCommand(`execute as @e[type=player,r=20,rm=0.1,c=1] at @s run playsound tp @a ~~~ 100 1 0`)
        this.player.runCommand(`execute as @e[type=player,r=20,rm=0.1,c=1] at @s if block ^^^-1 air if  block ^^^-1 air run tp @e[tag="id${this.player.id}"] ^^^-1 facing @s `)
        this.player.runCommand(`execute as @e[type=player,r=20,rm=0.1,c=1] at @s unless block ^^^-1 air unless block ^^^-1 air run tp @e[tag="id${this.player.id}"] ^^^-0.1 facing @s `)
        this.player.runCommand(`execute as @e[type=player,r=20,rm=0.1,c=1] at @s unless block ^^^-1 air unless block ^^^-1 air run tp ^^1^1`)
        this.player.runCommand(`execute as @e[type=player,r=20,rm=0.1,c=1] run tag @e[tag="id${this.player.id}"] add tp:return`)
        if (this.player.hasTag("tp:return")) {
            this.player.removeTag("tp:return")
            this.player.runCommand("particle stand:tw ~~1.25~")
            throw "tp is finished";
            return;
        }
        this.player.runCommand(`effect @e[tag="target:${this.player.id}",r=20,c=1] blindness 1 1 true`)
        this.player.runCommand(`effect @e[tag="target:${this.player.id}",r=20,c=1] slowness 1 2 true`)
        this.player.runCommand(`execute as @e[tag="target:${this.player.id}",r=20,c=1] at @s run playsound tp @a ~~~ 100 1 0`)
        this.player.runCommand(`execute as @e[tag="target:${this.player.id}",r=20,c=1] at @s if block ^^^-1 air if  block ^^^-1 air run tp @e[tag="id${this.player.id}"] ^^^-1 facing @s `)
        this.player.runCommand(`execute as @e[tag="target:${this.player.id}",r=20,c=1] at @s unless block ^^^-1 air unless block ^^^-1 air run tp @e[tag="id${this.player.id}"] ~~~ facing @s `)
        this.player.runCommand(`execute as @e[tag="target:${this.player.id}",r=20,c=1] at @s unless block ^^^-1 air unless block ^^^-1 air run tp ^^1^1`)
        this.player.runCommand(`execute as @e[tag="target:${this.player.id}",r=20,c=1] run tag @e[tag="id${this.player.id}"] add tp:return`)
        if (this.player.hasTag("tp:return")) {
            this.player.removeTag("tp:return")
            this.player.runCommand("particle stand:tw ~~1.25~")
            throw "tp is finished";
            return;
        }
        this.player.runCommand(`effect @e[family=mob,r=20,rm=0.1,c=1] blindness 1 1 true`)
        this.player.runCommand(`effect @e[family=mob,r=20,rm=0.1,c=1] slowness 1 2 true`)
        this.player.runCommand(`execute as @e[family=mob,r=20,rm=0.1,c=1] at @s run playsound tp @a ~~~ 100 1 0`)
        this.player.runCommand(`execute as @e[family=mob,r=20,rm=0.1,c=1] at @s if block ^^^-1 air if  block ^^^-1 air run tp @e[tag="id${this.player.id}"] ^^^-1 facing @s `)
        this.player.runCommand(`execute as @e[family=mob,r=20,rm=0.1,c=1] at @s unless block ^^^-1 air unless block ^^^-1 air run tp @e[tag="id${this.player.id}"] ^^^-0.1 facing @s `)
        this.player.runCommand(`execute as @e[family=mob,r=20,rm=0.1,c=1] at @s unless block ^^^-1 air unless block ^^^-1 air run tp ^^1^1`)
        this.player.runCommand(`execute as @e[family=mob,r=20,rm=0.1,c=1] run tag @e[tag="id${this.player.id}"] add tp:return`)
        if (this.player.hasTag("tp:return")) {
            this.player.removeTag("tp:return")
            this.player.runCommand("particle stand:tw ~~1.25~")
            throw "tp is finished";
            return;
        }
    }

    whack() {
        if (this.player.typeId == "minecraft:player") {
            set(this.player, "stand_skill_cd_2", (score(this.player, "stop_time") - 11))
        }
        this.player.runCommand("playanimation @s animation.stand.tw.whack")
         if (this.player.typeId == "minecraft:player") {
            this.player.runCommand("scoreboard players set @s stand_fpp_invisibility 0")
            system.runTimeout(() => {
                this.player.runCommand("scoreboard players set @s stand_fpp_invisibility 1")
            }, 20)
        }
        system.runTimeout(() => {
            this.player.runCommand("playsound whack @a ~~~ 100 1 0")
            attacks(this.player, (5 * (score(this.player, "stand_level") / 100) + 5), 10)
        }, 11)
    }

    timeStop() {
        if (this.player.typeId == "minecraft:player") {
            this.player.runCommand("scoreboard players set @s stand_skill_cd_4 " + (score(this.player, "stop_time") * 2 + 70))
            set(this.player, "stand_energy", 0)
            this.player.runCommand("camera @s set minecraft:free pos ^^2.5^3 facing @s")
        }
        this.player.runCommand("playsound tw_ts @a[r=100] ~~~ 100 1 0")
        this.player.runCommand("effect @s resistance 2 255 true")
        let ts_tp = system.runInterval(() => {
            this.player.runCommand("tp @s @s")
        }, 1)
        system.runTimeout(() => {
            this.player.runCommand("playanimation @s animation.stand.tw.ts")
            if (this.player.typeId == "minecraft:player") {
                this.player.sendMessage("§eThe...")
            }
        }, 5)
        system.runTimeout(() => {
            system.clearRun(ts_tp)
            if (this.player.typeId == "minecraft:player") {
                this.player.runCommand("camera @s clear")
                this.player.sendMessage("§eWorld!")
            } else {
                this.player.addTag("time_attack")
            }
            this.player.runCommand("tag @s[tag=!be_stopped_of_time] add time_stop_start")
        }, 20)
        if (this.player.typeId == "minecraft:player") {
            this.player.runCommand("scoreboard players set @s stand_fpp_invisibility 0")
            system.runTimeout(() => {
                this.player.runCommand("scoreboard players set @s stand_fpp_invisibility 1")
            }, 20)
        }
    }

    timeStopTp() {
        this.player.runCommand("playsound tp @a ~~~ 100 1 0")
        this.player.runCommand("effect @s blindness 1 1 true")
        this.player.runCommand("tp ^^1^1 true")
        this.player.runCommand("tp ^^^1 true")
        this.player.runCommand("tp ^^^1 true")
        this.player.runCommand("tp ^^^1 true")
        this.player.runCommand("tp ^^^1 true")
        this.player.runCommand("tp ^^^1 true")
        this.player.runCommand("tp ^^^1 true")
        this.player.runCommand("tp ^^^1 true")
        this.player.runCommand("tp ^^^1 true")
        if (this.player.typeId == "minecraft:player") {
            this.player.runCommand("scoreboard players set @s stand_skill_cd_4 20")
        }
    }

    barrage() {
        const sneaking = this.player.isSneaking ? true : false
        system.runTimeout(() => {
            if (this.player.typeId == "minecraft:player") {
                this.player.runCommand("scoreboard players set @s stand_fpp_invisibility 0")
                triggerEvent(this.player)
                if (sneaking) {
                    this.player.runCommand("playanimation @s animation.stand.tw.foot.barrage")
                } else {
                    this.player.runCommand("playanimation @s animation.stand.tw.barrage")
                }
            } else {
                this.player.runCommand("playanimation @s animation.stand.tw.barrage")
            }
        }, 2);
        if (this.player.typeId == "minecraft:player") {
            if (sneaking) {
                system.runTimeout(() => {
                    this.player.runCommand("playsound foot_barrage @a ~~~ 100 1 0")
                }, 5)
            } else {
                this.player.runCommand("playsound dio_barrage @a ~~~ 100 1 0")
            }
        } else {
            this.player.runCommand("playsound dio_barrage @a ~~~ 100 1 0")
        }
        if (this.player.typeId == "minecraft:player") {
            this.player.runCommand("scoreboard players set @s stand_skill_cd_3 60")
        }
        if (this.player.typeId == "minecraft:player") {
            if (sneaking) {
                let barrage1 = system.runInterval(() => {
                    if (this.player.typeId == "minecraft:player") {
                        this.player.runCommand("effect @s slowness 1 0 true")
                        attacks(this.player, (5 * (score(this.player, "stand_level") / 100) + 5), 10)
                    } else {
                        attacks(this.player, 16, 80)
                    }
                }, 4)
                system.runTimeout(() => {
                    if (barrage1) {
                        system.clearRun(barrage1)
                    }
                    system.runTimeout(() => {
                        if (this.player.typeId == "minecraft:player") {
                            if (sneaking) {
                                this.player.runCommand("effect @s slowness 1 0 true")
                                attacks(this.player, (10 * (score(this.player, "stand_level") / 100) + 10), 149.9)
                            } else {
                                attacks(this.player, (14 * (score(this.player, "stand_level") / 100) + 14), 60)
                            }
                            system.runTimeout(() => {
                                this.player.runCommand("scoreboard players set @s stand_fpp_invisibility 1")
                                triggerEvent(this.player)
                            }, 10)
                        } else {
                            attacks(this.player, 32, 60)
                        }
                    }, 2)
                }, 50)
            } else {
                let barrage2 = system.runInterval(() => {
                    if (this.player.typeId == "minecraft:player") {
                        this.player.runCommand("effect @s slowness 1 0 true")
                        attacks(this.player, (7 * (score(this.player, "stand_level") / 100) + 7), 10)
                    } else {
                        attacks(this.player, 16, 10)
                    }
                }, 4)
                system.runTimeout(() => {
                    if (barrage2) {
                        system.clearRun(barrage2)
                    }
                    system.runTimeout(() => {
                        if (this.player.typeId == "minecraft:player") {
                            if (sneaking) {
                                attacks(this.player, (10 * (score(this.player, "stand_level") / 100) + 10), 300)
                            } else {
                                attacks(this.player, (14 * (score(this.player, "stand_level") / 100) + 14), 60)
                            }
                            system.runTimeout(() => {
                                this.player.runCommand("scoreboard players set @s stand_fpp_invisibility 1")
                                triggerEvent(this.player)
                            }, 10)
                        } else {
                            attacks(this.player, 32, 60)
                        }
                    }, 2)
                }, 50)
            }
        } else {
            let barrage3 = system.runInterval(() => {
                if (this.player.typeId == "minecraft:player") {
                    attacks(this.player, (6 * (score(this.player, "stand_level") / 100) + 6), 10)
                } else {
                    attacks(this.player, 12, 10)
                }
            }, 4)
            system.runTimeout(() => {
                if (barrage3) {
                    system.clearRun(barrage3)
                }
                system.runTimeout(() => {
                    if (this.player.typeId == "minecraft:player") {
                        if (sneaking) {
                            attacks(this.player, (10 * (score(this.player, "stand_level") / 100) + 10), 300)
                        } else {
                            attacks(this.player, (14 * (score(this.player, "stand_level") / 100) + 14), 60)
                        }
                        system.runTimeout(() => {
                            this.player.runCommand("scoreboard players set @s stand_fpp_invisibility 1")
                            triggerEvent(this.player)
                        }, 10)
                    } else {
                        attacks(this.player, 32, 60)
                    }
                }, 2)
            }, 50)
        }
    }

    shoot() {
        world.playSound(`fly_sword`, this.player.location);
        const head = this.player.getHeadLocation();
        const rotation = this.player.getRotation();
        const yaw = rotation.y * (Math.PI / 180);
        const pitch = rotation.x * (Math.PI / 180);
        const direction = {
            x: -Math.sin(yaw) * Math.cos(pitch),
            y: -Math.sin(pitch),
            z: Math.cos(yaw) * Math.cos(pitch)
        };
        const offset = 0.1;
        const fly_sword = world.getDimension(this.player.dimension.id).spawnEntity(`stand:fly_sword`, {
            x: head.x + direction.x * offset,
            y: head.y + direction.y * offset,
            z: head.z + direction.z * offset,
        });
        const speed = 3;
        fly_sword.getComponent("minecraft:projectile").owner = this.player
        fly_sword.applyImpulse({
            x: direction.x * speed,
            y: direction.y * speed,
            z: direction.z * speed,
        });
        const fly_sword_2 = world.getDimension(this.player.dimension.id).spawnEntity(`stand:fly_sword`, {
            x: head.x + direction.x * (offset - 0.1),
            y: head.y + direction.y * offset - 0.25,
            z: head.z + direction.z * (offset - 0.1),
        });
        fly_sword_2.getComponent("minecraft:projectile").owner = this.player
        fly_sword_2.applyImpulse({
            x: direction.x * speed,
            y: direction.y * speed,
            z: direction.z * speed,
        });

        const fly_sword_3 = world.getDimension(this.player.dimension.id).spawnEntity(`stand:fly_sword`, {
            x: head.x + direction.x * (offset - 0.1),
            y: head.y + direction.y * offset + 0.25,
            z: head.z + direction.z * (offset - 0.1),
        });
        fly_sword_3.getComponent("minecraft:projectile").owner = this.player
        fly_sword_3.applyImpulse({
            x: direction.x * speed,
            y: direction.y * speed,
            z: direction.z * speed,
        });
    }
}


//-----------------------------------------------------
//事件
//________________________________________________________________

world.afterEvents.projectileHitEntity.subscribe(event => {
    if (event.projectile.typeId == "stand:fly_sword") {
        const player = event.source
        const entity = event.getEntityHit().entity
        if (player != entity) {
            fly_sword_list[player.name] = {
                "id": `${entity.id}`
            }
        }
    }
})

world.afterEvents.entityDie.subscribe(event => {
    const entity = event.deadEntity
    if (score(entity, "stand_type_id") == 9) {
        entity.runCommand("playsound dio_die @a ~~~ 100 1 0")
    }
})

world.afterEvents.itemStartUse.subscribe(event => {
    const item = event.itemStack;
    const player = event.source;
    if (item.typeId == "minecraft:bread" && score(player, "stand_type_id") == 9) {
        if (sound_cd[player.name]["eat_bread"] == 0) {
            sound_cd[player.name]["eat_bread"] = 1200
            player.runCommand("playsound eat_bread @a ~~~ 100 1 0")
        }
    }
});

world.afterEvents.entityHurt.subscribe(event => {
    try {
        const player = event.damageSource.damagingEntity
        if (score(player, "stand_type_id") == 9) {
            if (sound_cd[player.name]["world_is_best"] == 0) {
                sound_cd[player.name]["world_is_best"] = 2400
                player.runCommand("playsound world_is_best @a ~~~ 100 1 0")
            }
        }
    } catch (error) {}
})

//-----------------------------------------------------
//函数
//________________________________________________________________

export function twNoSkill(player) {
    if (score(player, "stand_skill_cd_2") < ((score(player, "stop_time") - 25) >= 0 && score(player, "stand_level") >= 40 && player.hasTag("time_stopper")?(score(player, "stop_time") - 25):114514) && score(player, "stand_skill_cd_3") == 0 && score(player, "stand_skill_cd_4") <= (score(player, "stop_time") * 2 + 50) && combo[player.name]["time"] == 0) {
        return true;
    } else {
        return false;
    }
}

export function attacks(player, damage, kc) {
    let entities = getEntites(player, 4.5)
    for (let i = 0; i < entities.length; i++) {
        if (score(player, "stand_skill_cd_2") >= ((score(player, "stop_time") - 25) > 0 ? (score(player, "stop_time") - 25) : 0) && score(player, "stand_level") >= 40 && player.hasTag("time_stopper") && player.typeId != "stand:dio3h") {
            if ((entities[i].entity.getComponent("minecraft:health").currentValue / entities[i].entity.getComponent("minecraft:health").effectiveMax) < 0.25 && (entities[i].entity.getComponent("minecraft:health").currentValue / entities[i].entity.getComponent("minecraft:health").effectiveMax) > 0) {
                attack(player, entities[i].entity, 500, 300, -114514)
                player.runCommand("camerashake add @a[r=5] 0.35 0.1")
            }
            entities[i].entity.addTag("ts:whack")
            entities[i].entity.runCommand("particle stand:kill ~~1.5~")
            attack(player, entities[i].entity, (score(player, "stand_level") / 100 * 7 + 7), 300, -114514)
            player.runCommand("playsound mob.zombie.woodbreak @a ~~~ 100 1 0")
            if (entities[i].entity.typeId == "minecraft:player") {
                entities[i].entity.addTag("ts:kc")
                const location = {x: player.location.x, y: player.location.y, z:player.location.z}
                let facing = system.runInterval(() => {
                    entities[i].entity.runCommand(`tp ~~~ facing ${location.x} ${location.y} ${location.z}`)
                    if (!entities[i].entity.hasTag("be_stopped_of_time")) {
                        system.clearRun(facing)
                    }
                })
            }
        } else {
            attack(player, entities[i].entity, damage, kc, entities[i].distance)
        }
    }
}