//-----------------------------------------------------
//导入
//________________________________________________________________

import { world, system, ItemStack } from '@minecraft/server';
import { ActionFormData, ModalFormData } from '@minecraft/server-ui';
import { score, add, set } from 'score.js';
import { dio1_cd, dio1 } from 'monster/dio.js'
import { dio3_cd, dio3 } from 'monster/dio.js'

//-----------------------------------------------------
//变量
//________________________________________________________________

let gravity_time = {}
let sv = {}
let jj_tick = {}
let jj_id = world.getDynamicProperty("jj_id") ? world.getDynamicProperty("jj_id") : 0;
let bc = {}

//-----------------------------------------------------
//事件
//________________________________________________________________

world.beforeEvents.playerBreakBlock.subscribe(event => {
    const player = event.player;
    if (player.hasTag("be_stopped_of_time")) {
        event.cancel = true;
    }
});


world.beforeEvents.playerInteractWithBlock.subscribe(event => {
    const player = event.player;
    if (player.hasTag("be_stopped_of_time")) {
        event.cancel = true;
    }
});

world.beforeEvents.playerInteractWithEntity.subscribe(event => {
    const player = event.player;
    if (player.hasTag("be_stopped_of_time")) {
        event.cancel = true;
    }
});

world.beforeEvents.playerPlaceBlock.subscribe(event => {
    const player = event.player;
    if (player.hasTag("be_stopped_of_time")) {
        event.cancel = true;
    }
});

//-----------------------------------------------------
//函数
//________________________________________________________________

//玩家时停
export function timeStop(player) {

    //时停开关
    if (player.hasTag("time_stop_start") && !player.hasTag("time_stop_start_hud_showing") && player.typeId == "minecraft:player") {
        player.addTag("time_stop_start_hud_showing")
        player.addTag("time_stopper")
        player.addTag("time_stop_hud")
        player.runCommand("scoreboard players set @s stand_time_stop_hud_invisibility 1")
        player.runCommand("playsound timetick @a[r=100]")
        player.runCommand("particle stand:ts ~~1.25~")
        player.triggerEvent("sync:stand_time_stop_hud_invisibility")
        let tick = system.currentTick;
        let timetick = system.runInterval(() => {
            if (!player) {
                system.clearRun(rt)
                system.clearRun(st)
                system.clearRun(timetick)
            }
            let difference = system.currentTick - tick;
            if (difference % 20 === 0) {
                player.runCommand("playsound timetick @a[r=100]")
            }
        });
        let rt = system.runTimeout(() => {   
            system.runTimeout(() => {
                player.runCommand("function TimeStopperEffectClear")
            }, 40)
            system.clearRun(st)
            player.runCommand("scoreboard players set @s stand_time_stop_hud_invisibility 0")
            player.triggerEvent("sync:stand_time_stop_hud_invisibility")
            player.runCommand("playsound ts_over @a[r=100]")
            player.runCommand("playsound timetick @a[r=100]")
            player.removeTag("time_stop_start")
            player.removeTag("time_stopper")
            player.removeTag("time_stop_start_hud_showing")
            system.clearRun(timetick)
        }, score(player, "stop_time"))
        let st = system.runInterval(() => {
            if (!player) {
                system.clearRun(rt)
                system.clearRun(st)
                system.clearRun(timetick)
            }
            if (player.hasTag("stop_time_stop")) {
                system.clearRun(rt)
                player.removeTag("stop_time_stop")
                system.runTimeout(() => {
                    player.runCommand("function TimeStopperEffectClear")
                }, 40)
                player.runCommand("scoreboard players set @s stand_time_stop_hud_invisibility 0")
                player.triggerEvent("sync:stand_time_stop_hud_invisibility")
                player.runCommand("playsound ts_over @a[r=100]")
                player.runCommand("playsound timetick @a[r=100]")
                player.removeTag("time_stop_start")
                player.removeTag("time_stopper")
                player.removeTag("time_stop_start_hud_showing")
                system.clearRun(timetick)
                system.clearRun(st)
            }
        })
    };
}


//时停效果
export function timeStopEffect(player) {

    //辛红辣椒：人偶
    function standPlayer(entity) {
        if (entity.typeId != "stand:players") return;
        if (system.currentTick % 4 === 0) {
            entity.runCommand(`execute as @a[rm=35,name="${entity.nameTag}"] at @s run tp ^^^1.5 facing @e[type=stand:players,c=1,name="${entity.nameTag}"] true`)
        }
    }
    
    //承太郎
    function jojo3(entity) {
        const co = ["c", "a", "b", "c", "o"]
        let animation = co[score(entity, "mr.co")]
        if (animation == "c") {
            if (entity.target) {
                entity.addTag(`jojo3Tp:${entity.id}`)
                entity.target.runCommand(`tp @e[tag=jojo3Tp:${entity.id}] ^^0.25^-1 facing @s`)
                entity.target.runCommand("effect @e[r=20] blindness 1 1 true")
                entity.target.runCommand("effect @s slowness 2 2 true")
                entity.target.runCommand("playsound tp @a ~~~")
                entity.runCommand("tp ^^^-0.5 true")
                entity.runCommand("tp ^^^-0.5 true")
                entity.runCommand("tp ^^^-0.5 true")
                entity.runCommand("tp ^^^-0.5 true")
                entity.runCommand("effect @s strength 2 2 true")
                entity.removeTag(`jojo3Tp:${entity.id}`)
                entity.runCommand("scoreboard players add @s mr.co 1")
            }
        }
        if (entity.target) {
            var points = [entity.target.location, entity.location];
            points.dist = function() {
                var p1 = this[0];
                var p2 = this[1];
                var a = p2.x - p1.x;
                var b = p2.z - p1.z;
                var c = p2.y - p1.y;
                return Math.sqrt(a * a + b * b + c * c);
            };
            if (points.dist() > 10) {
                entity.runCommand("scoreboard players set @s mr.co 0")
            }
        }
    }

    //折纸师：纸
    function paper(entity) {
        if (entity.typeId == "stand:paper") {
            try {
                entity.getComponent("minecraft:rideable")
                    .getRiders()[0].runCommand("playanimation @s animation.player.invisibility move 114514")
                entity.getComponent("minecraft:rideable")
                    .getRiders()[0].runCommand("tag @s add paper")
            } catch (error) {
                try {
                    entity.runCommand("playanimation @a[r=3] animation.player.scale")
                    entity.remove()
                    return;
                } catch (error) {}
            }
            let time = 200 - score(entity, "kick")
            entity.runCommand("scoreboard players add @s kick 1")
            if (time < 0 || time == 0) {
                entity.getComponent("minecraft:rideable")
                    .getRiders()[0].runCommand("playanimation @s animation.player.scale")
                entity.getComponent("minecraft:rideable")
                    .getRiders()[0].runCommand("effect @s invisibility 3 0 true")
                entity.remove()
                return;
            }
            entity.getComponent("minecraft:rideable")
                .getRiders()[0].runCommand("effect @s invisibility 2 1 true")
            entity.getComponent("minecraft:rideable")
                .getRiders()[0].runCommand("scoreboard players set @s stand_skill_cd_1 " + time)
        }
    }

    //吉良吉影
    function jj(entity) {
        let health = parseInt(entity.getComponent("minecraft:health").currentValue)
        if (!jj_tick[entity.id]) {
            jj_tick[entity.id] = system.currentTick;
        }
        if (!entity.hasTag("appear")) {
            jj_id += 1
            world.setDynamicProperty("jj_id", jj_id)
            entity.runCommand("summon stand:ec ^^^1")
            entity.runCommand("summon stand:ec ^^^-1")
            entity.runCommand("summon stand:ec ^1^^")
            entity.runCommand("summon stand:ec ^-1^^")
            entity.addTag("appear")
        }
        if (system.currentTick % 600 === 0 && entity.hasTag("appear") && jj_tick[entity.id] != system.currentTick) {
            entity.runCommand(`summon stand:sheer_heart_attack ^^^0.5 ~ ~ ? "§d枯萎穿心攻击"`)
            entity.runCommand(`tag @e[r=3,type=stand:sheer_heart_attack,c=1,name="§d枯萎穿心攻击"] add "jj:${entity.id}"`)
            entity.runCommand("particle stand:kqs_summon ~ ~1.25 ~")
            entity.runCommand("playsound kq.car @a ~~~ 100 1 0")
            jj_tick[entity.id] = system.currentTick;
        }
        if (system.currentTick % 199 === 0 && entity.hasTag("boss2") && jj_tick[entity.id] != system.currentTick) {
            entity.runCommand(`summon stand:monster_air_tnt ^^^0.5`)
            entity.runCommand("playsound mob.cat.straymeow @a ~~~ 100 1 0")
            jj_tick[entity.id] = system.currentTick;
        }
        if (health <= 199 && !entity.hasTag("boss2")) {
            entity.addTag("boss2")
            entity.runCommand("summon stand:dz ^^^1")
            entity.runCommand("summon stand:dz ^^^-1")
            entity.runCommand("summon stand:dz ^-1^^")
            entity.runCommand("summon stand:dz ^1^^")
            entity.runCommand("particle minecraft:knockback_roar_particle ~ ~0.5 ~")
            entity.runCommand("effect @a[r=10] nausea 10 3 true")
            entity.runCommand("effect @s strength 114514 1 true")
            entity.runCommand("effect @s slowness 114514 0 true")
            entity.runCommand("effect @s resistance 114514 1 true")
            entity.runCommand("effect @s invisibility 3 1 false")
            entity.runCommand(`tellraw @a[r=10] {"rawtext":[{"translate": "jj.tellraw"}]}`)
            entity.runCommand("damage @a[r=10] 0 entity_attack entity @s")
        }
    }

    //回音：重力
    function gravity(entity) {
        if (!gravity_time[entity.id]) {
            gravity_time[entity.id] = 0
        }
        if (entity.hasTag("gravity")) {
            if (entity.typeId == "minecraft:player" || entity.typeId == "stand:sheer_heart_attack") {
                entity.runCommand("effect @s slowness 1 2 true")
            }
            if (gravity_time[entity.id] % 300 === 0) {
                entity.runCommand("tag @s remove gravity")
                entity.gravity_time = undefined
            }
            if (gravity_time[entity.id] % 5 === 0) {
                entity.runCommand("particle stand:gravity ~~1~")
                entity.runCommand("tp ~~-0.25~ true")
                entity.runCommand("effect @s slowness 3 2 true")
            }
            gravity_time[entity.id] += 1
        }
    }
    
    //阿努比斯：已废弃
    function anbs(entity) {
        if (entity.typeId == "stand:anbs") {
            const playerN = entity.nameTag.replace("§d", "").replace(" 阿努比斯神", "")
            const entities = entity.dimension.getEntities({
                name: playerN,
                type: "minecraft:player"
            });
            if (!entities[0]) {
                entity.remove()
            } else {
                if (!entities[0].getComponent("minecraft:inventory").container.getItem(entities[0].selectedSlotIndex) || entities[0].getComponent("minecraft:inventory").container.getItem(entities[0].selectedSlotIndex).typeId != "stand:anbss") {
                    entity.remove()
                }
                if (entities[0].hasTag("anbs_person")) {
                    entity.remove()
                }
            }
        }
    }

    //杀手皇后：枯萎穿心攻击
    function car(entity) {
        if (entity.typeId == "stand:sheer_heart_attack") {
            add(entity, "kick", 1)
            if (score(entity, "kick") >= 300) {
                entity.runCommand("particle stand:kqs_summon ~~1.25~")
                entity.remove()
            }
        }
        try {
            entity.runCommand(`execute as @s[scores={kick=..280}] run effect @e[name="${entity.nameTag.replace("§d", "").replace(" 枯萎穿心攻击", "")}"] slowness 1 ${entity.getEffect("slowness").amplifier} false`)
        } catch (e) {}
    }
    
    //公路之星：脚印
    function footprints(entity) {
        if (entity.typeId == "stand:footprints") {
            add(entity, "kick", 1)
            if (score(entity, "kick") >= 600) {
                entity.runCommand("particle stand:hw_summon ~~1.25~")
                entity.remove()
            }
        }
    }

    //极恶中队：军队
    function bcs(entity) {
        if (entity.getComponent("minecraft:type_family")?.hasTypeFamily("bc")) {
            add(entity, "kick", 1)
            if (score(entity, "kick") >= 1600) {
                entity.runCommand("particle stand:bc_summon ~~1.25~")
                entity.remove()
            }
            if (entity.hasTag("tp") && score(entity, "kick") < 1600) {
                if (!bc[entity.id]) {
                    bc[entity.id] = {
                        "x": entity.location.x,
                        "y": entity.location.y,
                        "z": entity.location.z
                    }
                }
                entity.runCommand(`tp ${bc[entity.id].x} ${bc[entity.id].y} ${bc[entity.id].z}`)
                if (entity.typeId != "stand:ah64a") {
                    entity.runCommand(`execute as @s at @s if block ~~-0.5~ air run tag @s remove tp`)
                }
            } else {
                if (bc[entity.id]) {
                    bc[entity.id] = undefined
                }
            }
        }
    }
    
    //添加仇恨目标标签
    function target(entity) {
        if (entity.target) {
            entity.addTag(`target:${entity.target.id}`)
        }
        const tags = entity.getTags()
        for (const tag of tags) {
            if (tag.indexOf("target:") != -1) {
                if (!entity.target) {
                    entity.removeTag(tag)
                } else {
                    if (tag != `target:${entity.target.id}`) {
                        entity.removeTag(tag)
                    }
                }
            }
        }
    }
    
    //实体时停
    function entityTimeStop(player) {
        if (player.hasTag("time_stop_start") && !player.hasTag("time_stopper") && player.typeId != "minecraft:player") {
            let time;
            time = 100;
            if (player.typeId == "stand:dio3h") {
                time = 180;
            }
            player.addTag("time_stopper")
            player.runCommand("playsound timetick @a[r=100]")
            player.runCommand("particle stand:ts ~~1.25~")
            let tick = system.currentTick;
            let timetick = system.runInterval(() => {
                if (!player) {
                    system.clearRun(rt)
                    system.clearRun(st)
                    system.clearRun(timetick)
                }
                let difference = system.currentTick - tick;
                if (difference % 20 === 0) {
                    player.runCommand("playsound timetick @a[r=100]")
                }
            });
            let rt = system.runTimeout(() => {   
                system.runTimeout(() => {
                    player.runCommand("function TimeStopperEffectClear")
                }, 40)
                system.clearRun(st)
                player.runCommand("playsound ts_over @a[r=100]")
                player.runCommand("playsound timetick @a[r=100]")
                player.removeTag("time_stopper")
                player.removeTag("time_stop_start")
                system.clearRun(timetick)
            }, time)
            let st = system.runInterval(() => {
                if (!player) {
                    system.clearRun(rt)
                    system.clearRun(st)
                    system.clearRun(timetick)
                }
            })
        };
    }
    
    //固定实体视角
    function setTargetEntity(entity) {
        const initialRotation = entity.getRotation();
    
        let setTargetEntityS = system.runInterval(() => {
            try {
                if (entity) {
                    if (entity.hasTag("be_stopped_of_time")) {
                        entity.setRotation(initialRotation);
                    } else {
                        system.clearRun(setTargetEntityS);
                    }
                } else {
                    system.clearRun(setTargetEntityS);
                }
            } catch(error) {
                system.clearRun(setTargetEntityS);
            }
        }, 1);
    }

    //实体时停效果
    function entityTimeStopEffect(entity) {
        if (entity.hasTag("time_stopper")) {
            entity.runCommand("tag @e[r=50,type=!stand:jojo3,type=!item,type=!boat,type=!chest_minecart,type=!xp_orb,tag=!time_stopper] add be_stopped_of_time")
            entity.runCommand("tag @e[r=50,type=!stand:jojo3,type=!item,type=!boat,type=!chest_minecart,type=!xp_orb,tag=!time_stopper,scores={active_in_ts=1..}] remove be_stopped_of_time")
            entity.runCommand("scoreboard players remove @e[r=50,type=!stand:jojo3,type=!item,type=!boat,type=!chest_minecart,type=!xp_orb,tag=!time_stopper,scores={active_in_ts=1..}] active_in_ts 1")
            entity.runCommand("scoreboard players set @e[r=50,type=!stand:jojo3,type=!item,type=!boat,type=!chest_minecart,type=!xp_orb,tag=!time_stopper,scores={active_in_ts=1..,stand_skill_cd_4=0}] stand_skill_cd_4 20")
            entity.runCommand("function TimeStopperEffect")
        };
        if (entity.hasTag("time_stopper") && !entity.hasTag("time_stop_health")) {
            entity.addTag("time_stop_health")
        };
        if (!entity.hasTag("time_stopper") && entity.hasTag("time_stop_health")) {
            entity.runCommand("function TimeStopperEffectClear")
            entity.removeTag("time_stop_health")
        };
        if (entity.hasTag("be_stopped_of_time")) {
            entity.runCommand("tp @s[tag=saved] ~~0.00000001~")
            entity.runCommand("function PlayerTimeStopEffect")
            if (entity.typeId != "minecraft:player") {
                if (entity.typeId == "minecraft:tnt") {
                    entity.runCommand("fill ~~~ ~~~ tnt")
                    entity.remove()
                }
                if (entity.typeId.includes("zombie")) {
                    entity.runCommand("event entity @s minecraft:lost_target")
                }
                if (entity.typeId == "minecraft:creeper") {
                    entity.runCommand("event entity @s[type=creeper] minecraft:stop_exploding")
                }
            }
        };
        if (entity.hasTag("time_stop_over")) {
            entity.removeTag("time_stop_over")
            entity.removeTag("be_stopped_of_time")
            entity.removeTag("be_stopped_of_time_true")
            entity.removeTag("saved")
            if (entity.hasTag("ts:whack")) {
                entity.runCommand("playsound whack_over @a ~~~ 100 1 0")
                entity.runCommand("effect @s wither 10 3 true")
                entity.removeTag("ts:whack")
            }
            if (entity.hasTag("ts:kc")) {
                entity.runCommand("tp ^^1^-1 true")
                entity.runCommand("tp ^^^-1 true")
                entity.runCommand("tp ^^^-1 true")
                entity.runCommand("tp ^^^-1 true")
                entity.runCommand("tp ^^^-1 true")
                entity.runCommand("tp ^^^-1 true")
                entity.runCommand("tp ^^^-1 true")
                entity.runCommand("tp ^^^-1 true")
                entity.runCommand("tp ^^^-1 true")
                entity.runCommand("tp ^^^-1 true")
                entity.runCommand("tp ^^^-1 true")
                entity.runCommand("tp ^^^-1 true")
                entity.runCommand("tp ^^^-1 true")
                entity.runCommand("tp ^^^-1 true")
                entity.runCommand("tp ^^^-1 true")
                entity.runCommand("tp ^^^-1 true")
                entity.runCommand("tp ^^^-1 true")
                entity.runCommand("tp ^^^-1 true")
                entity.runCommand("tp ^^^-1 true")
                entity.runCommand("tp ^^^-1 true")
                entity.removeTag("ts:kc")
            }
            
            entity.runCommand("function EntityTimeStopEffectClear")

            if (entity.typeId != "minecraft:player") {
                entity.applyImpulse({
                    x: score(entity, "stand_time_stop_vx") / 1000,
                    y: score(entity, "stand_time_stop_vy") / 1000,
                    z: score(entity, "stand_time_stop_vz") / 1000
                })
            }
            if (entity.hasComponent("minecraft:health")) {
                entity.runCommand("damage @s[scores={ts_damage=1..}] " + (score(entity, "ts_damage")?score(entity, "ts_damage"):0))
                entity.runCommand("scoreboard players set @s ts_damage 0")
            }
        };
        if (entity.hasTag("be_stopped_of_time") && !entity.hasTag("saved") && entity.typeId == "minecraft:player") {
            entity.addTag("saved")
        };
        if (entity.hasTag("be_stopped_of_time") && !entity.hasTag("saved")) {
            if (entity.typeId != "minecraft:player") {
                let velocity = entity.getVelocity()
                let scoreboardVelocity = {
                    x: parseInt(velocity.x * 1000),
                    y: parseInt(velocity.y * 1000),
                    z: parseInt(velocity.z * 1000)
                }
                entity.runCommand("scoreboard players set @s stand_time_stop_vx " + scoreboardVelocity.x)
                entity.runCommand("scoreboard players set @s stand_time_stop_vy " + scoreboardVelocity.y)
                entity.runCommand("scoreboard players set @s stand_time_stop_vz " + scoreboardVelocity.z)
                entity.addTag("saved")
                entity.clearVelocity()
                setTargetEntity(entity)
            }
        };
        if (entity.hasTag("saved") && entity.typeId != "minecraft:player") {
            entity.applyImpulse({
                x: score(entity, "stand_time_stop_vx") / 100000000,
                y: score(entity, "stand_time_stop_vy") / 100000000,
                z: score(entity, "stand_time_stop_vz") / 100000000
            })
        }
    }
    
    //压路机
    function roller(entity) {
        if (entity.isFalling) {
            let v = Math.sqrt(entity.getVelocity().x**2 + entity.getVelocity().z**2 + entity.getVelocity().y**2)
            if (v > 0.9 && !entity.hasTag("boom")) {
                entity.addTag("boom")
            }
        }
        if (!entity.isFalling && entity.isOnGround && entity.hasTag("boom") && !entity.hasTag("be_stopped_of_time")) {
            entity.removeTag("boom")
            entity.dimension.createExplosion(entity.location, 3, {breaksBlocks: false});
        }
    }
        
    //替身召唤物：精神提升
    function standSummon(entity) {
        try {
            if (entity.getComponent("minecraft:type_family")?.hasTypeFamily("stand_summon")) {
                const player = entity.getComponent("minecraft:tameable").tamedToPlayer
                if (score(player, "life_level") >= 1) {
                    entity.runCommand("effect @s speed 5 0 true")
                }
                if (score(player, "life_level") >= 2) {
                    entity.runCommand("effect @s strength 5 0 true")
                }
                if (score(player, "life_level") >= 3) {
                    entity.runCommand("effect @s resistance 5 0 true")
                }
            }
        } catch(error) {}
    }

    //世界：去除时停效果
    function worldStopEffect() {
        player.dimension.runCommand("tag @e[tag=be_stopped_of_time_true] remove be_stopped_of_time_true")
        player.dimension.runCommand("execute as @e[tag=time_stopper] at @s run tag @e[r=100,tag=!time_stopper] add be_stopped_of_time_true")
        player.dimension.runCommand("tag @e[tag=!be_stopped_of_time_true,tag=be_stopped_of_time] add time_stop_over")
    }

    //世界：遍历
    function worldEntityEach() {
        worldStopEffect()
        
        for (const entity of player.dimension.getEntities
            ({
                excludeFamilies: [
                    'inanimate'
                ],
                location: player.location,
                minDistance: 0,
                maxDistance: 128 
            })
        )
        {
            try {
                function start(entity) {
                
                    if (!entity.hasTag(`id${entity.id}`)) {
                        entity.addTag(`id${entity.id}`)
                    }
                    
                    entityTimeStopEffect(entity)
                    entityTimeStop(entity)
                    
                    standSummon(entity)
                    
                    gravity(entity)
                    car(entity)
                    footprints(entity)
                    bcs(entity)
                    paper(entity)
                    standPlayer(entity)
                    
                    if (entity.typeId == "stand:jj") {
                        jj(entity)
                    }
                    if (entity.typeId == "stand:jojo3") {
                        jojo3(entity)
                    }
                    if (entity.typeId == "stand:roller") {
                        roller(entity)
                    }
                    if (entity.typeId == "stand:dio1") {
                        dio1(entity)
                    }
                    if (entity.typeId == "stand:dio3") {
                        dio3(entity)
                    }
                    if (entity.typeId == "stand:dio3h") {
                        dio3(entity)
                    }
                    target(entity)
                }
                start(entity)
            } catch (error) {}
        }
    }
    
    //世界遍历，启动！
    worldEntityEach()
}